CCC   #################################################################
CCC   SUBROUTINE PROGRAM: cleantfin
CCC   clean t<tfin SPH particles
CCC   although the subroutine is built in a fashion that it suits any value of oflg
CCC   it does not work with oflg=2 case in rung() because that is in the middle of RK method
CCC   when the positions of the particles are not final
CCC   for some reasons not clear to me, it breaks when one uses it there
CCC   #################################################################
CCC   last updated 03192009
CCC   an oflg concerned bug is fixed
CCC   tfin is changed to zero in order not to affect the original code
CCC
CCC   last updated 03182009
CCC   modified the part concerning idpq arrays
CCC
CCC   last updated 03162009
CCC   built based on solvediff
CCC   #################################################################
      SUBROUTINE cleantfin(tau,ncall)

      IMPLICIT NONE 
      include 'spherio.inc'
      include 'spherio.eos.inc'
      include 'spherio.debug.inc'
      include 'spherio.quifz.inc'
      include 'spherio.rfactor.inc'
      include 'spherio.ce.inc'
      include 'spherio.temps.inc'
      include 'spherio.sphsplit.inc'
      include 'epos.incsf'
      INTEGER na,nn,mm,kk
      INTEGER indx(NPL) 
      DOUBLE PRECISION tau
      DOUBLE PRECISION arr(NPL)
      INTEGER booloss,nacut,natot
      integer ncall

      do nn=1,Nsp(oflg)
         eos(2)=ss(oflg,nn)
         eos(3)=bd(oflg,nn)
         call eosph(eos,2)
          if (eos(5).ge.0.d0) then
            continue
            else
          if (iauxi.ge.8) then
          open(11,file=fnnan(1:nfnnan),access='append')
          write(11,*)'eos(5) problem/nancatchup in cleantfin'
          write(11,*)'current particle index,tau=',nn,tau
          write(11,*)'oflg,ncall=',oflg,ncall
          write(11,'(a,4d20.10)') 'eos(1-4)',eos(1),eos(2),eos(3),eos(4)
          write(11,'(a,3d20.10)') 'eos(5-7)',eos(5),eos(6),eos(7)
          write(11,'(a,6d20.10)') 'xx,yy,et,ph,al,bt=',
     &      xx(oflg,nn),yy(oflg,nn),et(oflg,nn),
     &      ph(oflg,nn),al(oflg,nn),bt(oflg,nn)
          write(11,'(a,4d20.10)') 'ss,sn,bd,br=',
     &      ss(oflg,nn),sn(oflg,nn),bd(oflg,nn),br(oflg,nn)
          close(11)
          stop 'eos(5) NaN or negative error in cleantfin!'
          endif
          eos(5)=-1.d0
          endif
          arr(nn)=eos(5)
      enddo

      call indexx(Nsp(oflg),NPL,arr,indx)


      na=0
      do nn=Nsp(oflg),1,-1
         na=na+1
         mm=indx(nn)
cxx         idp(-1,na)=mm  
cxx         if(mm.le.Nsp(-1)) idp(-1,na)=mm
cxx         if(mm.gt.Nsp(-1)) idp(-1,na)=ndpr(mm)
cxx         if(ntsp.ge.2) idp(-2,na)= idp(0,idp(-1,na))
cxx         nb= idp(-1,na)
cxx         if(ntsp.ge.2) idq(-2,nb)= idp(0,idp(-1,na))

CCC   #################################################################
!!!   idq,idq:complicated!!! double check needed!!!
!!!   note: we don't consider idp(0,), since temporary thing should help itself
!!!         as it is the case in the code
!!!         we don't consider idq, since it is not necessary
         idp_aux(-1,na) = idp(-1,mm)
         idp_aux(-2,na) = idp(-2,mm)
CCC   Emissao Continua e Quimico fo
         iflgce_aux(na) = iflgce(mm)
         iflgxn_aux(na) = iflgxn(mm)
         mbxn_aux(na)   = mbxn(mm)
         msxn_aux(na)   = msxn(mm)
         tempxn_aux(na) = tempxn(mm)
         ssxn_aux(na)   = ssxn(mm)
         bbxn_aux(na)   = bbxn(mm)
         do kk=0,3
            uxn_aux(kk,na) = uxn(kk,mm)
         enddo
         iflgfp_aux(na) = iflgfp(mm)
CCC   #################################################################
         xx(0,na)= xx(oflg,mm)
         yy(0,na)= yy(oflg,mm)
         et(0,na)= et(oflg,mm)
         al(0,na)= al(oflg,mm)
         bt(0,na)= bt(oflg,mm)
         ph(0,na)= ph(oflg,mm)
CCC   #################################################################
         sn(0,na)= sn(oflg,mm)
         br(0,na)= br(oflg,mm)
         sr(0,na)= sr(oflg,mm)
         qr(0,na)= qr(oflg,mm)
CCC   #################################################################
         ss(0,na)= ss(oflg,mm)
         bd(0,na)= bd(oflg,mm)
         sd(0,na)= sd(oflg,mm)
         qd(0,na)= qd(oflg,mm)
CCC   #################################################################
      enddo


      do na=1,Nsp(oflg)
CCC   #################################################################
!!!   idq,idq:complicated!!! double check needed!!!
         idp(-1,na) = idp_aux(-1,na)
         idp(-2,na) = idp_aux(-2,na)
CCC   Emissao Continua e Quimico fo
         iflgce(na) = iflgce_aux(na)
         iflgxn(na) = iflgxn_aux(na)
         mbxn(na)   = mbxn_aux(na)
         msxn(na)   = msxn_aux(na)
         tempxn(na) = tempxn_aux(na)
         ssxn(na)   = ssxn_aux(na)
         bbxn(na)   = bbxn_aux(na)
         do kk=0,3
           uxn(kk,na) = uxn_aux(kk,na)
         enddo
         iflgfp(na) = iflgfp_aux(na)
CCC   #################################################################
         xx(oflg,na)= xx(0,na)
         yy(oflg,na)= yy(0,na)
         et(oflg,na)= et(0,na)
         al(oflg,na)= al(0,na)
         bt(oflg,na)= bt(0,na)
         ph(oflg,na)= ph(0,na)
CCC   #################################################################
         sn(oflg,na)= sn(0,na)
         br(oflg,na)= br(0,na)
         sr(oflg,na)= sr(0,na)
         qr(oflg,na)= qr(0,na)
CCC   #################################################################
         ss(oflg,na)= ss(0,na)
         bd(oflg,na)= bd(0,na)
         sd(oflg,na)= sd(0,na)
         qd(oflg,na)= qd(0,na)
CCC   #################################################################
         end do
         natot=Nsp(oflg)
         booloss=0
         nacut=Nsp(oflg)
CCC   #################################################################
         do na=1,Nsp(oflg)
         eos(2)= ss(oflg,na)
         eos(3)= bd(oflg,na) 
         call eosph(eos,2)
CCC   #################################################################
CCC   eliminating low temperature particles
cxx         if (eos(5).lt.Tfin) then
         if (eos(5).gt.0.d0) then !!the new structure is different
           continue
         elseif (booloss.eq.0) then
           nacut=na-1					!!This particle is also dropped
           booloss=1
         endif
CCC   #################################################################
               if ((iflgce(na).ne.2).and.(iflgce(na).ne.0)) then
                 if (iauxi.ge.6) then
                 open(22,file=fnfce(1:nfnfce),access='append')
                 WRITE(22,*)'fatal iflgce error in solvediff!'
                 WRITE(22,*)'iflgce,na=',iflgce(na),na
                 CLOSE(22)
               endif
                 stop 'fatal ifgce error in cleantfin!'
               endif
CCC   #################################################################
      end do
      Nsp(oflg)=nacut
CCC   #################################################################
CCC   debugging output to iflgce
      if ((iauxi.ge.6).and.(booloss.eq.1)) then
            OPEN(22,file=fnfce(1:nfnfce),access='append')
            WRITE(22,*)' '
            WRITE(22,*)'Cleantfin zero temperature cutoff detected!'
            WRITE(22,'(a,d20.10,2i3)')'Tfin,oflg,ncall=',Tfin,oflg,ncall
            WRITE(22,'(a,i10,a,i10)')'start from',nacut+1,'  of',natot
            WRITE(22,*)'tau=',tau
              eos(2)= ss(oflg,nacut+1)
              eos(3)= bd(oflg,nacut+1)
              call eosph(eos,2)
            WRITE(22,'(a,7d30.20)')'eos(1-7)=',eos(1),eos(2),eos(3),
     &                 eos(4),eos(5),eos(6),eos(7)
            WRITE(22,'(a,6d20.10)') 'xx,yy,et,ph,al,bt=',
     &               xx(oflg,nacut+1),yy(oflg,nacut+1),et(oflg,nacut+1),
     &               ph(oflg,nacut+1),al(oflg,nacut+1),bt(oflg,nacut+1)
            WRITE(22,'(a,4d20.10)') 'ss,sn,bd,br=',
     &               ss(oflg,nacut+1),sn(oflg,nacut+1),
     &               bd(oflg,nacut+1),br(oflg,nacut+1)

            CLOSE(22)
      end if

c     a mklt call should be implemented afterward in the code which evokes this subroutine
c      CALL mklt()
      RETURN 
      END

CCC   #################################################################



CCC   #################################################################
CCC   checkce()
CCC   #################################################################
CCC   last updated 10092007
CCC   add check output
CCC
CCC   last updated 08232007
CCC   adopt ihdmode
CCC
CCC   last updated 07082007
CCC   adopt pp0
CCC
CCC   last updated 07052007
CCC   added ppce initialization
CCC
CCC   last updated 07042007
CCC   adopt ppce
CCC
CCC   last updated 06272007
CCC   adopt icemode instead of kappa
CCC
CCC   last updated 10152006
CCC   check kappa at first to improve the efficiency
CCC
CCC   last updated 05042006
CCC   include 'spherio.eos.inc' to include strangeness
CCC   #################################################################
      subroutine checkce(tau)

      implicit none
      include 'spherio.inc'
	include 'spherio.seedspo.inc'
      include 'spherio.eos.inc'
      include 'spherio.ce.inc'
	include 'spherio.temps.inc'
	include 'spherio.quifz.inc'
      double precision pp,pp0,ran3,tau,random
      double precision xxss,xxnn
      integer na,phsflg
      double precision lambda
      common/cemixphs/lambda  !! fracao na fase de plasma


	if (icemode.eq.0) return

      oflg=1
      select case (ihdmode)
      case (0)
	    if (ihdfull.ne.1) stop'ihdfull stroke 1 in checkce!'
          call mklt()
      case (1)
	    if (ihdfull.ne.0) stop'ihdfull stroke 2 in checkce!'
          ihdfull=1
          call mklt()
      case default
          stop'ihdmode fatal error in checkce!'
      end select


      do 100 na=1,Nsp(1)
         eos(2)     = ss(1,na)
         eos(3)     = bd(1,na)
	   ppce(na)   = 0.d0
         call eosph(eos,2)
         if(iflgce(na).eq.0.and.eos(5).gt.Tf) then
            xxss       = ss(1,na)
            xxnn       = bd(1,na)
            call phsjdg2(xxss,xxnn,phsflg)
            if(phsflg.eq.2) goto 100
            if(phsflg.eq.1) then 
                if( ran3(idum).lt.lambda ) goto 100
            end if
            call probce(tau,na,pp,pp0)
            random=ran3(idum)
            if(random.lt.pp) then
              iflgce(na)=1
	        ppce(na)=pp0
	      end if
         endif
 100  continue   

      select case (ihdmode)
      case (0)
          continue
      case (1)
          ihdfull=0
          call mklt()
      case default
          stop 'ihdmode fatal error in checkce!'
      end select


      return
      end





cxx   ################################################################      
      SUBROUTINE checknu(nf,nr,rf,nuu) 
      IMPLICIT NONE 
      include 'spherio.inc'
      DOUBLE PRECISION nr(0:3),rf(1:3)
      DOUBLE PRECISION nuu,u0,u1,u2,u3
      INTEGER nf 
      
      u0=+cosh(rf(1))*cosh(rf(3)-xfrs(3,nf))
      u1=+sinh(rf(1))*cos(rf(2))
      u2=+sinh(rf(1))*sin(rf(2)) 
      u3=+cosh(rf(1))*sinh(rf(3)-xfrs(3,nf))
      u3= u3/xfrs(0,nf)         
      nuu=  u0*nr(0)+ u1*nr(1)+ u2*nr(2)+ u3*nr(3)
      return
      stop 234
      end 
cxx   ################################################################





CCC   #################################################################
CCC   checkxn()
CCC   #################################################################
CCC   last udpated 01022009
CCC   modified the treat to fit IC
CCC
CCC   last udpated 07022008
CCC   modified to adopt 3-point interpolation
CCC
CCC   last updated 07022008
CCC   adopt ch mode 6
CCC
CCC   last updated 08012007
CCC   adopt ch mod 5
CCC
CCC   last updated 05252007
CCC   modified to adopt new quimode option
CCC
CCC   last updated 05042007
CCC   incorporate the chemical freeze-out temperature
CCC
CCC   last updated 10262006
CCC   fixed a initime bug
CCC
CCC   last updated 10172006
CCC   modified according to Yogiro's suggestion
CCC
CCC   last updated 10152006
CCC   inherited from and modified based on checkce()
CCC   #################################################################
      subroutine checkxn(tau,ntsp)

      implicit none
      include 'spherio.inc'
	include 'spherio.quifz.inc'
	include 'spherio.temps.inc'
	include 'spherio.eos.inc'

      double precision tau
      double precision xxss,xxnn
      integer na,phsflg,ntsp

	DOUBLE PRECISION Tm(-2:1)
	DOUBLE PRECISION ta(-2:1)
      integer igoflg

	if (iquifz.eq.0) return
c	if (ntsp.lt.2) return

      oflg=1
      call mklt()

      do na=1,Nsp(1)
         if(iflgxn(na).ne.0) cycle
	   if(iflgce(na).ne.0) cycle
	   igoflg=0
	   select case (iquimode)
	        case (1)
	            if (ntsp.lt.2) return
                  xxss = ss(1,na)
                  xxnn = bd(1,na)
                  call phsjdg2(xxss,xxnn,phsflg)
                  if(phsflg.eq.2.or.phsflg.eq.1) cycle
                  if(phsflg.ne.0) stop'phsflg err em checkxn'
                     igoflg=1
	        case (2)
                  stop 'quimode unsupported!'
	        case (3,4,5,6)
                  if (ntsp.ge.2) then
                      ta(-2)= tau-dtau-dtau
                      ta(-1)= tau-dtau
                      ta( 1)= tau
				    call tmevol(na,ta,Tm)
				    if(Tm(-2).gt.Tch.and.Tm(-1).
     &                   le.Tch.and.Tm(1).le.Tch) then
                          igoflg=1
				    endif
                  elseif (ntsp.eq.0) then
                      eos(2)= ss(1,na)
                      eos(3)= bd(1,na)
                      call eosph(eos,2)
                      if (eos(5).le.Tch) igoflg=1
	            else
                      continue
	            endif
	        case default
	            stop 'quimode fatal error!'
          end select
	    if (igoflg.eq.1) then
			call recordxn(tau,ntsp,na)
			iflgxn(na)=1
	    endif
      enddo

      return
      end



CCC   #################################################################
CCC   SUBROUTINE PROGRAM: flintp
CCC   locate freeze-out surface
CCC   #################################################################
CCC   last updated 04282009
CCC   fixed a bug concerning interpolation of ph
CCC   which was pointed out by Rone
CCC
CCC   last updated 07022008
CCC   adopt fz temperature as variable
CCC   #################################################################
      SUBROUTINE flintp(Tm,na,ta,txyef,rapf,ssf,nbf,ntype,tt0)      
      IMPLICIT NONE       
      include 'spherio.inc'
      INTEGER na,nb,nc,nn,ii,jj,ndim,ntype  
      DOUBLE PRECISION Tm(-2:1),ta(-2:1),txyef(0:3),rapf(1:3),tt0 
	DOUBLE PRECISION utf(1:2)
      DOUBLE PRECISION Tmr(1:3),ttr(1:3),xxr(1:3),yyr(1:3),etr(1:3)
	DOUBLE PRECISION u1r(1:3),u2r(1:3)
      DOUBLE PRECISION alr(1:3),btr(1:3)
cxx     DOUBLE PRECISION phr(1:3)
      DOUBLE PRECISION ssr(1:3),brr(1:3),ssf,nbf 
      DOUBLE PRECISION error       
      double precision phif

      nb=idp(-1,na) 
      nc=idp(-2,na)      
      if(ntype.le.2) then 
         ndim=2
      else
         ndim=3
      end if
      
      do ii=1,ndim        
         if(ntype.eq.1) then      
            if(ii.eq.1) jj=-2
            if(ii.eq.2) jj=-1
         end if
         if(ntype.eq.2) then      
            if(ii.eq.1) jj=-1
            if(ii.eq.2) jj= 1
         end if      
         if(ntype.eq.3) then      
            if(ii.eq.1) jj=-2
            if(ii.eq.2) jj=-1
            if(ii.eq.3) jj= 1
         end if      
         
         if(jj.eq.-2) nn=nc
         if(jj.eq.-1) nn=nb
         if(jj.eq. 1) nn=na

         Tmr(ii)=Tm(jj)
         ttr(ii)=ta(jj)
         xxr(ii)=xx(jj,nn) 
         yyr(ii)=yy(jj,nn)
         etr(ii)=et(jj,nn)
         alr(ii)=al(jj,nn)
         btr(ii)=bt(jj,nn)
c         phr(ii)=ph(jj,nn)        !this is not correct when phi~0(or 2*pi), so one gets pretty much any number
                                   !pointed out by Rone
         u1r(ii)=1.d0*dcos(ph(jj,nn)) !this is just a symbol
         u2r(ii)=1.d0*dsin(ph(jj,nn))
         ssr(ii)=ss(jj,nn)
         brr(ii)=bd(jj,nn)
      end do
ccc   //////////////////////////////////////////////////      
      call polint(Tmr,ttr,3,ndim,tt0,txyef(0),error)
      call polint(Tmr,xxr,3,ndim,tt0,txyef(1),error)
      call polint(Tmr,yyr,3,ndim,tt0,txyef(2),error)
      call polint(Tmr,etr,3,ndim,tt0,txyef(3),error)
      call polint(Tmr,btr,3,ndim,tt0,rapf(1),error)
c      call polint(Tmr,phr,3,ndim,tt0,rapf(2),error)
      call polint(Tmr,u1r,3,ndim,tt0,utf(1),error)
      call polint(Tmr,u2r,3,ndim,tt0,utf(2),error)
	rapf(2)= phif(utf(1),utf(2))
      call polint(Tmr,alr,3,ndim,tt0,rapf(3),error)
      call polint(Tmr,ssr,3,ndim,tt0,ssf,error)
      call polint(Tmr,brr,3,ndim,tt0,nbf,error)
ccc   /////////////////////////////////////////////////
      RETURN 
      END
      
CCC ####################################################################


CCC   #################################################################
CCC   SUBROUTINE PROGRAM: listsurf2 
CCC   checking freezeout SPH particles
CCC   #################################################################
CCC   last updated 01032009
CCC   clean up some remarks
CCC
CCC   last updated 09022008
CCC   modified eftot
CCC
CCC   last updated 08192008
CCC   added the energy summation check
CCC
CCC   last updated 07042008
CCC   added more debugging output
CCC
CCC   last updated 07032008
CCC   fix the norm problem pointed out by Rone
CCC   though this modification should NOT affect the numerical results
CCC
CCC   last updated 10092007
CCC   add check output
CCC
CCC   last updated 08312007
CCC   adopt vvxn, vvfrsxn
CCC
CCC   last updated 08232007
CCC   adopt ihdmode
CCC
CCC   last updated 07052007
CCC   fix a bug concerning the definition of ufrsxn
CCC
CCC   last updated 07042007
CCC   nrfz(4,nf), ppfz, ppce are incorporated
CCC
CCC   last updated 05222007
CCC   modified to adopt uxn and ufrsxn
CCC
CCC   last updated 05042007
CCC   modified the check routine concerning chemical freeze-out
CCC   owing to the new scenario of chemical freeze-out has been added
CCC
CCC   last updated 03312007
CCC   add ntsp.ge.2 criterian for thermal freeze-out
CCC
CCC   last updated 01182007
CCC   add iquifz.eq.0 check to ensure the validity
CCC
CCC   last updated 12192006
CCC   modified to incorporate tempxn and tempfrsxn in new chemical fo
CCC
CCC   last updated 12182006
CCC   add more debugging info
CCC
CCC   last updated 10172006
CCC   modified according to Yogiro's suggestion
CCC
CCC   last updated 10162006
CCC   add the evoking of checkxn()
CCC   add mfrsxn, msfrsxn storage
CCC   add chemical fo flag checkup
CCC
CCC   last updated 09282006
CCC   redefine the nef to avoid entropy unexpected lost
CCC
CCC   last updated 09202006
CCC   eosph() is used uniformly
CCC
CCC   last updated 08172006
CCC   added debug info to check divergence
CCC
CCC   last updated 08152006
CCC   added debugging output for total entropy and baryon number
CCC   to the file trdata
CCC
CCC   last updated 06072006
CCC   eosphdbg() is evoked to extract the eos info for frozen 
CCC   SPH particle instead of eosph()
CCC
CCC   last updated 05122006
CCC   msfrs is updated to incorporate strangeness using the output
CCC   of eosph() --> eos(7)
CCC
CCC   last updated 05042006
CCC   include 'spherio.eos.inc' to incorporate the strangeness              
CCC   #################################################################
      SUBROUTINE lssf(ntsp,tau,nf,nef)
      IMPLICIT NONE 
      include 'spherio.inc' 
      include 'spherio.eos.inc'
	include 'spherio.debug.inc'
	include 'spherio.temps.inc'
	include 'spherio.quifz.inc'
	include 'epos.incsf'

      INTEGER ntsp      
      INTEGER na,nb,nc,nf,nef,kk,fflg
      INTEGER ntype

      DOUBLE PRECISION tau,ta(-2:1),txyef(0:3),rapf(1:3)         
      DOUBLE PRECISION Tm(-2:1),ssf,nbf 
      DOUBLE PRECISION nr(0:3)
      DOUBLE PRECISION vx,vy,ve
      DOUBLE PRECISION jacobian,u0,u1,u2,u3,norm 
      DOUBLE PRECISION rf(3),nuu0,nuu1,nuu2
      DOUBLE PRECISION gamma
CCC   #################################################################
CCC   Chemical FO
	call checkxn(tau,ntsp)
	call recordxn_inspector(tau,ntsp)
CCC   #################################################################
CCC   Emissao Continua
      call checkce(tau)
CCC   #################################################################
cxx	nef=0
cxx      if(ntsp.ge.2)then
cxx         oflg= -2
cxx         call mklt()
cxx         oflg= -1
cxx         call mklt()
cxx      endif
cxx      oflg=  1
cxx      call mklt()
      select case (ihdmode)
      case (0)
	    if (ihdfull.ne.1) stop 'ihdfull stroke 1 in lssf!'
          oflg=  1
          call mklt()
      case (1)
	    if (ihdfull.ne.0) stop 'ihdfull stroke 2 in lssf!'
          oflg=  1
          ihdfull=1
          call mklt()
      case default
          stop 'ihdmode fatal error in lssf!'
      end select
CCC   #################################################################
CCC   Emissao Continua
CCC   #################################################################
      do 500 na=1,Nsp(1)
         if(iflgce(na).lt.0.or.iflgce(na).gt.2)then
            open(22,file=fnfce(1:nfnfce),access='append')
            write(22,*)'erro em iflgce = ',iflgce(na)
            close(22)
            stop 'erro of iflgce in lssf'
         endif
         if(iflgce(na).eq.1) then
         iflgce(na)=2 !! dados ja armazenados  
         nf=nf+1
         xfrs(0,nf) = tau
         xfrs(1,nf) = xx(1,na)
         xfrs(2,nf) = yy(1,na)
         xfrs(3,nf) = et(1,na)
         rfrs(1,nf) = bt(1,na)
         rfrs(2,nf) = ph(1,na)
         rfrs(3,nf) = al(1,na)
c fluid 4-velocity u_\mu
         ufrs(0,nf)=+cosh(rfrs(1,nf))*cosh(rfrs(3,nf)-xfrs(3,nf))
         ufrs(1,nf)=-sinh(rfrs(1,nf))* cos(rfrs(2,nf))
         ufrs(2,nf)=-sinh(rfrs(1,nf))* sin(rfrs(2,nf)) 
         ufrs(3,nf)=-cosh(rfrs(1,nf))*sinh(rfrs(3,nf)-xfrs(3,nf))
         ufrs(3,nf)= ufrs(3,nf)      *xfrs(0,nf)
         eos(2)     = ss(1,na)
         eos(3)     = bd(1,na)
         call eosph(eos,2)
         ssfz(nf)   = ss(1,na)
         snfz(nf)   = sn(1,na)
         bnfz(nf)   = br(1,na)
         mfrs(nf)   = eos(6)
         msfrs(nf)  = eos(7)
         tempfz(nf) = eos(5)
         edfz(nf)   = eos(1)
         bbfz(nf)   = eos(3)
         iflgfpfz(nf)=iflgfp(na)
         if ((iflgxn(na).eq.0).or.(iquifz.eq.0)) then
           mfrsxn(nf) = eos(6)
           msfrsxn(nf)= eos(7)
           tempfrsxn(nf)=eos(5)
	     ssfrsxn(nf)=ssfz(nf)
	     bbfrsxn(nf)=bbfz(nf)
	     ufrsxn(0,nf)=+cosh(xfrs(3,nf))*ufrs(0,nf)
     &                  -1.d0/xfrs(0,nf)*sinh(xfrs(3,nf))*ufrs(3,nf)
	     ufrsxn(1,nf)=-ufrs(1,nf)
	     ufrsxn(2,nf)=-ufrs(2,nf)
	     ufrsxn(3,nf)=+sinh(xfrs(3,nf))*ufrs(0,nf)
     &                  -1.d0/xfrs(0,nf)*cosh(xfrs(3,nf))*ufrs(3,nf)
           iflgxn(na)=3
         elseif (iflgxn(na).eq.1) then
           mfrsxn(nf) = mbxn(na)
           msfrsxn(nf)= msxn(na)
           tempfrsxn(nf)=tempxn(na)
	     ssfrsxn(nf)=ssxn(na)
	     bbfrsxn(nf)=bbxn(na)
	     ufrsxn(0,nf)=uxn(0,na)
	     ufrsxn(1,nf)=uxn(1,na)
	     ufrsxn(2,nf)=uxn(2,na)
	     ufrsxn(3,nf)=uxn(3,na)
           iflgxn(na)=2
         else
           stop 'iflgxn err 1 em lssf'
         endif
         if (iauxi.ge.7) then
           if (mfrsxn(nf).eq.zero.or.msfrsxn(nf).eq.zero) then
	      if (eos(6).ne.zero.and.eos(7).ne.zero) then
             open(11,file=fnnan(1:nfnnan),access='append')
             write(11,*)'NaN in lssf place 1!'
	       write(11,'(a,2i6,2d30.20)')'na,nf,mfrsxn(nf),msfrsxn(nf)=',
     &            na,nf,mfrsxn(nf),msfrsxn(nf)
	       write(11,'(a,i6,3d30.20)')'ntsp,tempfrsxn(nf),ufrsxn()=',
     &            ntsp,tempfrsxn(nf),ufrsxn(0,nf),ufrsxn(1,nf)
	       write(11,'(a,d30.20)')'ssfrsxn(nf)=',
     &            ssfrsxn(nf)
	       write(11,'(a,i6,2d30.20)')'iflgxn(na),eos(6),eos(7)=',
     &            iflgxn(na),eos(6),eos(7)
             close(11)
             stop 'quim fo err 1 em lssf'
            endif	 
	     endif
         end if
         call normal_ce(na,nf,nr)
         norm=nr(0)**2-nr(1)**2-nr(2)**2-nr(3)**2/tau**2
CCC   #################################################################
CCC   NaN debugging output
      if (iauxi.ge.3) then
	if ((norm.gt.0.d0).or.(norm.lt.0.d0)) then
	    continue
	else
          open(11,file=fnnan(1:nfnnan),access='append')
	    WRITE(11,*)'  '
		WRITE(11,*)'report from lssf normal_ce has unphysical value'
	    WRITE(11,'(a,4d16.8)')'this weird normal vector is nr0-3',
     &                   nr(0),nr(1),nr(2),nr(3)
	    WRITE(11,'(a,i6)')'freeze out index=',nf
	    WRITE(11,'(a,4d16.8)')'ssfz,snfz,bnfz,tempfz=',
     &                 ssfz(nf),snfz(nf),bnfz(nf),tempfz(nf)
	    CLOSE(11)
	    nr(0)=1.d0
	    nr(1)=0.d0
	    nr(2)=0.d0
	    nr(3)=0.d0
	    norm=1.d0
	endif
	endif
CCC   #################################################################
         norm=dsqrt(abs(norm))
         do kk=0,3
            nr(kk)=nr(kk)/norm
            nrfz(kk,nf)=nr(kk)
         end do
	   nrfz(4,nf)=norm
	   ppfz(nf)=ppce(na)
         vx= tanh(rfrs(1,nf))*cos(rfrs(2,nf))
         vy= tanh(rfrs(1,nf))*sin(rfrs(2,nf))
         ve= tanh(rfrs(3,nf)-xfrs(3,nf))
         vx= vx/cosh(rfrs(3,nf)-xfrs(3,nf))
         vy= vy/cosh(rfrs(3,nf)-xfrs(3,nf))
         ve= ve/xfrs(0,nf)
         jacobian= zero
         jacobian= jacobian+ nr(0)*uni
         jacobian= jacobian+ nr(1)*vx
         jacobian= jacobian+ nr(2)*vy
         jacobian= jacobian+ nr(3)*ve
         jacobian= abs(jacobian)
         do kk=0,3
            sfrs(kk,nf)= snfz(nf)/jacobian
            sfrs(kk,nf)= sfrs(kk,nf)/(ssfz(nf)*ufrs(0,nf))
            sfrs(kk,nf)= sfrs(kk,nf)* nr(kk) 
         end do  
         endif
 500  continue  
      select case (ihdmode)
      case (0)
	    if (ihdfull.ne.1) stop 'ihdfull stroke 3 in lssf!'
          continue
      case (1)
	    if (ihdfull.ne.1) stop 'ihdfull stroke 4 in lssf!'
          oflg=  1
          ihdfull=0
          call mklt()
      case default
          stop 'ihdmode fatal error in lssf!'
      end select
CCC   #################################################################
CCC   Kinematic Freeze-out according to Tf
CCC   #################################################################
      if(ntsp.lt.2) return     !treat FO only for ntsp larger equal 2
CCC   #################################################################
cxx     oflg= -2
cxx     call mklt()
cxx     oflg= -1
cxx     call mklt()
cxx     oflg=  1
cxx     call mklt()
      select case (ihdmode)
      case (0)
	    if (ihdfull.ne.1) stop 'ihdfull stroke 5 in lssf!'
          oflg= -2
          call mklt()
          oflg= -1
          call mklt()
          oflg=  1
          call mklt()
      case (1)
	    if (ihdfull.ne.0) stop 'ihdfull stroke 6 in lssf!'
          ihdfull=1
          oflg= -2
          call mklt()
          oflg= -1
          call mklt()
          oflg=  1
          call mklt()
      case default
          stop 'ihdmode fatal error in lssf!'
      end select
      ta(-2)= tau-dtau-dtau
      ta(-1)= tau-dtau
      ta( 1)= tau
CCC   #################################################################
      DO 880 na=1,Nsp(1)
         if(iflgce(na).lt.0.or.iflgce(na).gt.2)then
            open(22,file=fnfce(1:nfnfce),access='append')
            write(22,*)'erro em iflgce = ',iflgce(na)
            close(22)
            stop 'erro em iflgce!'
         endif
         if(iflgce(na).eq.1)then
            open(22,file=fnfce(1:nfnfce),access='append')
            write(22,*)'iflgce = ',iflgce(na)
            write(22,*)'Isso nao pode acontecer aqui!!!'
            close(22)
            stop 'Isso nao pode acontecer aqui!'
         endif
         if(iflgce(na).eq.2) cycle       !already frozen-out skip
         nb=idp(-1,na) 
         nc=idp(-2,na)
         call tmevol(na,ta,Tm)
cxx         if(Tm(-1).gt.Tf.or.Tm(1).gt.Tf) nef=nef+1
CCC   #################################################################
CCC   Freeze-out conditions
         fflg=0
         if(ntsp.ge.2.and.Tm(-2).gt.Tf.and.Tm(-1).le.Tf.and.Tm(1).le.Tf)
     &      fflg=1
         if(fflg.ne.1) cycle     !not qualified for fz
         iflgce(na)=2 !! dados ja armazenados
         nf=nf+1
         if(nf.gt.NPLF) goto 905 !! should be smaller than NPLF...         
         if(Tf.gt.Tm(-1)) ntype=1
         if(Tf.le.Tm(-1)) ntype=2
         call flintp(Tm,na,ta,txyef,rapf,ssf,nbf,ntype,Tf)
         do kk=0,3
            xfrs(kk,nf) =txyef(kk)
         end do
         do kk=1,3
            rfrs(kk,nf)=rapf(kk)           
         end do 
CCC   fluid 4_velocoty u_{\mu} (not u^{mu}!! ) 
         ufrs(0,nf)=+cosh(rfrs(1,nf))*cosh(rfrs(3,nf)-xfrs(3,nf))
         ufrs(1,nf)=-sinh(rfrs(1,nf))* cos(rfrs(2,nf))
         ufrs(2,nf)=-sinh(rfrs(1,nf))* sin(rfrs(2,nf)) 
         ufrs(3,nf)=-cosh(rfrs(1,nf))*sinh(rfrs(3,nf)-xfrs(3,nf))
         ufrs(3,nf)= ufrs(3,nf)      *xfrs(0,nf)
         eos(2)= ssf
         eos(3)= nbf
         call eosph(eos,2)
         ssfz(nf)= ssf
         snfz(nf)= sn(1,na) 
         bnfz(nf)= br(1,na)
         mfrs(nf)= eos(6) 
         msfrs(nf)= eos(7)
         tempfz(nf)= eos(5)
         edfz(nf)= eos(1)
         bbfz(nf)= nbf
         iflgfpfz(nf)=iflgfp(na)
         if (iflgxn(na).eq.0) then
           mfrsxn(nf) = eos(6)
           msfrsxn(nf)= eos(7)
           tempfrsxn(nf)=eos(5)
	     ssfrsxn(nf)=ssfz(nf)
           bbfrsxn(nf)=bbfz(nf)
	     ufrsxn(0,nf)=+cosh(xfrs(3,nf))*ufrs(0,nf)
     &                  -1.d0/xfrs(0,nf)*sinh(xfrs(3,nf))*ufrs(3,nf)
	     ufrsxn(1,nf)=-ufrs(1,nf)
	     ufrsxn(2,nf)=-ufrs(2,nf)
	     ufrsxn(3,nf)=+sinh(xfrs(3,nf))*ufrs(0,nf)
     &                  -1.d0/xfrs(0,nf)*cosh(xfrs(3,nf))*ufrs(3,nf)
           iflgxn(na)=3
         elseif (iflgxn(na).eq.1) then
           mfrsxn(nf) = mbxn(na)
           msfrsxn(nf)= msxn(na)
           tempfrsxn(nf)=tempxn(na)
	     ssfrsxn(nf)=ssxn(na)
	     bbfrsxn(nf)=bbxn(na)
	     ufrsxn(0,nf)=uxn(0,na)
	     ufrsxn(1,nf)=uxn(1,na)
	     ufrsxn(2,nf)=uxn(2,na)
	     ufrsxn(3,nf)=uxn(3,na)
           iflgxn(na)=2
         else
           stop 'iflgxn err 3 em lssf'
         endif
         if (iauxi.ge.7) then
           if (mfrsxn(nf).eq.zero.or.msfrsxn(nf).eq.zero) then
	      if (eos(6).ne.zero.and.eos(7).ne.zero) then
             open(11,file=fnnan(1:nfnnan),access='append')
             write(11,*)'NaN in lssf place 2!'
	       write(11,'(a,2i6,2d30.20)')'na,nf,mfrsxn(nf),msfrsxn(nf)=',
     &            na,nf,mfrsxn(nf),msfrsxn(nf)
	       write(11,'(a,i6,3d30.20)')'ntsp,tempfrsxn(nf),ufrsxn()=',
     &            ntsp,tempfrsxn(nf),ufrsxn(0,nf),ufrsxn(1,nf)
	       write(11,'(a,d30.20)')'ssfrsxn(nf)=',
     &            ssfrsxn(nf)
	       write(11,'(a,i6,2d30.20)')'iflgxn(na),eos(6),eos(7)=',
     &            iflgxn(na),eos(6),eos(7)
             close(11)
             stop 'quim fo err 2 em lssf'
            endif	 
	     endif
         end if
CCC   to calculate the normal verctor and normalize it
         CALL normal(ta,na,nf,nr)
         norm= nr(0)**2-nr(1)**2-nr(2)**2-nr(3)**2/tau**2
CCC   #################################################################
CCC   NaN debugging output
      if (iauxi.ge.3) then
	if ((norm.gt.0.d0).or.(norm.lt.0.d0)) then
	    continue
	else
          open(11,file=fnnan(1:nfnnan),access='append')
	    WRITE(11,*)'  '
		WRITE(11,*)'report from lssf normal has unphysical value'
	    WRITE(11,'(a,4d16.8)')'this weird normal vector is nr0-3',
     &                   nr(0),nr(1),nr(2),nr(3)
	    WRITE(11,'(a,i6)')'freeze out index=',nf
	    WRITE(11,'(a,4d16.8)')'ssfz,snfz,bnfz,tempfz=',
     &                 ssfz(nf),snfz(nf),bnfz(nf),tempfz(nf)
	    CLOSE(11)
	    nr(0)=1.d0
	    nr(1)=0.d0
	    nr(2)=0.d0
	    nr(3)=0.d0
	    norm=1.d0
	endif
	endif
CCC   #################################################################
         norm= dsqrt(abs(norm))		!!norm<0 means space like...
         do kk=0,3
            nr(kk)=nr(kk)/norm
            nrfz(kk,nf) =nr(kk)
         enddo
	   nrfz(4,nf)=norm
         ppfz(nf)=0.99d0
         rf(1)= rfrs(1,nf)
         rf(2)= rfrs(2,nf)
         rf(3)= rfrs(3,nf)
         call checknu(nf,nr,rf,nuu0)
         if(nuu0.gt.zero) goto 600
         rf(1)= bt(-2,nc)
         rf(2)= ph(-2,nc)
         rf(3)= al(-2,nc)
         call checknu(nf,nr,rf,nuu1)
         rf(1)= bt(-1,nb)
         rf(2)= ph(-1,nb)
         rf(3)= al(-1,nb)
         call checknu(nf,nr,rf,nuu2)
         nuu0= max(nuu1,nuu2)
         if(nuu0.eq.nuu1) then
            rfrs(1,nf)= bt(-2,nc)
            rfrs(2,nf)= ph(-2,nc)
            rfrs(3,nf)= al(-2,nc)
         else if(nuu0.eq.nuu2) then
            rfrs(1,nf)= bt(-1,nb)
            rfrs(2,nf)= ph(-1,nb)
            rfrs(3,nf)= al(-1,nb)
         end if
CCC   #################################################################
 600     continue
CCC   #################################################################
         u0=+cosh(rf(1))*cosh(rf(3)-xfrs(3,nf))
         u1=+sinh(rf(1))*cos(rf(2))
         u2=+sinh(rf(1))*sin(rf(2)) 
         u3=+cosh(rf(1))*sinh(rf(3)-xfrs(3,nf))
         u3= u3/xfrs(0,nf)
CCC   #################################################################
CCC   thermodynamical quantities at freeze-out surface
         vx= tanh(rfrs(1,nf))*cos(rfrs(2,nf))
         vy= tanh(rfrs(1,nf))*sin(rfrs(2,nf))
         ve= tanh(rfrs(3,nf)-xfrs(3,nf))
         vx= vx/cosh(rfrs(3,nf)-xfrs(3,nf))
         vy= vy/cosh(rfrs(3,nf)-xfrs(3,nf))
         ve= ve/xfrs(0,nf)
CCC   #################################################################
         jacobian= zero
         jacobian= jacobian+ nr(0)*uni
         jacobian= jacobian+ nr(1)*vx
         jacobian= jacobian+ nr(2)*vy
         jacobian= jacobian+ nr(3)*ve
         jacobian= abs(jacobian) 
CCC   #################################################################
         do kk=0,3
            sfrs(kk,nf)= snfz(nf)/jacobian
            sfrs(kk,nf)= sfrs(kk,nf)/(ssfz(nf)*ufrs(0,nf))
            sfrs(kk,nf)= sfrs(kk,nf)* nr(kk) 
         end do
c$$$         if(nr(0).lt.zero) then
c$$$            do kk=0,3 
c$$$               sfrs(kk,nf)= -sfrs(kk,nf)
c$$$            end do
c$$$         end if
CCC   #################################################################
 880  CONTINUE
      select case (ihdmode)
      case (0)
	    if (ihdfull.ne.1) stop 'ihdfull stroke 7 in lssf!'
          continue
      case (1)
	    if (ihdfull.ne.1) stop 'ihdfull stroke 8 in lssf!'
          ihdfull=0
          oflg= -2
          call mklt()
          oflg= -1
          call mklt()
          oflg=  1
          call mklt()
      case default
          stop 'ihdmode fatal error in lssf!'
      end select
CCC   #################################################################
CCC   freeze out end flag and checkpoints
	nef=0
      DO na=1,Nsp(1)
         if((iflgce(na).ne.0).and.(iflgce(na).ne.2)) then
            open(22,file=fnfce(1:nfnfce),access='append')
            write(22,*)'erro em iflgce for nef, iflgce = ',iflgce(na)
            close(22)
            stop 'erro em iflgce for nef!'
         elseif(iflgce(na).eq.0) then
            nef=nef+1
         endif
      END DO
CCC   #################################################################
CCC   hydro statistical info sum up
      sftot=zero
      bftot=zero
	eftot=zero
	do na=1,nf
	   sftot=sftot+snfz(na)
	   bftot=bftot+bnfz(na)
         eos(2)=   ssfz(na)
         eos(3)=   bbfz(na)
         call eosph(eos,2)
         gamma= cosh(rfrs(1,na)) *cosh(rfrs(3,na)-xfrs(3,na))
	   eftot=eftot+snfz(na)/(ssfz(na)*gamma)
     &      *((eos(1)+eos(4))*gamma**2-eos(4))    !ez is missing here
	enddo
      if (iauxi.ge.6) then
          OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
            WRITE(11,54) ' tau=',tau,',  Nsp=',Nsp(1),',  Nrs=',nef
            WRITE(11,'(a,i5,a,i5)') ' Nfr0=',Nfr0,'  Nfr=',nf
            WRITE(11,*) ('-',kk=1,63)
          CLOSE(11)
 54         FORMAT(a,f6.3,a,i5,a,i5)
          OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
            WRITE(11,'(a,d30.20)')' total fo entropy=',sftot
            WRITE(11,'(a,d30.20)')' total fo baryon =',bftot
c            WRITE(11,'(a,d30.20)')' total fo energy =',eftot
            WRITE(11,*) ('-',kk=1,63)
          CLOSE(11)
      elseif(iauxi.ge.1) then
          OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
            WRITE(11,54) ' tau=',tau,',  Nsp=',Nsp(1),',  Nrs=',nef
            WRITE(11,'(a,i5,a,i5)') ' Nfr0=',Nfr0,'  Nfr=',nf
            WRITE(11,*) ('-',kk=1,63)
          CLOSE(11)
      elseif(iauxi.ge.0) then
          OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
            WRITE(11,54) ' tau=',tau,',  Nsp=',Nsp(1),',  Nrs=',nef
          CLOSE(11)
	endif
      RETURN
CCC   #################################################################
CCC   error massages
 905  continue 
      open(11,file=fnnsp(1:nfnnsp),access='append')
      write(11,*) 'nf > NPLF error \(^^:)/'
      close(11)
      stop 'nf > NPLF error '
CCC   #################################################################
      END
CCC   #################################################################

CCC   #################################################################
CCC   SUBROUTINE PROGRAM: listsurf0
CCC   checking freezeout SPH particles at tau0
CCC   in the place of CE scenario
CCC   #################################################################
CCC   last updated 01032009
CCC   inherited from lssf
CCC   #################################################################
      SUBROUTINE lssf0(ntsp,tau,nf,nef)
      IMPLICIT NONE
      include 'spherio.inc' 
      include 'spherio.eos.inc'
	include 'spherio.debug.inc'
	include 'spherio.temps.inc'
	include 'spherio.quifz.inc'
	include 'epos.incsf'
      INTEGER ntsp      
      INTEGER na,nf,nef,kk,fflg
      DOUBLE PRECISION tau
      DOUBLE PRECISION nr(0:3)
      DOUBLE PRECISION norm 
      DOUBLE PRECISION gamma
CCC   #################################################################
      if(ntsp.ne.0)then
      	print*,'ntsp.ne.0 in lssf0'
	    stop'ntsp.ne.0 in lssf0'
	endif
      if(nf.ne.0)then
	    print*,'nfr.ne.0 in lssf0'
	    stop'nfr.ne.0 in lssf0'
	endif
CCC   #################################################################
      DO na=1,Nsp(1)
	   if(iflgce(na).eq.2) cycle
         fflg=0
         eos(2)= ss(1,na)
         eos(3)= bd(1,na)
         call eosph(eos,2)
         if(ntsp.eq.0.and.eos(5).le.Tf) fflg=1
cxx   it wont caught any since it is before the hydro evolution and after the Tfin cut-off
c         if(ntsp.gt.0.and.eos(5).le.Tfin.and.eos(5).ge.Tlim) fflg=1
         if(fflg.ne.1) cycle     !not qualified for fz
         iflgce(na)=2 !! dados ja armazenados
         nf=nf+1
         xfrs(0,nf) = tau
         xfrs(1,nf) = xx(1,na)
         xfrs(2,nf) = yy(1,na)
         xfrs(3,nf) = et(1,na)
         rfrs(1,nf) = bt(1,na)
         rfrs(2,nf) = ph(1,na)
         rfrs(3,nf) = al(1,na)
CCC   fluid 4_velocoty u_{\mu} (not u^{mu}!! )
         ufrs(0,nf)=+cosh(rfrs(1,nf))*cosh(rfrs(3,nf)-xfrs(3,nf))
         ufrs(1,nf)=-sinh(rfrs(1,nf))* cos(rfrs(2,nf))
         ufrs(2,nf)=-sinh(rfrs(1,nf))* sin(rfrs(2,nf)) 
         ufrs(3,nf)=-cosh(rfrs(1,nf))*sinh(rfrs(3,nf)-xfrs(3,nf))
         ufrs(3,nf)= ufrs(3,nf)      *xfrs(0,nf)
         ssfz(nf)= ss(1,na)
         snfz(nf)= sn(1,na) 
         bnfz(nf)= br(1,na)
         mfrs(nf)= eos(6) 
         msfrs(nf)= eos(7)
         tempfz(nf)= eos(5)
         edfz(nf)= eos(1)
         bbfz(nf)= bd(1,na)
         iflgfpfz(nf)=iflgfp(na)
CCC   cfo setting
         mfrsxn(nf) = eos(6)
         msfrsxn(nf)= eos(7)
         tempfrsxn(nf)=eos(5)
         ssfrsxn(nf)=ssfz(nf)
         bbfrsxn(nf)=bbfz(nf)
	   ufrsxn(0,nf)=+cosh(xfrs(3,nf))*ufrs(0,nf)
     &                -1.d0/xfrs(0,nf)*sinh(xfrs(3,nf))*ufrs(3,nf)
	   ufrsxn(1,nf)=-ufrs(1,nf)
	   ufrsxn(2,nf)=-ufrs(2,nf)
	   ufrsxn(3,nf)=+sinh(xfrs(3,nf))*ufrs(0,nf)
     &                -1.d0/xfrs(0,nf)*cosh(xfrs(3,nf))*ufrs(3,nf)
         iflgxn(na)=3         !cfo is actually forced by temperature fz
CCC   normal verctor
	   nr(0)=1.d0
	   nr(1)=0.d0
	   nr(2)=0.d0
	   nr(3)=0.d0
	   norm=1.d0
	   nrfz(0,nf)=nr(0)
	   nrfz(1,nf)=nr(1)
	   nrfz(2,nf)=nr(2)
	   nrfz(3,nf)=nr(3)
         nrfz(4,nf)=norm
         ppfz(nf)=0.99d0
         sfrs(0,nf)=snfz(nf)/ssfz(nf)/ufrs(0,nf)  !this was sic
	   do kk=1,3
          sfrs(kk,nf)=0
         end do
CCC   #################################################################
      ENDDO
CCC   #################################################################
CCC   low temperature Tfin cut off is handled by solvediff follows
CCC   #################################################################
CCC   freeze out end flag and checkpoints
	nef=0
      DO na=1,Nsp(1)
         if((iflgce(na).ne.0).and.(iflgce(na).ne.2)) then
            open(22,file=fnfce(1:nfnfce),access='append')
            write(22,*)'erro em iflgce for nef, iflgce = ',iflgce(na)
            close(22)
            stop 'erro em iflgce for nef!'
         elseif(iflgce(na).eq.0) then
            nef=nef+1
         endif
      END DO
CCC   #################################################################
CCC   hydro statistical info sum up
      Nfr0=nf
      sftot=zero
      bftot=zero
	eftot=zero
	do na=1,nf
	   sftot=sftot+snfz(na)
	   bftot=bftot+bnfz(na)
         eos(2)=   ssfz(na)
         eos(3)=   bbfz(na)
         call eosph(eos,2)
         gamma= cosh(rfrs(1,na)) *cosh(rfrs(3,na)-xfrs(3,na))
	   eftot=eftot+snfz(na)/(ssfz(na)*gamma)
     &      *((eos(1)+eos(4))*gamma**2-eos(4))    !ez is missing here
	enddo
      if (iauxi.ge.6) then
          OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
            WRITE(11,54) ' tau=',tau,',  Nsp=',Nsp(1),',  Nrs=',nef,
     &                '  Nfr=',nf
            WRITE(11,*) ('-',kk=1,63)
            CLOSE(11)
 54         FORMAT(a,f5.2,a,i5,a,i5,a,i5)
          OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
            WRITE(11,'(a,d30.20)')' total IC fo entropy=',sftot
            WRITE(11,'(a,d30.20)')' total IC fo baryon =',bftot
c            WRITE(11,'(a,d30.20)')' total fo energy =',eftot
            WRITE(11,*) ('-',kk=1,63)
            CLOSE(11)
	endif

c          nf=0
c      if (iauxi.ge.3) then
c          OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
c          WRITE(11,'(2a)') ' IC nf particles are dropped',
c     &                    ' in precision mode'
c          WRITE(11,*) ('-',kk=1,63)
c          CLOSE(11)
c      endif

      RETURN
CCC   #################################################################
CCC   error massages
 915  continue 
      open(11,file=fnnsp(1:nfnnsp),access='append')
      write(11,*) 'nf > NPLF error in lssf0 \(^^:)/'
      close(11)
	print*,'nf > NPLF error in lssf0'
      stop 'nf > NPLF error in lssf0'
CCC   #################################################################
      END
CCC   #################################################################

CCC   #################################################################
CCC   SUBROUTINE PROGRAM: normal25.f 
CCC   "normal" calculates normal vector on the freeze-out surface. 
CCC   normal vector 'nr' difined as  
CCC   nr=(-del T/del tau, -del T/del x, -del T/del y, -del T/del eta) 
CCC   #################################################################
CCC   last updated 03122009
CCC   fixed a minor bug concerning debugging output
CCC
CCC   last updated 09262007
CCC   modified debugging output
CCC
CCC   last updated 10052005
CCC   incorporate a new debugging control and ds dnb control
CCC
CCC   last updated 05042006
CCC   include 'spherio.eos.inc' to incorporate the strangeness
CCC
CCC   last updated 05312001
CCC   #################################################################
      SUBROUTINE normal(ta,na,nf,nr)
      IMPLICIT NONE 

      include 'spherio.inc'
      include 'spherio.eos.inc'
	include 'spherio.debug.inc'
	include 'epos.incsf'

      INTEGER na,nf,nb,nc,nn,kflg,kk
      DOUBLE PRECISION ta(-2:1),ssf,nbf,ds,dnb
      DOUBLE PRECISION T1,T2,pdTds,pdTdn
      DOUBLE PRECISION xa(3),xb(3)
      DOUBLE PRECISION QXY,QET,DW2,DW1,W2,W1
      DOUBLE PRECISION vb(3),aldn,btdn,phdn
      DOUBLE PRECISION gamma,gammb
      DOUBLE PRECISION rds(0:3),rdn(0:3),rda(0:3),rdb(0:3),rdg(0:3)
      DOUBLE PRECISION nr(0:3)
      DOUBLE PRECISION smplintf,alf,btf,phf
      DOUBLE PRECISION undn,und(0:3)
      DOUBLE PRECISION sinhfa,coshfa,sinhfb,coshfb,edf
      double precision epsilonnew
CCC   #################################################################
	epsilonnew=1.d-7
      aldn= zero
      btdn= zero
      phdn= zero 
      undn= zero 
      ssf=  zero
      nbf=  zero 
      do kflg=0,3
         rds(kflg)= zero 
         rdn(kflg)= zero 
         rda(kflg)= zero 
         rdb(kflg)= zero 
         und(kflg)= zero 
      end do
      xa(1)= xfrs(1,nf)
      xa(2)= xfrs(2,nf)
      xa(3)= xfrs(3,nf)
      gamma= cosh(rfrs(1,nf)) *cosh(rfrs(3,nf)-xfrs(3,nf))
      
      nb= idp(-1,na)
      oflg=-1
      call prcn(xx(-1,nb),yy(-1,nb),et(-1,nb))

      DO 120 nn=1,np
         nb=kl(nn)
         nc=idq(-2,nb)
         xb(1)= smplintf(ta(-2),ta(-1),xx(-2,nc),xx(-1,nb),xfrs(0,nf))
         xb(2)= smplintf(ta(-2),ta(-1),yy(-2,nc),yy(-1,nb),xfrs(0,nf))
         xb(3)= smplintf(ta(-2),ta(-1),et(-2,nc),et(-1,nb),xfrs(0,nf))

         QXY= dsqrt((xa(1)-xb(1))**2+(xa(2)-xb(2))**2)/hxy
         QET= abs(xa(3)-xb(3))/het         

         alf= smplintf(ta(-2),ta(-1),al(-2,nc),al(-1,nb),xfrs(0,nf))
         btf= smplintf(ta(-2),ta(-1),bt(-2,nc),bt(-1,nb),xfrs(0,nf))
         phf= smplintf(ta(-2),ta(-1),ph(-2,nc),ph(-1,nb),xfrs(0,nf))       

         vb(1)= tanh(btf)*cos(phf)
         vb(2)= tanh(btf)*sin(phf)
         vb(3)= tanh(alf-xb(3))
         vb(1)= vb(1)/cosh(alf-xb(3))
         vb(2)= vb(2)/cosh(alf-xb(3))
         vb(3)= vb(3)/xfrs(0,nf)
         
         CALL krln(QET,W1,1,33)
         CALL krln(QXY,W2,2,12)
         ssf=  ssf  + sn(-1,nb) *W2*W1 
         nbf=  nbf  + br(-1,nb) *W2*W1
         aldn= aldn +    alf    *W2*W1 
         btdn= btdn +    btf    *W2*W1 
         phdn= phdn +    phf    *W2*W1 
         undn= undn +    uni    *W2*W1
         DO 220 kflg=1,3 
            if(kflg.ne.3) then 
               call krld(QXY,DW2,2,12,xa,xb,kflg)
               rds(kflg)= rds(kflg)+ sn(-1,nb)*DW2*W1
               rdn(kflg)= rdn(kflg)+ br(-1,nb)*DW2*W1
               rda(kflg)= rda(kflg)+    alf   *DW2*W1
               rdb(kflg)= rdb(kflg)+    btf   *DW2*W1
               und(kflg)= und(kflg)+    uni   *DW2*W1
               rds(0)= rds(0)+ sn(-1,nb)* DW2*W1*(-1.d0*vb(kflg))
               rdn(0)= rdn(0)+ br(-1,nb)* DW2*W1*(-1.d0*vb(kflg))
               rda(0)= rda(0)+   alf    * DW2*W1*(-1.d0*vb(kflg))
               rdb(0)= rdb(0)+   btf    * DW2*W1*(-1.d0*vb(kflg))
               und(0)= und(0)+   uni    * DW2*W1*(-1.d0*vb(kflg))
            else if(kflg.eq.3) then
               call krld(QET,DW1,1,33,xa,xb,kflg)     
               rds(kflg)= rds(kflg)+ sn(-1,nb)*W2*DW1
               rdn(kflg)= rdn(kflg)+ br(-1,nb)*W2*DW1
               rda(kflg)= rda(kflg)+   alf    *W2*DW1
               rdb(kflg)= rdb(kflg)+   btf    *W2*DW1
               und(kflg)= und(kflg)+   uni    *W2*DW1
               rds(0)= rds(0)+ sn(-1,nb)* W2*DW1*(-1.d0*vb(kflg))
               rdn(0)= rdn(0)+ br(-1,nb)* W2*DW1*(-1.d0*vb(kflg))
               rda(0)= rda(0)+   alf    * W2*DW1*(-1.d0*vb(kflg))
               rdb(0)= rdb(0)+   btf    * W2*DW1*(-1.d0*vb(kflg))
               und(0)= und(0)+   uni    * W2*DW1*(-1.d0*vb(kflg))
            end if
 220     continue
 120  continue 
CCC   #################################################################
      aldn= aldn/undn
      btdn= btdn/undn 
      phdn= phdn/undn
CCC   #################################################################
      gammb= cosh(aldn-xfrs(3,nf))*cosh(btdn)
      
      ssf= ssf/(gammb*xfrs(0,nf))
      nbf= nbf/(gammb*xfrs(0,nf))
CCC   #################################################################
      do kflg=0,3
         rds(kflg)= +rds(kflg)/(gammb*xfrs(0,nf))
         rdn(kflg)= +rdn(kflg)/(gammb*xfrs(0,nf))
      end do
      rds(0)= rds(0)- ssf/xfrs(0,nf)
      rdn(0)= rdn(0)- nbf/xfrs(0,nf)
CCC   #################################################################
      do kflg=0,3
         rda(kflg)= rda(kflg)/undn -aldn/undn*und(kflg)
         rdb(kflg)= rdb(kflg)/undn -btdn/undn*und(kflg)
      end do      
      sinhfa= sinh(rfrs(3,nf)-xfrs(3,nf))
      coshfa= cosh(rfrs(3,nf)-xfrs(3,nf))
      sinhfb= sinh(abs(rfrs(1,nf)))
      coshfb= cosh(rfrs(1,nf))      
      do kflg=0,3
         if(kflg.eq.3) then 
            edf= uni
         else
            edf=zero
         end if
         rdg(kflg)=sinhfa*coshfb*(rda(kflg)-edf) 
     &             +coshfa*sinhfb* rdb(kflg)
      end do
      do kflg=0,3
         rds(kflg)= rds(kflg) -(rdg(kflg)/gammb)*ssf
         rdn(kflg)= rdn(kflg) -(rdg(kflg)/gammb)*nbf
      end do      
      
CCC   #################################################################
      ds= ssf *2.5d-02
	if (ds.lt.epsilonnew) ds=epsilonnew
	dnb= nbf*2.5d-02
      if(dnb.lt.epsilonnew) dnb=epsilonnew
CCC   #################################################################
320   continue
cxx   find @T/@s 
      eos(3)= nbf      
      eos(2)= ssf-ds 
      call eosph(eos,2)
      T1= eos(5) 
      eos(2)= ssf+ds 
      call eosph(eos,2)
      T2= eos(5) 
      pdTds= (T2-T1)/(2.d+00*ds) 
CCC   #################################################################
cxx   find @T/@nb 
      eos(2)= ssf
      eos(3)= nbf-dnb 
      call eosph(eos,2)
      T1= eos(5)
      eos(3)= nbf+dnb 
      call eosph(eos,2)
      T2= eos(5)
      pdTdn= (T2-T1)/(2.d+00*dnb)
CCC   #################################################################
      do kk=0,3
         nr(kk)= -pdTds*rds(kk) -pdTdn*rdn(kk)
      end do

CCC   #################################################################
CCC   NaN debugging output
	if (iauxi.ge.3) then
	if (((nr(0).gt.0).or.(nr(0).lt.0)).or.
     &    ((nr(1).gt.0).or.(nr(1).lt.0)).or. 
     &    ((nr(2).gt.0).or.(nr(2).lt.0)).or.
     &    ((nr(3).gt.0).or.(nr(3).lt.0)))  then
	    continue
      else
          open(11,file=fnnan(1:nfnnan),access='append')
	    WRITE(11,*)'  '
		WRITE(11,*)'report from normal, full null spotted'
	    WRITE(11,'(a,2d16.8)')'pdTds,pdTdn=',
     &                   pdTds,pdTdn
	    WRITE(11,'(a,2d16.8)')'ds,dnb=',
     &                   ds,dnb
	    WRITE(11,'(a,4d16.8)')'pdTdn info: ssf,nbf,T2,T1=',
     &                   ssf,nbf,T2,T1
	    WRITE(11,'(a,4d16.8)')'rds(0-3)=',
     &                   rds(0),rds(1),rds(2),rds(3)
	    WRITE(11,'(a,4d16.8)')'rdn(0-3)=',
     &                   rdn(0),rdn(1),rdn(2),rdn(3)
	    CLOSE(11)
	endif
	endif
CCC   #################################################################

CCC   #################################################################
CCC   NaN debugging control
	if (iauxi.ge.3) then
	if ((pdTdn.eq.0).and.(pdTds.eq.0)) then
		ds=ds*2.d0
		dnb=dnb*2.d0
		goto 320
	endif
	endif
CCC   #################################################################

      return
      stop 234
      end
CCC   #################################################################
      DOUBLE PRECISION FUNCTION smplintf(x1,x2,f1,f2,x)
      IMPLICIT NONE       
      include 'spherio.inc'
      DOUBLE PRECISION x1,x2,f1,f2,x
      if(x.gt.x2 .or. x.lt.x1) stop 'interpolation error'
      smplintf= f1+(f2-f1)/(x2-x1)*(x-x1) 
      RETURN
      END 



CCC   #################################################################
CCC   #################################################################
CCC   #################################################################




CCC   #################################################################
CCC   normal_ce()
CCC   #################################################################
CCC   last updated 08232007
CCC   remove the remark, cancel the modification
CCC   ihdmode adopted by lssf()
CCC
CCC   last updated 08162007
CCC   adopt ihdmode and remarked
CCC
CCC   last updated 05042006
CCC   removed the definition of eos,T1,T2,pdTds,pdTdn
CCC   cuz they have been never used in this subroutine
CCC   #################################################################
      SUBROUTINE normal_ce(na,nf,nr)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      INCLUDE 'spherio.quifz.inc'
      INTEGER na,nf,nb,nn,kflg,kk
      DOUBLE PRECISION ssf,nbf
      DOUBLE PRECISION xa(3),xb(3)
      DOUBLE PRECISION QXY,QET,DW2,DW1,W2,W1
      DOUBLE PRECISION vb(3),aldn,btdn,phdn
      DOUBLE PRECISION gamma,gammb
      DOUBLE PRECISION rds(0:3),rdn(0:3),rda(0:3),rdb(0:3),rdg(0:3) 
      DOUBLE PRECISION nr(0:3)
      DOUBLE PRECISION alf,btf,phf
      DOUBLE PRECISION undn,und(0:3)  
      DOUBLE PRECISION sinhfa,coshfa,sinhfb,coshfb,edf 
      
cxx   ///////////////////////////////////      
      aldn= zero
      btdn= zero
      phdn= zero 
      undn= zero 
      ssf=  zero
      nbf=  zero 

      do kflg=0,3
         rds(kflg)= zero 
         rdn(kflg)= zero 
         rda(kflg)= zero 
         rdb(kflg)= zero 
         und(kflg)= zero 
      end do

      xa(1)= xfrs(1,nf)
      xa(2)= xfrs(2,nf)
      xa(3)= xfrs(3,nf)
      gamma= cosh(rfrs(1,nf)) *cosh(rfrs(3,nf)-xfrs(3,nf))

      call prcn(xa(1),xa(2),xa(3))

cx      nb= idp(-1,na) 
cx      oflg=-1      
cx      call prcn(xx(-1,nb),yy(-1,nb),et(-1,nb)) 
      
      DO 120 nn=1,np
cxxx       do 120 nb=1,Nsp(1)
         nb=kl(nn)          
         xb(1)=xx(1,nb)
         xb(2)=yy(1,nb)
         xb(3)=et(1,nb)
         QXY= dsqrt((xa(1)-xb(1))**2+(xa(2)-xb(2))**2)/hxy
         QET= abs(xa(3)-xb(3))/het 
         CALL krln(QET,W1,1,33)
         CALL krln(QXY,W2,2,12) 
         if(W1.lt.1.d-20.or.W2.lt.1d-20)goto 120       
         alf=al(1,nb)
         btf=bt(1,nb)
         phf=ph(1,nb)     
         vb(1)= tanh(btf)*cos(phf)
         vb(2)= tanh(btf)*sin(phf)
         vb(3)= tanh(alf-xb(3))
         vb(1)= vb(1)/cosh(alf-xb(3))
         vb(2)= vb(2)/cosh(alf-xb(3))
         vb(3)= vb(3)/xfrs(0,nf)
cx         CALL krln(QET,W1,1,33)
cx         CALL krln(QXY,W2,2,12)
         ssf=  ssf  + sn(1,nb)  *W2*W1 
         aldn= aldn +    alf    *W2*W1 
         btdn= btdn +    btf    *W2*W1 
         phdn= phdn +    phf    *W2*W1 
         undn= undn +    uni    *W2*W1

         DO 220 kflg=1,3 
            if(kflg.ne.3) then 
               call krld(QXY,DW2,2,12,xa,xb,kflg)
               rds(kflg)= rds(kflg)+ sn(1,nb) *DW2*W1
               rda(kflg)= rda(kflg)+    alf   *DW2*W1
               rdb(kflg)= rdb(kflg)+    btf   *DW2*W1
               und(kflg)= und(kflg)+    uni   *DW2*W1
               rds(0)= rds(0)+ sn(1,nb) * DW2*W1*(-1.d+00*vb(kflg))
               rda(0)= rda(0)+   alf    * DW2*W1*(-1.d+00*vb(kflg))
               rdb(0)= rdb(0)+   btf    * DW2*W1*(-1.d+00*vb(kflg))
               und(0)= und(0)+   uni    * DW2*W1*(-1.d+00*vb(kflg))
            else if(kflg.eq.3) then
               call krld(QET,DW1,1,33,xa,xb,kflg)     
               rds(kflg)= rds(kflg)+ sn(1,nb) *W2*DW1
               rda(kflg)= rda(kflg)+   alf    *W2*DW1
               rdb(kflg)= rdb(kflg)+   btf    *W2*DW1
               und(kflg)= und(kflg)+   uni    *W2*DW1
               rds(0)= rds(0)+ sn(1,nb) * W2*DW1*(-1.d+00*vb(kflg))
               rda(0)= rda(0)+   alf    * W2*DW1*(-1.d+00*vb(kflg))
               rdb(0)= rdb(0)+   btf    * W2*DW1*(-1.d+00*vb(kflg))
               und(0)= und(0)+   uni    * W2*DW1*(-1.d+00*vb(kflg))
            end if
 220     continue
 120  continue 


cxx   =======================================================
      aldn= aldn/undn
      btdn= btdn/undn 
      phdn= phdn/undn
cxx   ========================================================      
      gammb= cosh(aldn-xfrs(3,nf))*cosh(btdn)
      
      ssf= ssf/(gammb*xfrs(0,nf))
cxx   //////////////////////////////////////////////////////////////
      do kflg=0,3
         rds(kflg)= +rds(kflg)/(gammb*xfrs(0,nf))	
      end do
      rds(0)= rds(0)- ssf/xfrs(0,nf) 
cxx   //////////////////////////////////////////////////////////////   
   
      do kflg=0,3
         rda(kflg)= rda(kflg)/undn -aldn/undn*und(kflg) 
         rdb(kflg)= rdb(kflg)/undn -btdn/undn*und(kflg)
      end do   
   
      sinhfa= sinh(rfrs(3,nf)-xfrs(3,nf))
      coshfa= cosh(rfrs(3,nf)-xfrs(3,nf))
      sinhfb= sinh(abs(rfrs(1,nf)))
      coshfb= cosh(rfrs(1,nf))  
    
      do kflg=0,3
         if(kflg.eq.3) then 
            edf= uni
         else
            edf=zero
         end if
         rdg(kflg)=sinhfa*coshfb*(rda(kflg)-edf) 
     &             +coshfa*sinhfb* rdb(kflg)
      end do

      do kflg=0,3
         rds(kflg)= rds(kflg) -(rdg(kflg)/gammb)*ssf
      end do         

cxx   ######################################################      
      do kk=0,3 
         nr(kk)= -rds(kk)
      end do

      
      return
      end


c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$


CCC   #################################################################
CCC   probce()
CCC   tau [in]
CCC   na  [in]
CCC   pp  [out]
CCC   #################################################################
CCC   last updated 07082007
CCC   add pp0 output
CCC
CCC   last udpated 06212007
CCC   restore to the original version
CCC
CCC   last updated 05082007
CCC   incorporate Otavio's correction
CCC   #################################################################
      subroutine probce(tau,na,pp,pp0)
      implicit none
      include 'spherio.inc'
	include 'spherio.ce.inc'
	include 'epos.incsf'
      double precision tau,pp,pp0
      double precision sdnsty,QXY,QET,W2,W1,dsdt
      double precision xa(3),xb(3),va(3),vb(3),DW(3)
      double precision u0
      integer na
      integer nn,nb

      xa(1)=xx(1,na)
      xa(2)=yy(1,na)
      xa(3)=et(1,na)
      va(1)=tanh(bt(1,na))*cos(ph(1,na))/cosh(al(1,na)-xa(3))
      va(2)=tanh(bt(1,na))*sin(ph(1,na))/cosh(al(1,na)-xa(3))
      va(3)=tanh(al(1,na)-xa(3))/tau

      call prcn(xa(1),xa(2),xa(3))
      if(npflg.eq.0) then
         open(11,file=fnnsp(1:nfnnsp),access='append')
         write(11,*)'np error in probce'
         close(11)
         stop 'np error in probce'
      endif

      sdnsty=0.d0
      dsdt=0.d0

      do nn=1,np
         nb=kl(nn)
         xb(1)=xx(1,nb)
         xb(2)=yy(1,nb)
         xb(3)=et(1,nb)
         vb(1)=tanh(bt(1,nb))*cos(ph(1,nb))/cosh(al(1,nb)-xb(3))
         vb(2)=tanh(bt(1,nb))*sin(ph(1,nb))/cosh(al(1,nb)-xb(3))
         vb(3)=tanh(al(1,nb)-xb(3))/tau 
         QXY=dsqrt( (xa(1)-xb(1))**2+(xa(2)-xb(2))**2 )/hxy
         QET=abs( xa(3)-xb(3) )/het
         call krln(QXY,W2,2,12)
         call krln(QET,W1,1,33)
         call krld(QXY,DW(1),2,12,xa,xb,1)
         call krld(QXY,DW(2),2,12,xa,xb,2)
         call krld(QET,DW(3),1,33,xa,xb,3)
         dsdt=dsdt+sn(1,nb)*(-vb(1)*DW(1)*W1
     &                       -vb(2)*DW(2)*W1
     &                       -vb(3)*DW(3)*W2 )
         dsdt=dsdt+sn(1,nb)*(  va(1)*DW(1)*W1+
     &                         va(2)*DW(2)*W1+
     &                         va(3)*DW(3)*W2 )
         sdnsty=sdnsty+sn(1,nb)*W2*W1
      enddo

      u0=cosh(al(1,na)-et(1,na))*cosh(bt(1,na))
      sdnsty=sdnsty/(tau*u0)
      dsdt=dsdt/tau-u0*sdnsty/tau  !! aproximacao

      if(dsdt.lt.0.d0)then
         pp0=exp(kappa*sdnsty*sdnsty/dsdt)
	   pp=pp0
         pp=2.d0 * pp/(1.d0-pp)*kappa*sdnsty*dtau
         if(pp.ge.1d0)pp=1.d0
      else
	   pp0=0.d0
         pp=pp0
      endif

      return
      end




CCC   #################################################################
CCC   probce_gen()
CCC   #################################################################
CCC   It can only been called from inside of finsb_gen()
CCC   #################################################################
CCC   last updated 10192007
CCC   adopted from probce()
CCC   #################################################################
      subroutine probce_gen(tau,xxp,yyp,etp,u0,vx,vy,ve,pp,pp0)
      implicit none
      include 'spherio.inc'
	include 'spherio.ce.inc'
c      INTEGER nn,na,nb
      DOUBLE PRECISION tau
	DOUBLE PRECISION xxp,yyp,etp
	DOUBLE PRECISION vx,vy,ve
	DOUBLE PRECISION pp,pp0

      double precision sdnsty,QXY,QET,W2,W1,dsdt
      double precision xa(3),xb(3),va(3),vb(3),DW(3)
      double precision u0
      integer nn,nb

	if (npflg.eq.0) then
	    pp=0.d0
	    pp0=1.d0
          return
	end if

      xa(1)=xxp
      xa(2)=yyp
      xa(3)=etp
      va(1)=vx
      va(2)=vy
      va(3)=ve

      sdnsty=0.d0
      dsdt=0.d0

      do nn=1,np
         nb=kl(nn)
         xb(1)=xx(1,nb)
         xb(2)=yy(1,nb)
         xb(3)=et(1,nb)
         vb(1)=tanh(bt(1,nb))*cos(ph(1,nb))/cosh(al(1,nb)-xb(3))
         vb(2)=tanh(bt(1,nb))*sin(ph(1,nb))/cosh(al(1,nb)-xb(3))
         vb(3)=tanh(al(1,nb)-xb(3))/tau 
         QXY=dsqrt( (xa(1)-xb(1))**2+(xa(2)-xb(2))**2 )/hxy
         QET=abs( xa(3)-xb(3) )/het
         call krln(QXY,W2,2,12)
         call krln(QET,W1,1,33)
         call krld(QXY,DW(1),2,12,xa,xb,1)
         call krld(QXY,DW(2),2,12,xa,xb,2)
         call krld(QET,DW(3),1,33,xa,xb,3)
         dsdt=dsdt+sn(1,nb)*( -vb(1)*DW(1)*W1
     &                        -vb(2)*DW(2)*W1
     &                        -vb(3)*DW(3)*W2 )
         dsdt=dsdt+sn(1,nb)*(  va(1)*DW(1)*W1+
     &                         va(2)*DW(2)*W1+
     &                         va(3)*DW(3)*W2 )
         sdnsty=sdnsty+sn(1,nb)*W2*W1
      enddo

      sdnsty=sdnsty/(tau*u0)
      dsdt=dsdt/tau-u0*sdnsty/tau  !! aproximacao

      if(dsdt.lt.0.d0)then
         pp0=exp(kappa*sdnsty*sdnsty/dsdt)
	   pp=pp0
         pp=2.d0 * pp/(1.d0-pp)*kappa*sdnsty*dtau
         if(pp.ge.1d0)pp=1.d0
      else
	   pp0=0.d0
         pp=pp0
      endif

      return
      end




CCC   #################################################################
CCC   recordxn()
CCC   #################################################################
CCC   last updated 01022009
CCC   modified the treat to fit IC
CCC
CCC   last updated 07032008
CCC   added more debugging output
CCC
CCC   last updated 07022008
CCC   implement 3-point interpolation
CCC
CCC   last updated 07022008
CCC   adopt ch mod 6
CCC
CCC   last udpated 10192007
CCC   rename setevg.sphrenda to setevg.chfz
CCC
CCC   last updated 08312007
CCC   adopt vvxn
CCC
CCC   last updated 08062007
CCC   adopt new ch mod 5
CCC
CCC   last updated 05252007
CCC   modified adopt new quimode option
CCC
CCC   last updated 05222007
CCC   modified the definition of uxn to match that of ufrs
CCC
CCC   last updated 05212007
CCC   adopt uxn and modified the struture of subroutine
CCC
CCC   last udpated 05042007
CCC   incorporate chemical freeze-out temperature
CCC
CCC   last updated 04262007
CCC   fixed an unknown minor bug
CCC
CCC   last updated 12192006
CCC   modified to incorporate tempxn in new chemical fo
CCC
CCC   last updated 11122006
CCC   modified the strategy that 0-->0 record the first 0 
CCC   while not the second
CCC   more debugging info is added
CCC
CCC   last updated 10272006
CCC   fixed a bug
CCC
CCC   last updated 10172006
CCC   modified according to Yogiro's suggestion
CCC
CCC   last updated 10152006
CCC   inherited from probce()
CCC   we use 2-step division to determine the phase boundary value
CCC   #################################################################
      subroutine recordxn(tau,ntsp,na)
      implicit none
      include 'spherio.inc'
	include 'spherio.eos.inc'
	include 'spherio.debug.inc'
	include 'spherio.quifz.inc'
	include 'spherio.temps.inc'
	include 'epos.incsf'
      double precision tau
      integer na
	integer nb
	integer phsflg,ntsp
	double precision tm1,tm2,bd1,bd2,ss1,ss2
	double precision mb1,mb2,ms1,ms2
	double precision u01,u11,u21,u31
	double precision u02,u12,u22,u32
	double precision uu0,uu1,uu2,uu3
	double precision tptm,tpbd,tpss,tpmb,tpms
      double precision tpu0,tpu1,tpu2,tpu3

      DOUBLE PRECISION Tm(-2:1),ssf,nbf
      INTEGER ntype
	DOUBLE PRECISION ta(-2:1),txyef(0:3),rapf(1:3)

	if (iquifz.eq.0)then
	print*,'iquifz fatal error in recordxn'
	stop'iquifz fatal error in recordxn'
      endif

	select case (iquimode)
	case (2)
		stop 'quimode value not supported!'
	case (1)
      	ss1=ss(1,na)
	    bd1=bd(1,na)
          uu0=+cosh(al(1,na)-et(1,na)) *cosh(bt(1,na))
          uu1=-cos(ph(1,na))           *sinh(bt(1,na))
          uu2=-sin(ph(1,na))           *sinh(bt(1,na))
          uu3=-sinh(al(1,na)-et(1,na)) *cosh(bt(1,na))*tau
          u01=cosh(et(1,na))*uu0-1.d0/tau*sinh(et(1,na))*uu3
          u11=-uu1
          u21=-uu2
          u31=sinh(et(1,na))*uu0-1.d0/tau*cosh(et(1,na))*uu3
          eos(2)= ss1
          eos(3)= bd1
          call eosph(eos,2)
	    tm1=eos(5)
	    mb1=eos(6)
	    ms1=eos(7)
	    nb=idp(-1,na)
	    ss2=ss(-1,nb)
	    bd2=bd(-1,nb)
          uu0=+cosh(al(-1,na)-et(-1,na)) *cosh(bt(-1,na))
          uu1=-cos(ph(-1,na))            *sinh(bt(-1,na))
          uu2=-sin(ph(-1,na))            *sinh(bt(-1,na))
          uu3=-sinh(al(-1,na)-et(-1,na)) *cosh(bt(-1,na))*(tau-dtau)
          u02=+cosh(et(-1,na))*uu0-1.d0/(tau-dtau)*sinh(et(-1,na))*uu3
          u12=-uu1
          u22=-uu2
          u32=+sinh(et(-1,na))*uu0-1.d0/(tau-dtau)*cosh(et(-1,na))*uu3
	    eos(2)= ss2
	    eos(3)= bd2
	    call eosph(eos,2)
	    tm2=eos(5)
	    mb2=eos(6)
	    ms2=eos(7)
          call phsjdg2(eos(2),eos(3),phsflg)
CCC   #################################################################
CCC   debugging output for chemical freezeout
          if (iauxi.ge.4) then
	    if (phsflg.eq.0) then
              open(10,FILE=fncfz(1:nfncfz),access='append')
	        write(10,'(a)')'SPH chemical freezeout abnormal record'
              write(10,'(a,2i7,4d20.10)')'sphid,ntsp,mb1,mb2,ms1,ms2=',
     &             na,ntsp,mb1,mb2,ms1,ms2
              write(10,'(a,2d20.10)')'tm1,tm2=',tm1,tm2
		    close(10)
          else
              open(10,FILE=fncfz(1:nfncfz),access='append')
	        write(10,'(a)')'SPH chemical freezeout normal record'
              write(10,'(a,2i7,4d20.10)')'sphid,ntsp,mb1,mb2,ms1,ms2=',
     &             na,ntsp,mb1,mb2,ms1,ms2
              write(10,'(a,2d20.10)')'tm1,tm2=',tm1,tm2
	        close(10)
	    end if
	    end if
CCC   #################################################################
	    do
	    tptm=(tm1+tm2)/2.d0
	    tpbd=(bd1+bd2)/2.d0
	    tpss=(ss1+ss2)/2.d0
	    tpmb=(mb1+mb2)/2.d0
	    tpms=(ms1+ms2)/2.d0
	    tpu0=(u01+u02)/2.d0
	    tpu1=(u11+u12)/2.d0
	    tpu2=(u21+u22)/2.d0
	    tpu3=(u31+u32)/2.d0
	    if (abs(tptm-tm1).le.1.d-4) exit
	    eos(2)= tpss
	    eos(3)= tpbd
          call phsjdg2(eos(2),eos(3),phsflg)
	    if ((iquimode.eq.1.and.phsflg.eq.0)) then
	    tm1=tptm
	    bd1=tpbd
	    ss1=tpss
	    mb1=tpmb
	    ms1=tpms
	    u01=tpu0
	    u11=tpu1
	    u21=tpu2
	    u31=tpu3
	    else
	    tm2=tptm
	    bd2=tpbd
	    ss2=tpss
	    mb2=tpmb
	    ms2=tpms
	    u02=tpu0
	    u12=tpu1
	    u22=tpu2
	    u32=tpu3
	    end if
	    end do
CCC   #################################################################
	case (3,4,5,6)
       if(ntsp.ge.2) then
CCC   Normal case, corresponding to normal thermal freeze-out
          ta(-2)= tau-dtau-dtau
          ta(-1)= tau-dtau
          ta( 1)= tau
		call tmevol(na,ta,Tm)
          if(Tm(-2).gt.Tch
     &        .and.Tm(-1).le.Tch.and.Tm(1).le.Tch)then
	        continue
	    else
	        print*,'never here! from recordxn'
	        stop'never here! from recordxn'
	    endif
          if(Tch.gt.Tm(-1)) ntype=1
          if(Tch.le.Tm(-1)) ntype=2
          call flintp(Tm,na,ta,txyef,rapf,ssf,nbf,ntype,Tch)
CCC   #################################################################
CCC   fluid 4_velocity uu0-4 is u_{\mu} (not u^{mu}!! )
          uu0=+cosh(rapf(3)-txyef(3)) *cosh(rapf(1))
          uu1=-cos(rapf(2))           *sinh(rapf(1))
          uu2=-sin(rapf(2))           *sinh(rapf(1))
          uu3=-sinh(rapf(3)-txyef(3)) *cosh(rapf(1))*txyef(0)
CCC   #################################################################
CCC   transformation into ufcc
          tpu0=cosh(txyef(3))*uu0-1.d0/txyef(0)*sinh(txyef(3))*uu3
          tpu1=-uu1
          tpu2=-uu2
          tpu3=sinh(txyef(3))*uu0-1.d0/txyef(0)*cosh(txyef(3))*uu3
          eos(2)= ssf
          eos(3)= nbf
          call eosph(eos,2)
          tpss= ssf
	    tpbd= nbf
          tptm= eos(5)
          tpmb= eos(6) 
          tpms= eos(7)
CCC   #################################################################
	 elseif(ntsp.eq.0) then
c	 elseif(ntsp.eq.0.and.eos(5).le.Tch.and.eos(5).gt.0.02d0) then !the last and is not necessary due to IC
CCC   corresponding to IC case
CCC   fluid 4_velocity uu0-4 is u_{\mu} (not u^{mu}!! )
          uu0=+cosh(al(1,na)-et(1,na)) *cosh(bt(1,na))
          uu1=-cos(ph(1,na))           *sinh(bt(1,na))
          uu2=-sin(ph(1,na))           *sinh(bt(1,na))
          uu3=-sinh(al(1,na)-et(1,na)) *cosh(bt(1,na))*tau
CCC   #################################################################
CCC   transformation into ufcc
          tpu0=cosh(et(1,na))*uu0-1.d0/tau*sinh(et(1,na))*uu3
          tpu1=-uu1
          tpu2=-uu2
          tpu3=sinh(et(1,na))*uu0-1.d0/tau*cosh(et(1,na))*uu3
CCC   #################################################################
          eos(2)= ss(1,na)
          eos(3)= bd(1,na)
          call eosph(eos,2)
          tpss= ss(1,na)
	    tpbd= bd(1,na)
          tptm= eos(5)
          tpmb= eos(6)
          tpms= eos(7)
          if (tptm.gt.Tch) then
	     print*,'recordxn: never here!'
           stop 'recordxn: never here!'
	    endif
	 else
	    print*,'recordxn: it should not be the case, never!'
	    print*,'ntsp=',ntsp
	    stop 'recordxn: it should not be the case, never!'
       endif

	case default
	    print*,'iqui mod fatal error, ilegal option number!'
		stop 'iqui mod fatal error, ilegal option number!'
	end select

CCC   #################################################################
CCC   debugging output for chemical freezeout
          if (iauxi.ge.4) then
          open(10,FILE=fncfz(1:nfncfz),access='append')
ccc   'sphid,iflgfp,ntsp,mbxn,msxn,tempxn,tpss'
          write(10,'(3i7,4d20.10)')
     &     na,iflgfp(na),ntsp,tpmb,tpms,tptm,tpss
	    close(10)
	    endif
CCC   #################################################################
	mbxn(na)=tpmb
	msxn(na)=tpms
	tempxn(na)=tptm
	ssxn(na)=tpss
	bbxn(na)=tpbd
	uxn(0,na)=tpu0
	uxn(1,na)=tpu1
	uxn(2,na)=tpu2
	uxn(3,na)=tpu3

      return
      end





CCC   #################################################################
CCC   recordxn_inspector()
CCC   #################################################################
CCC   last updated 07072008
CCC   add iqui-fz check to fix a bug
CCC
CCC   last updated 07042008
CCC   adopted from recordxn()
CCC   #################################################################
      subroutine recordxn_inspector(tau,ntsp)
      implicit none
      include 'spherio.inc'
	include 'spherio.debug.inc'
	include 'spherio.quifz.inc'
	include 'epos.incsf'
      double precision tau
      integer na
	integer ntsp

      if (iquifz.eq.0) return
      if (iauxi.le.12) return
	select case (iquimode)
	case (1,2)
		return
	case (3,4,5,6)
      do na=1,Nsp(1)
          if(iflgxn(na).eq.0) cycle
          if(iflgxn(na).eq.3) cycle
          if (mbxn(na).eq.zero.or.msxn(na).eq.zero) then
             open(11,file=fnnan(1:nfnnan),access='append')
             write(11,*)'NaN in recordxn_inp!'
	       write(11,'(a,2i6,d30.20)')'iflgxn(na),iflgce(na),sn(1,na)='
     &            ,iflgxn(na),iflgce(na),sn(1,na)
	       write(11,'(a,2i6,2d30.20)')'na,ntsp,mbxn(na),mbxn(na)='
     &            ,na,ntsp,mbxn(na),mbxn(na)
	       write(11,'(2a,6d30.20)')'tempxn(na),ssxn(na),',
     &            'uxn(0,na),uxn(1,na),uxn(2,na),uxn(3,na)=',
     &            tempxn(na),ssxn(na),
     &            uxn(0,na),uxn(1,na),uxn(2,na),uxn(3,na)
	       write(11,'(2a,9d30.20)')'xx(1,na),yy(1,na),et(1,na),tau',
     &            'bt(1,na),ph(1,na),al(1,na),ss(1,na),bd(1,na)=',
     &            xx(1,na),yy(1,na),et(1,na),tau,
     &            bt(1,na),ph(1,na),al(1,na),ss(1,na),bd(1,na)
             close(11)
          endif
      end do

      case default
          stop 'quimode fatal error in recordxn_inspector!'
      end select

      return
      end



