CCC   #################################################################
CCC   checkodd()
CCC   function check for strange particles
CCC   #################################################################
CCC   last udpated 07022008
CCC   implement all particle chemical freeze-out scenario
CCC
CCC   last updated 05302008
CCC   rip p bar out of chemical freeze-out
CCC
CCC   last updated 09182007
CCC   active phi(1020) into the set
CCC
CCC   last updated 06212007
CCC   fixed a bug in the last modification
CCC
CCC   last updated 05282007
CCC   proton is excluded
CCC
CCC   last updated 05252007
CCC   add proton and anti-proton
CCC
CCC   last udpated 04272007
CCC   ripped some of hyperons from the list
CCC
CCC   last updated 01182007
CCC   #################################################################
      integer function checkodd(id)
      IMPLICIT NONE
      include 'spherio.quifz.inc'
      INTEGER id



	       if (
c     &           ((id.ge.070).and.(id.le.077)).or.		!!kion
c     &           ((id.eq.150)).or.	                	!!proton
c     &           ((id.eq.151)).or.	                	!!anti-proton
     &           ((id.ge.300).and.(id.le.327)).or.		!!lambda
c     &           ((id.ge.330).and.(id.le.383)).or.		!!sigma
     &           ((id.ge.390).and.(id.le.401)).or.		!!xi
     &           ((id.eq.014)).or.	                    !!phi(1020)
     &           ((id.ge.410).and.(id.le.411)).or.   		!!omega
     &           (iquimode.eq.6)
     &          )
     &       then
                checkodd=1
             else
                checkodd=0
             endif


             if ((checkodd.ne.0).and.(checkodd.ne.1)) 
     &          stop 'checkodd fatal error'


      RETURN
      END     



CCC   #################################################################
CCC   checkomg()
CCC   function check for strange particles
CCC   #################################################################
CCC   last updated 04252007
CCC   #################################################################
      integer function checkomg(id)
      IMPLICIT NONE
      INTEGER id

	       if ((id.ge.410).and.(id.le.411))           		!!omega
     &       then
                checkomg=1
             else
                checkomg=0
             endif
             if ((checkomg.ne.0).and.(checkomg.ne.1)) 
     &          stop 'checkomg fatal error'

      RETURN
      END     



CCC   #################################################################
CCC   checkv2()
CCC   function check for low yield particles for v2 calculation
CCC   #################################################################
CCC   last updated 0925007
CCC   inherited from checkomg()
CCC   #################################################################
      integer function checkv2(id)
      IMPLICIT NONE
      INTEGER id

	       if ((id.eq.150).or.(id.eq.151))           		!!p,ap
     &       then
                checkv2=1
             else
                checkv2=0
             endif
             if ((checkv2.ne.0).and.(checkv2.ne.1)) 
     &          stop 'checkv2 fatal error'

      RETURN
      END     



CCC   #################################################################
CCC   density()
CCC   #################################################################
      SUBROUTINE DENSTY(T,U,MASS,B,G,SOL)
      IMPLICIT NONE
	include 'epos.incsf'
	include 'spherio.debug.inc'
      INTEGER B,G,I,N
      DOUBLE PRECISION T,U,MASS,SOL
      DOUBLE PRECISION FUNCX,SINAL,C1,C2
      DOUBLE PRECISION PI,HBARC
      PARAMETER (N=40,PI=3.1416D0,HBARC=0.197D0)
      DOUBLE PRECISION X(N),W(N)
      DATA x    /.605560794968470D-01,.242314399453907D+00,
     &           .545545942940150D+00,.970704825303149D+00,
     &           .151843206139111D+01,.218956094537021D+01,
     &           .298512415353425D+01,.390636271905900D+01,
     &           .495473707204299D+01,.613194039039904D+01,
     &           .743991456973172D+01,.888086919648455D+01,
     &           .104573040025865D+02,.121720353971540D+02,
     &           .140282278190022D+02,.160294308429648D+02,
     &           .181796232172878D+02,.204832653281224D+02,
     &           .229453620078218D+02,.255715381655908D+02,
     &           .283681304789583D+02,.313422994264794D+02,
     &           .345021673919297D+02,.378569906205317D+02,
     &           .414173757589751D+02,.451955560431829D+02,
     &           .492057486975734D+02,.534646251033695D+02,
     &           .579919410908272D+02,.628114004819503D+02,
     &           .679518686100185D+02,.734491294926328D+02,
     &           .793485231107206D+02,.857090805572550D+02,
     &           .926103714808114D+02,.100164666988845D+03,
     &           .108540671171466D+03,.118016418625933D+03,
     &           .129124302686158D+03,.143235883046645D+03/
      DATA w    /.280557084504549D-01,.936587631414218D-01,
     &           .155852454570871D+00,.181507401397079D+00,
     &           .164460962731629D+00,.121467812463066D+00,
     &           .749263716356719D-01,.391389980666205D-01,
     &           .174578228962413D-01,.668248223379627D-02,
     &           .220130319872711D-02,.624869534483574D-03,
     &           .152879412248271D-03,.322142925829804D-04,
     &           .583771261043685D-05,.907785044756843D-06,
     &           .120790579159305D-06,.137047071467560D-07,
     &           .132030457877663D-08,.107476134588874D-09,
     &           .735029847418547D-11,.419555976761447D-12,
     &           .198365640346937D-13,.770066730807756D-15,
     &           .242982698628324D-16,.615883901864997D-18,
     &           .123689541347603D-19,.193667819139842D-21,
     &           .231917100545989D-23,.207556734498725D-25,
     &           .134975350543052D-27,.615940496341259D-30,
     &           .188713947564140D-32,.366516393879786D-35,
     &           .417655596639807D-38,.250434496512019D-41,
     &           .671282050344281D-45,.615627888802903D-49,
     &           .116230495454071D-53,.124543158530471D-59/

      C1=MASS/T
      C2=U/T

      IF(B.EQ.0)THEN
         SINAL = -1.0D0  !! Boson
      ELSE 
         SINAL = +1.0D0  !! Fermion
      ENDIF

      SOL=0.0D0

      DO 10 I=1,N
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.5) then
	if ((X(I)+2.0*C1).lt.0.d0) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN in density!'
	write(11,'(a,f16.8)')'(X(I)+2.0*C1)=',(X(I)+2.0*C1)
      close(11)
	endif
	endif
CCC   #################################################################
         FUNCX=(X(I)+C1)*SQRT(X(I)+2.0*C1)/(EXP(C1-C2)+SINAL*EXP(-X(I)))
         SOL = SOL+W(I)*FUNCX
 10   CONTINUE

      SOL=G/(2.0D0*PI*PI)*SOL
      SOL=SOL*(T*T*T)
      SOL=SOL/(HBARC*HBARC*HBARC)  !! [fm^-3]   

      RETURN
      END 



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   SUBROUTINE PROGRAM: evgen.f 
CCC   #################################################################
CCC   last updated 06272010
CCC   modified to fix a hidden bug concerining freeze-out surface
CCC   resulting non-avoidable pdx = 0
CCC   this kind of particle will always be accepted if any
CCC
CCC   last updated 12092009
CCC   switched back for debugging purpose, maybe a bug here(?)
CCC
CCC   last updated 09132009
CCC   modified to adopt do enddo 
CCC   modified to remove ambiguity of focused spot
CCC
CCC   last updated 09072009
CCC   normaliztion of ridge check emission is modified
CCC   new rdratio definition is implemented for easy usage
CCC
CCC   last updated 02162009
CCC   remarked the z2-.data output
CCC
CCC   last updated 02112009
CCC   modified the output to multiply the transverse velocity of SPH particles
CCC
CCC   last updated 02092009
CCC   modified the output to suit the event-by-event calculation
CCC
CCC   last updated 02052009
CCC   add more ridge effect output
CCC
CCC   last updated 01052009
CCC   modified to study ridge effect
CCC
CCC   last updated 12102008
CCC   fixed a bug in output debug info
CCC
CCC   last updated 12012008
CCC   modify the value passes to mptlic
CCC
CCC   last updated 11162008
CCC   sum up the total energy generated during the hydro evolution before passing back
CCC   to NEXUS as a check
CCC
CCC   last updated 07072007
CCC   modified to adopt new ce scenario
CCC
CCC   last updated 05222007
CCC   modified accroding to lorenz()
CCC
CCC   last updated 04272007
CCC   modified output id info
CCC
CCC   last updated 04252007
CCC   modified to adopt checkomg()
CCC
CCC   last updated 08162006
CCC   debugging info output added, summation of emmision
CCC
CCC   last updated 05122006
CCC   ssq is introduced, the interface of pdmax() and prodis() are changed
CCC
CCC   last updated 12092002
CCC   #################################################################
      SUBROUTINE evgen(nfr,nfrzz)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      INCLUDE 'spherio.seedspo.inc'
      INCLUDE 'spherio.evgen1.inc'
      INCLUDE 'spherio.evgen2.inc'
	INCLUDE 'spherio.evgen4.inc'
	INCLUDE 'spherio.evgen5.inc'
      INCLUDE 'spherio.debug.inc'
      INCLUDE 'spherio.ridge.inc'
      INCLUDE 'epos.incsf'
      INTEGER nfr,mmptl,ipart,bb,ssq,gg,ncont,iescol,id
	INTEGER nfrzz
      INTEGER nexpid(500),nxpid,jntot
      INTEGER iger
c      INTEGER igerloop
      INTEGER iev,mptlic
      double precision mm,sinal,ran2r
      double precision pdx,p,theta,phi,gasdev,hx,hy,he
      double precision pprx,ppry,pprz
      double precision prodis,pd 
	double precision tau,x,y,eta
      double precision ppr(0:3),plb(0:3)
      double precision gamma,vx,vy,vz
      INTEGER imaxdata
      PARAMETER (imaxdata=100000)
c      integer nxpid_rdg(1:imaxdata)
c	double precision plb_rdg(1:imaxdata,1:3),mm_rdg(1:imaxdata)
      double precision totalgenenergy,ttgenenergy(npart)
	double precision avgenenergy
      integer kk
c	double precision phif_ridge
c	logical check_f
      PARAMETER (hx=0.7,hy=0.7,he=0.7)
      COMMON/nxp/nexpid
      COMMON/startic/mptlic
      SAVE iev
      DATA iev/0/
	integer nexp,ntest
      integer ncntspofo
      data ncntspofo/0/
      save ncntspofo
      ncntspofo=ncntspofo+1

      if(ncntspofo.eq.1)print*,'spherio freeze out'
      IF(iev.EQ.0) idum=-ABS(idum)
      iev=iev+1    
C*** Debug
c$$$      OPEN(10,FILE='ev.out',STATUS='UNKNOWN',ACCESS='APPEND')
c$$$      WRITE(10,*)'Monte Carlo event = ',iev
c$$$      CLOSE(10)
C*** End Debug

      mmptl = 0
      totalgenenergy = 0.d0

      if (iauxi.ge.3.and.nfrzz.eq.0) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
	    WRITE(10,*)' '
          WRITE(10,*) ('-',kk=1,63)
	    WRITE(10,*)' '
          CLOSE(10)
      endif      

      iger = 0      
      DO ipart=1,nparb_act
	    ttgenenergy(ipart) = 0.d0
          id     = ipid(ipart)
          nxpid  = nexpid(id)
	    mm     = mss(id)
	    gg     = ngf(id)
	    bb     = nbr(id)
CCC   to incorporate strangeness
          ssq    = nsr(id)
CCC   to incorporate strangeness
          IF(bb.EQ.0)THEN
             sinal = -1.  !! bosons
          ELSE
             sinal = +1.  !! fermions 
          ENDIF
          CALL settot(ntot(ipart),jntot)
CCC   #################################################################
CCC   emmision summation output
      if (iauxi.ge.3.and.nfrzz.eq.0) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
          WRITE(10,'(a,2i5,i7,d30.20,i5)')
     &              'ipart,id,nxpid,ntot,emission no= ',
     &               ipart,id,nxpid,ntot(ipart),jntot
          CLOSE(10)
	endif
CCC   #################################################################
	  ncont = 0
cxxx	  DO ! of ncont loop
cxxx         IF(ncont.ge.jntot)exit
10	  IF(ncont.LT.jntot)THEN
 	    iescol = INT(nfr*ran2r(idum))+1
c*** Debug
	    IF(iescol.LT.1 .OR. iescol.GT.nfr) THEN 
               open(11,file=fnnsp(1:nfnnsp),access='append')
               WRITE(11,*)'ERRO EM iescol'
	         CLOSE(11)
               STOP 'ERRO EM iescol'
          ENDIF
	    IF(wg(iescol,ipart).GT.wmax(ipart)) THEN 
               open(11,file=fnnsp(1:nfnnsp),access='append')
               WRITE(11,*)'ERRO EM wmax(ipart)'
               CLOSE(11)
               STOP 'ERRO EM wmax(ipart)'
          ENDIF
c*** End Debug

          IF(ran2r(idum).LE.wg(iescol,ipart)/wmax(ipart)) THEN !sph particle choice
	      ncont = ncont+1

CCC   #################################################################
CCC   ridge check
CCC   in order that there is no normalization (after ncont increment)
CCC   the particle is emitted but never registed by NEXUS (before mmptl increment)
CCC   #################################################################
          IF(iridge.eq.1)THEN
           if((iflgfpfz(iescol).gt.Nsprdg).and.(rdratio.gt.0.d0))GOTO 10 !if not in the Nsprdg selected list cycle
           if((iflgfpfz(iescol).le.Nsprdg).and.(rdratio.lt.0.d0))GOTO 10 !if in the Nsprdg select list cycle
cxxx           if((iflgfpfz(iescol).gt.Nsprdg).and.(rdratio.gt.0.d0))cycle
cxxx           if((iflgfpfz(iescol).le.Nsprdg).and.(rdratio.lt.0.d0))cycle
c	        if(check_f(phif_ridge(-ufcc(1,iescol),-ufcc(2,iescol)))
c     &                        .eqv..false.) GOTO 10
          ENDIF
CCC   #################################################################

	      mmptl = mmptl+1
	      CALL pdmax(iescol,id,mm,gg,sinal,bb,ssq,pdx)
CCC   #################################################################
CCC   NaN catchup, moved to pdx
cxx      if (pdx.le.0.d0) then
cxx      if (iauxi.ge.9) then
cxx      open(11,file=fnnan(1:nfnnan),access='append')
cxx      write(11,*)'NaN catchup in evgen!'
cxx	write(11,*)'pdx unphysical number'
cxx	write(11,*)'pdx=',pdx
cxx	write(11,*)'iescol,id,mm,gg,sinal,bb,ssq=',
cxx     &            iescol,id,mm,gg,sinal,bb,ssq
cxx      write(11,*)'sfpr(0-4,iescol)',sfpr(0,iescol),sfpr(1,iescol),
cxx     &  sfpr(2,iescol),sfpr(3,iescol),sfpr(4,iescol)
cxx      write(11,*)'wg(iescol,1-2)',wg(iescol,1),wg(iescol,2)
cxx      write(11,*)'nparb_act',nparb_act
cxx      write(11,*)' '
cxx      close(11)
cxx	endif
cxx	stop 'pdx unphysical!'
cxx	endif
CCC   #################################################################
cxxx	      do ! of momentum generation
20         continue
              p     = pmin+ran2r(idum)*(pmax-pmin)
	        theta = thmin+ran2r(idum)*(thmax-thmin)
	        phi = phmin+ran2r(idum)*(phmax-phmin)
              CALL rot(iescol,p,phi,theta,pprx,ppry,pprz)
              ppr(0)=SQRT(mm**2+pprx**2+ppry**2+pprz**2)
              ppr(1)=pprx
              ppr(2)=ppry
              ppr(3)=pprz
              CALL lorenz(iescol,id,ppr,plb)
	        pd    =  prodis(iescol,id,mm,gg,sinal,bb,ssq,p,plb,theta)
              IF ((pdx.ne.0.d0).and.(ran2r(idum).GT.pd/pdx)) GOTO 20 !rejection mechanism
	        if (iauxi.ge.9.and.nfrzz.eq.0) then
	            if(sqrt(plb(1)**2+plb(2)**2).ge.10.d0) then
                      OPEN(10,FILE=fnsom(1:nfnsom),access='append')
                      WRITE(10,'(a,i5,3d25.10)')
     &                 'high pT particle detected: ipart,pT,pz,E=',
     &                  ipart,sqrt(plb(1)**2+plb(2)**2),plb(3),plb(0)
                        gamma = ufcc(0,iescol)
                        vx = ufcc(1,iescol)/gamma
                        vy = ufcc(2,iescol)/gamma
                        vz = ufcc(3,iescol)/gamma
                      WRITE(10,'(a,i6,4d25.10)')
     &                  'iescol,gamma,vx,vy,vz=',
     &                  iescol,gamma,vx,vy,vz
                      WRITE(10,'(2a,5d25.10)')
     &                  'tempfz(iescol),xfrs(0,iescol),xfrs(1,iescol),',
     &                  'xfrs(2,nf),xfrs(3,nf)=',
     &                   tempfz(iescol),xfrs(0,iescol),xfrs(1,iescol),
     &                   xfrs(2,iescol),xfrs(3,iescol)
                      CLOSE(10)
	            endif
	        endif
cxxx              IF(ran2r(idum).gt.pd/pdx) then !rejection mechanism
cxxx	         continue
cxxx	        else
cxxx	         exit
cxxx	        ENDIF

cxxx            enddo ! of momentum generation
            totalgenenergy = totalgenenergy + plb(0)             !sum up the total energy of hadrons
            ttgenenergy(ipart) = ttgenenergy(ipart) + plb(0)
c*** Debug
	      IF(pd.GT.pdx)THEN
               open(11,file=fnnsp(1:nfnnsp),access='append')
	         WRITE(11,*)'pd = ',pd,'   pdx = ',pdx
               CLOSE(11)
	      ENDIF
c*** End Debug
            iger= iger+1
            x   = xfrs(1,iescol)+hx*gasdev(idum)
            y   = xfrs(2,iescol)+hy*gasdev(idum)
            eta = xfrs(3,iescol)+he*gasdev(idum)
            tau = xfrs(0,iescol)
	      CALL setnex(mmptl,id,nxpid,plb,mm,tau,x,y,eta)
c      if(iridge.eq.1)then
c	    nxpid_rdg(iger)=nxpid
c	    plb_rdg(iger,1)=plb(1)
c	    plb_rdg(iger,2)=plb(2)
c         plb_rdg(iger,3)=plb(3)
c	    mm_rdg(iger)=mm
c      endif
          ENDIF !sph particle choice
        GOTO 10
cxxx        ENDDO ! of ncont loop
	  ENDIF ! of ncont check

      if (iauxi.ge.6.and.nfrzz.eq.0) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
	    avgenenergy=0.d0
	    if (dble(jntot).ne.0.d0)
     &       avgenenergy=ttgenenergy(ipart)/dble(jntot)
          WRITE(10,'(a,i5,2d25.10)')
     &       'ipart,ttgenenergy,averaged energy =',
     &      ipart,ttgenenergy(ipart),avgenenergy
          CLOSE(10)
      endif



      ENDDO ! of ipart

c      mptlic = mmptl+1
      mptlic=mmptl

c     the output data file directly from SPheRIO without decay treated by NEXUS
c      if(iridge.eq.1)then
c	    open(19,file='z2-'//fncno(1:nfncno)//'.data',access='append')
c          write(19,'(i8,a)')iger,'      0      0 0.0000E+00 0.0000E+00 '
c	    do igerloop=1,iger
c          write(19,'(2i8,4d20.10)')igerloop,nxpid_rdg(igerloop),
c     &    plb_rdg(igerloop,1),plb_rdg(igerloop,2),plb_rdg(igerloop,3),
c     &    mm_rdg(igerloop)
c	    enddo
c	    close(19)
c      endif

      if (iauxi.ge.6.and.nfrzz.eq.0) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
          WRITE(10,*) ('-',kk=1,63)
          WRITE(10,'(a,d25.10)')
     &             ' energy of hadrons emitted by SPheRIO:',
     &               totalgenenergy
          CLOSE(10)
      endif

      if (iauxi.ge.3.and.nfrzz.eq.0) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
	    WRITE(10,*)' '
          WRITE(10,*) ('-',kk=1,63)
	    WRITE(10,*)' '
          CLOSE(10)
      endif


CCC   #################################################################
CCC   debug output of checking the energy conservation
      if (iauxi.ge.24.and.nfrzz.eq.0) then
	ipart=1
c      DO ipart=1,nparb_act
       do nexp=0,3 !try 1,10,100,1000 particles
	    ttgenenergy(ipart) = 0.d0
          ntest=10**(nexp) 
          id     = ipid(ipart)
          nxpid  = nexpid(id)
	    mm     = mss(id)
	    gg     = ngf(id)
	    bb     = nbr(id)
          ssq    = nsr(id)
          IF(bb.EQ.0)THEN
             sinal = -1.  !! bosons
          ELSE
             sinal = +1.  !! fermions 
          ENDIF
	  ncont = 0
 	  do while(ncont.LE.ntest)
 	    iescol = INT(nfr*ran2r(idum))+1
          IF(ran2r(idum).LE.wg(iescol,ipart)/wmax(ipart)) THEN
	      ncont = ncont+1
	      CALL pdmax(iescol,id,mm,gg,sinal,bb,ssq,pdx)
            do while(.true.)
              p     = pmin+ran2r(idum)*(pmax-pmin)
	        theta = thmin+ran2r(idum)*(thmax-thmin)
	        phi = phmin+ran2r(idum)*(phmax-phmin)
              CALL rot(iescol,p,phi,theta,pprx,ppry,pprz)
              ppr(0)=SQRT(mm**2+pprx**2+ppry**2+pprz**2)
              ppr(1)=pprx
              ppr(2)=ppry
              ppr(3)=pprz
              CALL lorenz(iescol,id,ppr,plb)
	        pd    =  prodis(iescol,id,mm,gg,sinal,bb,ssq,p,plb,theta)
              IF(ran2r(idum).le.pd/pdx) exit
            enddo
            totalgenenergy = totalgenenergy + plb(0)             !sum up the total energy of hadrons
            ttgenenergy(ipart) = ttgenenergy(ipart) + plb(0)
          ENDIF
        enddo ! of nont
        OPEN(10,FILE=fnsom(1:nfnsom),access='append')
        WRITE(10,'(a,2i5,2d25.10)')
     &    'ipart,ntest,ttgenenergy,averaged energy =',
     &    ipart,ntest,ttgenenergy(ipart),ttgenenergy(ipart)/dble(ntest)
        CLOSE(10)
       enddo ! of ntest
c      ENDDO ! of ipart
      endif ! of iauxi check
      


      RETURN
      END






CCC   #################################################################
CCC   SUBROUTINE PROGRAM: evgen.f 
CCC   #################################################################
CCC   last updated 06272010
CCC   modified to fix a hidden bug concerining freeze-out surface
CCC   resulting non-avoidable pdx = 0
CCC   this kind of particle will always be accepted if any
CCC
CCC   last updated 09132009
CCC   modified to adopt do enddo 
CCC   modified to remove ambiguity of focused spot
CCC
CCC   last updated 09072009
CCC   normaliztion of ridge check emission is modified
CCC   new rdratio definition is implemented for easy usage
CCC
CCC   last updated 02162009
CCC   remarked the z2-.data output
CCC
CCC   last updated 02112009
CCC   modified the output to multiply the transverse velocity of SPH particles
CCC
CCC   last updated 02092009
CCC   modified the output to suit the event-by-event calculation
CCC
CCC   last updated 02052009
CCC   add more ridge effect output
CCC
CCC   last updated 01052009
CCC   modified to study ridge effect
CCC
CCC   last updated 12102008
CCC   fixed a bug in output debug info
CCC
CCC   last updated 12012008
CCC   modify the value passes to mptlic
CCC
CCC   last updated 11162008
CCC   sum up the total energy generated during the hydro evolution before passing back
CCC   to NEXUS as a check
CCC
CCC   last updated 07072007
CCC   modified to adopt new ce scenario
CCC
CCC   last updated 05222007
CCC   modified accroding to lorenz()
CCC
CCC   last updated 04272007
CCC   modified output id info
CCC
CCC   last updated 04252007
CCC   modified to adopt checkomg()
CCC
CCC   last updated 08162006
CCC   debugging info output added, summation of emmision
CCC
CCC   last updated 05122006
CCC   ssq is introduced, the interface of pdmax() and prodis() are changed
CCC
CCC   last updated 12092002
CCC   #################################################################
      SUBROUTINE evgen_nogo(nfr,nfrzz)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      INCLUDE 'spherio.seedspo.inc'
      INCLUDE 'spherio.evgen1.inc'
      INCLUDE 'spherio.evgen2.inc'
	INCLUDE 'spherio.evgen4.inc'
	INCLUDE 'spherio.evgen5.inc'
      INCLUDE 'spherio.debug.inc'
      INCLUDE 'spherio.ridge.inc'
      INCLUDE 'epos.incsf'
      INTEGER nfr,mmptl,ipart,bb,ssq,gg,ncont,iescol,id
	INTEGER nfrzz
      INTEGER nexpid(500),nxpid,jntot
      INTEGER iger
c      INTEGER igerloop
      INTEGER iev,mptlic
      double precision mm,sinal,ran2r
      double precision pdx,p,theta,phi,gasdev,hx,hy,he
      double precision pprx,ppry,pprz
      double precision prodis,pd 
	double precision tau,x,y,eta
      double precision ppr(0:3),plb(0:3)
      double precision gamma,vx,vy,vz
      INTEGER imaxdata
      PARAMETER (imaxdata=100000)
c      integer nxpid_rdg(1:imaxdata)
c	double precision plb_rdg(1:imaxdata,1:3),mm_rdg(1:imaxdata)
      double precision totalgenenergy,ttgenenergy(npart)
	double precision avgenenergy
      integer kk
c	double precision phif_ridge
c	logical check_f
      PARAMETER (hx=0.7,hy=0.7,he=0.7)
      COMMON/nxp/nexpid
      COMMON/startic/mptlic
      SAVE iev
      DATA iev/0/
	integer nexp,ntest
      integer ncntspofo
      data ncntspofo/0/
      save ncntspofo
      ncntspofo=ncntspofo+1

      if(ncntspofo.eq.1)print*,'spherio freeze out'
      IF(iev.EQ.0) idum=-ABS(idum)
      iev=iev+1    
C*** Debug
c$$$      OPEN(10,FILE='ev.out',STATUS='UNKNOWN',ACCESS='APPEND')
c$$$      WRITE(10,*)'Monte Carlo event = ',iev
c$$$      CLOSE(10)
C*** End Debug

      mmptl = 0
      totalgenenergy = 0.d0

      if (iauxi.ge.3.and.nfrzz.eq.0) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
	    WRITE(10,*)' '
          WRITE(10,*) ('-',kk=1,63)
	    WRITE(10,*)' '
          CLOSE(10)
      endif      

      iger = 0      
      DO ipart=1,nparb_act
	    ttgenenergy(ipart) = 0.d0
          id     = ipid(ipart)
          nxpid  = nexpid(id)
	    mm     = mss(id)
	    gg     = ngf(id)
	    bb     = nbr(id)
CCC   to incorporate strangeness
          ssq    = nsr(id)
CCC   to incorporate strangeness
          IF(bb.EQ.0)THEN
             sinal = -1.  !! bosons
          ELSE
             sinal = +1.  !! fermions 
          ENDIF
          CALL settot(ntot(ipart),jntot)
CCC   #################################################################
CCC   emmision summation output
      if (iauxi.ge.3.and.nfrzz.eq.0) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
          WRITE(10,'(a,2i5,i7,d30.20,i5)')
     &              'ipart,id,nxpid,ntot,emission no= ',
     &               ipart,id,nxpid,ntot(ipart),jntot
          CLOSE(10)
	endif
CCC   #################################################################
	  ncont = 0
	  DO ! of ncont loop
         IF(ncont.ge.jntot)exit
cx 10	  IF(ncont.LT.jntot)THEN
 	    iescol = INT(nfr*ran2r(idum))+1
c*** Debug
	    IF(iescol.LT.1 .OR. iescol.GT.nfr) THEN 
               open(11,file=fnnsp(1:nfnnsp),access='append')
               WRITE(11,*)'ERRO EM iescol'
	         CLOSE(11)
               STOP 'ERRO EM iescol'
          ENDIF
	    IF(wg(iescol,ipart).GT.wmax(ipart)) THEN 
               open(11,file=fnnsp(1:nfnnsp),access='append')
               WRITE(11,*)'ERRO EM wmax(ipart)'
               CLOSE(11)
               STOP 'ERRO EM wmax(ipart)'
          ENDIF
c*** End Debug
cxx       IF(iridge.eq.1.and.iflgfpfz(iescol).gt.Nsprdg)CYCLE

          IF(ran2r(idum).LE.wg(iescol,ipart)/wmax(ipart)) THEN !sph particle choice
	      ncont = ncont+1

CCC   #################################################################
CCC   ridge check
CCC   in order that there is no normalization (after ncont increment)
CCC   the particle is emitted but never registed by NEXUS (before mmptl increment)
CCC   #################################################################
          IF(iridge.eq.1)THEN
cx           if((iflgfpfz(iescol).gt.Nsprdg).and.(rdratio.gt.0.d0))GOTO 10 !if not in the Nsprdg selected list cycle
cx           if((iflgfpfz(iescol).le.Nsprdg).and.(rdratio.lt.0.d0))GOTO 10 !if in the Nsprdg select list cycle
           if((iflgfpfz(iescol).gt.Nsprdg).and.(rdratio.gt.0.d0))cycle
           if((iflgfpfz(iescol).le.Nsprdg).and.(rdratio.lt.0.d0))cycle
c	        if(check_f(phif_ridge(-ufcc(1,iescol),-ufcc(2,iescol)))
c     &                        .eqv..false.) GOTO 10
          ENDIF
CCC   #################################################################

	      mmptl = mmptl+1
	      CALL pdmax(iescol,id,mm,gg,sinal,bb,ssq,pdx)
CCC   #################################################################
CCC   NaN catchup moved to pdx
cxx      if (pdx.le.0.d0) then
cxx      if (iauxi.ge.9) then
cxx      open(11,file=fnnan(1:nfnnan),access='append')
cxx      write(11,*)'NaN catchup in evgen_nogo!'
cxx	write(11,*)'pdx unphysical number'
cxx	write(11,*)'pdx=',pdx
cxx	write(11,*)'iescol,id,mm,gg,sinal,bb,ssq=',
cxx     &            iescol,id,mm,gg,sinal,bb,ssq
cxx      write(11,*)'sfpr(0-4,iescol)',sfpr(0,iescol),sfpr(1,iescol),
cxx     &  sfpr(2,iescol),sfpr(3,iescol),sfpr(4,iescol)
cxx      write(11,*)'sfrs(0-3,iescol)',sfrs(0,iescol),sfrs(1,iescol),
cxx     &  sfrs(2,iescol),sfrs(3,iescol)
cxx      write(11,*)'ufrs(0-3,iescol)',ufrs(0,iescol),ufrs(1,iescol),
cxx     &  ufrs(2,iescol),ufrs(3,iescol)
cxx      write(11,*)'xfrs(0-3,iescol)',xfrs(0,iescol),xfrs(1,iescol),
cxx     &  xfrs(2,iescol),xfrs(3,iescol)
cxx      write(11,*)'wg(iescol,1-2)',wg(iescol,1),wg(iescol,2)
cxx      write(11,*)'nparb_act',nparb_act
cxx      write(11,*)' '
cxx      close(11)
cxx	endif
cxx	stop 'pdx unphysical!'
cxx	endif
CCC   #################################################################
	      do ! of momentum generation
cx 20         continue
              p     = pmin+ran2r(idum)*(pmax-pmin)
	        theta = thmin+ran2r(idum)*(thmax-thmin)
	        phi = phmin+ran2r(idum)*(phmax-phmin)
              CALL rot(iescol,p,phi,theta,pprx,ppry,pprz)
              ppr(0)=SQRT(mm**2+pprx**2+ppry**2+pprz**2)
              ppr(1)=pprx
              ppr(2)=ppry
              ppr(3)=pprz
              CALL lorenz(iescol,id,ppr,plb)
	        pd    =  prodis(iescol,id,mm,gg,sinal,bb,ssq,p,plb,theta)
cx              IF(ran2r(idum).GT.pd/pdx) GOTO 20
	        if (iauxi.ge.9.and.nfrzz.eq.0) then
	            if(sqrt(plb(1)**2+plb(2)**2).ge.10.d0) then
                      OPEN(10,FILE=fnsom(1:nfnsom),access='append')
                      WRITE(10,'(a,i5,3d25.10)')
     &                 'high pT particle detected: ipart,pT,pz,E=',
     &                  ipart,sqrt(plb(1)**2+plb(2)**2),plb(3),plb(0)
                        gamma = ufcc(0,iescol)
                        vx = ufcc(1,iescol)/gamma
                        vy = ufcc(2,iescol)/gamma
                        vz = ufcc(3,iescol)/gamma
                      WRITE(10,'(a,i6,4d25.10)')
     &                  'iescol,gamma,vx,vy,vz=',
     &                  iescol,gamma,vx,vy,vz
                      WRITE(10,'(2a,5d25.10)')
     &                  'tempfz(iescol),xfrs(0,iescol),xfrs(1,iescol),',
     &                  'xfrs(2,nf),xfrs(3,nf)=',
     &                   tempfz(iescol),xfrs(0,iescol),xfrs(1,iescol),
     &                   xfrs(2,iescol),xfrs(3,iescol)
                      CLOSE(10)
	            endif
	        endif
              IF ((pdx.ne.0.d0).and.(ran2r(idum).gt.pd/pdx)) then !momentum p generate check
	         cycle
	        else
               totalgenenergy = totalgenenergy + plb(0)             !sum up the total energy of hadrons
               ttgenenergy(ipart) = ttgenenergy(ipart) + plb(0)
c*** Debug
	            IF(pd.GT.pdx)THEN
                      open(11,file=fnnsp(1:nfnnsp),access='append')
	                WRITE(11,*)'pd = ',pd,'   pdx = ',pdx
                      CLOSE(11)
	            ENDIF
c*** End Debug
               iger= iger+1
               x   = xfrs(1,iescol)+hx*gasdev(idum)
               y   = xfrs(2,iescol)+hy*gasdev(idum)
               eta = xfrs(3,iescol)+he*gasdev(idum)
               tau = xfrs(0,iescol)
	         CALL setnex(mmptl,id,nxpid,plb,mm,tau,x,y,eta)
	         exit
	        ENDIF !momentum p generate check
            enddo ! of momentum generation
c      if(iridge.eq.1)then
c	    nxpid_rdg(iger)=nxpid
c	    plb_rdg(iger,1)=plb(1)
c	    plb_rdg(iger,2)=plb(2)
c         plb_rdg(iger,3)=plb(3)
c	    mm_rdg(iger)=mm
c      endif
          ENDIF !sph particle choice
cx        GOTO 10
        ENDDO ! of ncont loop
cx	  ENDIF ! of ncont check

      if (iauxi.ge.6.and.nfrzz.eq.0) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
	    avgenenergy=0.d0
	    if (dble(jntot).ne.0.d0)
     &       avgenenergy=ttgenenergy(ipart)/dble(jntot)
          WRITE(10,'(a,i5,2d25.10)')
     &       'ipart,ttgenenergy,averaged energy =',
     &      ipart,ttgenenergy(ipart),avgenenergy
          CLOSE(10)
      endif



      ENDDO ! of ipart

c      mptlic = mmptl+1
      mptlic=mmptl

c     the output data file directly from SPheRIO without decay treated by NEXUS
c      if(iridge.eq.1)then
c	    open(19,file='z2-'//fncno(1:nfncno)//'.data',access='append')
c          write(19,'(i8,a)')iger,'      0      0 0.0000E+00 0.0000E+00 '
c	    do igerloop=1,iger
c          write(19,'(2i8,4d20.10)')igerloop,nxpid_rdg(igerloop),
c     &    plb_rdg(igerloop,1),plb_rdg(igerloop,2),plb_rdg(igerloop,3),
c     &    mm_rdg(igerloop)
c	    enddo
c	    close(19)
c      endif

      if (iauxi.ge.6.and.nfrzz.eq.0) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
          WRITE(10,*) ('-',kk=1,63)
          WRITE(10,'(a,d25.10)')
     &             ' energy of hadrons emitted by SPheRIO:',
     &               totalgenenergy
          CLOSE(10)
      endif

      if (iauxi.ge.3.and.nfrzz.eq.0) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
	    WRITE(10,*)' '
          WRITE(10,*) ('-',kk=1,63)
	    WRITE(10,*)' '
          CLOSE(10)
      endif


CCC   #################################################################
CCC   debug output of checking the energy conservation
      if (iauxi.ge.24.and.nfrzz.eq.0) then
	ipart=1
c      DO ipart=1,nparb_act
       do nexp=0,3 !try 1,10,100,1000 particles
	    ttgenenergy(ipart) = 0.d0
          ntest=10**(nexp)
          id     = ipid(ipart)
          nxpid  = nexpid(id)
	    mm     = mss(id)
	    gg     = ngf(id)
	    bb     = nbr(id)
          ssq    = nsr(id)
          IF(bb.EQ.0)THEN
             sinal = -1.  !! bosons
          ELSE
             sinal = +1.  !! fermions 
          ENDIF
	  ncont = 0
 	  do while(ncont.LE.ntest)
 	    iescol = INT(nfr*ran2r(idum))+1
          IF(ran2r(idum).LE.wg(iescol,ipart)/wmax(ipart)) THEN
	      ncont = ncont+1
	      CALL pdmax(iescol,id,mm,gg,sinal,bb,ssq,pdx)
            do while(.true.)
              p     = pmin+ran2r(idum)*(pmax-pmin)
	        theta = thmin+ran2r(idum)*(thmax-thmin)
	        phi = phmin+ran2r(idum)*(phmax-phmin)
              CALL rot(iescol,p,phi,theta,pprx,ppry,pprz)
              ppr(0)=SQRT(mm**2+pprx**2+ppry**2+pprz**2)
              ppr(1)=pprx
              ppr(2)=ppry
              ppr(3)=pprz
              CALL lorenz(iescol,id,ppr,plb)
	        pd    =  prodis(iescol,id,mm,gg,sinal,bb,ssq,p,plb,theta)
              IF(ran2r(idum).le.pd/pdx) exit
            enddo
            totalgenenergy = totalgenenergy + plb(0)             !sum up the total energy of hadrons
            ttgenenergy(ipart) = ttgenenergy(ipart) + plb(0)
          ENDIF
        enddo ! of nont
        OPEN(10,FILE=fnsom(1:nfnsom),access='append')
        WRITE(10,'(a,2i5,2d25.10)')
     &    'ipart,ntest,ttgenenergy,averaged energy =',
     &    ipart,ntest,ttgenenergy(ipart),ttgenenergy(ipart)/dble(ntest)
        CLOSE(10)
       enddo ! of ntest
c      ENDDO ! of ipart
      endif ! of iauxi check
      


      RETURN
      END






CCC   #################################################################
CCC   lorenz()
CCC   #################################################################
CCC   last updated 05032009
CCC   fix a minor bug when v2 is zero
CCC
CCC   last updated 02162009
CCC   add ridge debug output and remarked
CCC
CCC   last updated 07312007
CCC   restore last modification and adopt ch mod 5
CCC
CCC   last updated 07292007
CCC   let omega thermal freeze-out on CFO
CCC
CCC   last updated 05252007
CCC   modified to adopt new quimode option
CCC
CCC   last updated 05222007
CCC   interface of lorenz() is modified
CCC   ufccxn is incorporated
CCC   #################################################################
      SUBROUTINE lorenz(iescol,id,ppr,plb)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      include 'epos.incsf'
	include 'spherio.quifz.inc'
	include 'spherio.ridge.inc'
	include 'spherio.debug.inc'
      INTEGER iescol
	INTEGER checkodd
	INTEGER checkomg
	INTEGER id
      double precision ppr(0:3),plb(0:3) 
      double precision vx,vy,vz,gamma,v2
c	double precision u0,u1,u2,u3
      
      if (
     &    ((iquifz.eq.1).and.(iquimode.le.3).and.
     &    (checkodd(id).eq.1)).or.
     &    ((iquifz.eq.1).and.(iquimode.eq.5).and.
     &    (checkomg(id).eq.1))           !see option file remarks
     &   )
     &then
          gamma = ufrsxn(0,iescol)
          vx = ufrsxn(1,iescol)/gamma
          vy = ufrsxn(2,iescol)/gamma
          vz = ufrsxn(3,iescol)/gamma
      else
          gamma = ufcc(0,iescol)
          vx = ufcc(1,iescol)/gamma
          vy = ufcc(2,iescol)/gamma
          vz = ufcc(3,iescol)/gamma
	end if


      v2 = vx*vx+vy*vy+vz*vz
      
      
c transformacao de Lorentz 
      if (v2.gt.0.d0) then
      plb(0)   = gamma*(ppr(0)+vx*ppr(1)+vy*ppr(2)+vz*ppr(3))
      plb(1)   =                gamma*vx *ppr(0)
     &         + (1.+(gamma-1.)*vx*vx/v2)*ppr(1)
     &         +     (gamma-1.)*vx*vy/v2 *ppr(2)
     &         +     (gamma-1.)*vx*vz/v2 *ppr(3)
      plb(2)   =                gamma*vy *ppr(0)
     &         +     (gamma-1.)*vx*vy/v2 *ppr(1)
     &         + (1.+(gamma-1.)*vy*vy/v2)*ppr(2)
     &         +     (gamma-1.)*vz*vy/v2 *ppr(3)
      plb(3)   =                gamma*vz *ppr(0)
     &         +     (gamma-1.)*vx*vz/v2 *ppr(1)
     &         +     (gamma-1.)*vy*vz/v2 *ppr(2)
     &         + (1.+(gamma-1.)*vz*vz/v2)*ppr(3)
      else
      plb(0)   = ppr(0)
	plb(1)   = ppr(1)
	plb(2)   = ppr(2)
	plb(3)   = ppr(3)
	endif

     
      RETURN
      END




CCC   #################################################################
CCC   SUBROUTINE PROGRAM: makefzo
CCC   #################################################################
CCC   last updated 03232009
CCC   the program is built based on evgen()
CCC   #################################################################
      SUBROUTINE makefzo(nfr)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      INCLUDE 'spherio.evgen1.inc'
	INCLUDE 'spherio.evgen4.inc'
	INCLUDE 'spherio.evgen5.inc'
      INCLUDE 'spherio.debug.inc'
      INCLUDE 'epos.incsf'
      INTEGER nfr
      INTEGER infr,ipart,i
	integer itemp
      itemp=ipid(1)       !to avoid the warning message
CCC   #################################################################
CCC   Variables saved for total emission numbers: ntot,wg,wmax
CCC   Variables saved for emission probility: nfr, sfpr, ufrsxn, ufcc, mfrsxn, msfrsxn
CCC   tempfrsxn, mfrs, msfrs, tempfz, xfrs, nrfz, ppfz, ssfz
CCC   Variables saved for uncertain future use: all the rest of them
CCC   #################################################################

            write(*,'(2a)')' Write fzo table into ',fnfzo(1:nfnfzo)
          open(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
            write(11,*)' Write fzo table into ',fnfzo(1:nfnfzo)
            close(11)
            open(97,file=fnfzo(1:nfnfzo),status='unknown')
            write(97,*) nfr,nparb_act
            write(97,*)((wg(infr,ipart),infr=1,nfr),ipart=1,nparb_act),
     &                      (wmax(ipart),ipart=1,nparb_act),
     &                      (ntot(ipart),ipart=1,nparb_act)
            write(97,*)((xfrs(i,infr),i=0,3),infr=1,nfr),
     &                      ((rfrs(i,infr),i=0,3),infr=1,nfr),
     &                      ((ufrs(i,infr),i=0,3),infr=1,nfr),
     &                      ((sfrs(i,infr),i=0,3),infr=1,nfr),
     &                      ((ufrsxn(i,infr),i=0,3),infr=1,nfr),
     &                      ((ufcc(i,infr),i=0,3),infr=1,nfr)
            write(97,*)((nrfz(i,infr),i=0,4),infr=1,nfr),
     &                      ((sfpr(i,infr),i=0,4),infr=1,nfr)
          write(97,*)(mfrs(infr),infr=1,nfr),(msfrs(infr),infr=1,nfr),
     &                      (mfrsxn(infr),infr=1,nfr),
     &                      (msfrsxn(infr),infr=1,nfr),
     &       (snfz(infr),infr=1,nfr),(ssfz(infr),infr=1,nfr),
     &       (bnfz(infr),infr=1,nfr),(bbfz(infr),infr=1,nfr),
     &       (ssfrsxn(infr),infr=1,nfr),(bbfrsxn(infr),infr=1,nfr),
     &       (tempfz(infr),infr=1,nfr),(tempfrsxn(infr),infr=1,nfr),
     &       (ppfz(infr),infr=1,nfr),(edfz(infr),infr=1,nfr),
     &       (iflgfpfz(infr),infr=1,nfr)
           close(97)
      
      RETURN
      END






CCC   #################################################################
CCC   pdmax()
CCC   #################################################################
CCC   last updated 12132008
CCC   cancelled the precision mode
CCC
CCC   last updated 12092008
CCC   implemented precision mode
CCC
CCC   last updated 07182007
CCC   add output
CCC
CCC   last updated 07162007
CCC   modified again
CCC
CCC   last updated 07152007
CCC   modified the strategy to calculate pdmax
CCC
CCC   last updated 07082007
CCC   optimized the pdmax algorithm
CCC
CCC   last updated 07072007
CCC   modified to adopt new ce scenario
CCC
CCC   last updated 04252007
CCC   modified to adopt checkomg()
CCC
CCC   last updated 05122006
CCC   modified according the interfaceis prodis()
CCC   #################################################################
      SUBROUTINE pdmax(iescol,id,m,g,sinal,b,ssq,pdx)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
	INCLUDE 'spherio.ce.inc'
	INCLUDE 'spherio.evgen1.inc'
      INCLUDE 'spherio.evgen2.inc'
      INCLUDE 'spherio.evgen5.inc'
	INCLUDE 'spherio.debug.inc'
	include 'epos.incsf'
      INTEGER iescol,b,ssq,g
      INTEGER i,j
c      integer k
      INTEGER mp,mth,mph
	INTEGER id
	double precision ppr(0:3),plb(0:3)
      double precision m,sinal,pdx
      double precision p,theta,dp,dth,prodis,pdtmp
	double precision dph,phi
	double precision pprx,ppry,pprz
c      double precision ran2r
      double precision x,y,eta,tau
	double precision nr0,nr1,nr2,nr3
	double precision nnn(0:3),norm
c	double precision pplb
      

      mp   = 30
      mth  = 30
	mph  = 30

      if(imprs.eq.1) then
      mp   = 300
      mth  = 300
	mph  = 300
	endif

      dp   = (pmax-pmin)/dble(mp)
      dth  = (thmax-thmin)/dble(mth)
      dph  = (2.d0*thmax-thmin)/dble(mph)

      pdx=0.

      DO i=0,mp
         p=pmin+i*dp
         DO j=0,mth
            theta=thmin+j*dth
c		    DO k=0,mph
c	            phi = thmin+k*(2.d0*thmax-thmin)
				phi = 0.0
				CALL rot(iescol,p,phi,theta,pprx,ppry,pprz)
				ppr(0)=SQRT(m**2+pprx**2+ppry**2+pprz**2)
				ppr(1)=pprx
				ppr(2)=ppry
				ppr(3)=pprz
				CALL lorenz(iescol,id,ppr,plb)
				if ((plb(0)**2-m**2).lt.0.0) then
	                if (iauxi.ge.6) then
                      open(11,file=fnnan(1:nfnnan),access='append')
                      write(11,*)'NaN catchup in pdmax!'
                  	write(11,*)'plb(0),m=',plb(0),m
                      close(11)
	                end if
c                      stop 'plb err in pdmax!'
	            end if
c	            pplb=max(sqrt(plb(0)**2-m**2),p)
c				plb(0)=sqrt(m**2+p**2)
c				plb(1)=p
c				plb(2)=0.0
c				plb(3)=0.0
				if (ipid(1).eq.id) then		!check for pi+
				select case (icemode)
				case (2)
					x      = xfrs(1,iescol)
					y      = xfrs(2,iescol)
					eta    = xfrs(3,iescol)
					tau    = xfrs(0,iescol)
c 4-vector nr_{\mu} {{\tau}xy{\eta}-coord}
					nr0    = nrfz(0,iescol)
					nr1    = nrfz(1,iescol)
					nr2    = nrfz(2,iescol)
					nr3    = nrfz(3,iescol)
					norm   = nrfz(4,iescol)
c 4-vector nr_{\mu} {txyz-coord}
					nnn(0)     = +COSH(eta)*nr0-1./tau*SINH(eta)*nr3
					nnn(1)     = nr1
					nnn(2)     = nr2
					nnn(3)     = -SINH(eta)*nr0+1./tau*COSH(eta)*nr3
c the plb^{\mu} not on the mass shell but give the maximum nr*plb
c					plb(0)=sqrt(m**2+pplb**2)
c					plb(1)=pplb/nnn(1)
c     &                        *sqrt(nnn(1)**2+nnn(2)**2+nnn(3)**2)
c					plb(2)=0.0
c					plb(3)=0.0
				case default
					continue
				end select
				end if
				pdtmp = prodis(iescol,id,m,g,sinal,b,ssq,p,plb,theta)
				IF(pdtmp.GT.pdx) THEN
					pdx=pdtmp
				ENDIF
c			ENDDO
         ENDDO
      ENDDO
 
      pdx = 1.3*pdx
c	pdx = 100.d0*pdx
      if(imprs.eq.1) pdx = 10.d0*pdx

      if (pdx.le.0.d0) then
      if (iauxi.ge.9) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN catchup in pdx!'
	write(11,*)'pdx unphysical number'
	write(11,*)'pdx=',pdx
      write(11,*)'there is a chance for this to happen when the ',
     & 'normal vector sfpr() is not pointing properly,',
     & 'which happens when sfpr(0)<0 while larger than spacial part, ',
     & 'and the mass of particle is very small'
	write(11,*)'iescol,id,m,g,sinal,b,ssq=',
     &            iescol,id,m,g,sinal,b,ssq
      write(11,*)'sfpr(0-4,iescol)',sfpr(0,iescol),sfpr(1,iescol),
     &  sfpr(2,iescol),sfpr(3,iescol),sfpr(4,iescol)
      write(11,*)'sfrs(0-3,iescol)',sfrs(0,iescol),sfrs(1,iescol),
     &  sfrs(2,iescol),sfrs(3,iescol)
      write(11,*)'ufrs(0-3,iescol)',ufrs(0,iescol),ufrs(1,iescol),
     &  ufrs(2,iescol),ufrs(3,iescol)
      write(11,*)'xfrs(0-3,iescol)',xfrs(0,iescol),xfrs(1,iescol),
     &  xfrs(2,iescol),xfrs(3,iescol)
      write(11,*)'wg(iescol,1-2)',wg(iescol,1),wg(iescol,2)
c      write(11,*)'nparb_act',nparb_act
      write(11,*)' '
      close(11)
	endif
      if (sfpr(0,iescol).ge.0) stop 'pdx unphysical!'
	endif


      RETURN
      END



CCC   #################################################################
CCC   peso()
CCC   #################################################################
CCC   last updated 10012007
CCC   improved to avoid bosonic divergence
CCC
CCC   last updated 09282007
CCC   modifies output
CCC
CCC   last updated 09252007
CCC   add special treatment for proton anti-proton for v2 calculation
CCC
CCC   last updated 08312007
CCC   adopt vvfrsxn
CCC
CCC   last updated 08082007
CCC   amplified yield of omega to *10
CCC
CCC   last updated 07312007
CCC   adopt ch fz mode 5
CCC
CCC   last updated 03232007
CCC   modified itrp2d evoking according to the new data in tables
CCC
CCC   last updated 03162007
CCC   add more debugging info
CCC
CCC   last updated 01192006
CCC   INCLUDE 'spherio.quifz.inc'
CCC
CCC   last updated 01182007
CCC   incorporate checkodd and iquifz.eq.0 check
CCC
CCC   last updated 12192006
CCC   incorporate detetmin
CCC
CCC   last updated 05122006
CCC   add following new variables to incorporate strangeness
CCC   ssq --> strangeness, us --> strange chemical potential
CCC   for freeze out or initial condition accroding to "type"
CCC   the expression for uu is changed
CCC   uu=b*ub --> uu=b*ub+ssq*us
CCC   the finite volume correction has not be changed
CCC   but the corresponding data should be changed at a late stage
CCC   include 'spherio.evgen1-ic.inc' to include strangeness
CCC   include 'spherio.evgen2-ic.inc' to include strangeness
CCC   include 'spherio.evgen3.inc' to include strangeness
CCC   #################################################################
      function peso(iescol,id,m,g,b,ssq,type)
      implicit none
      include 'spherio.inc'
c      include 'spherio.evgen1-ic.inc'
      include 'spherio.evgen2-ic.inc'
      include 'spherio.evgen3.inc'
	INCLUDE 'spherio.quifz.inc'
	include 'spherio.debug.inc'
	include 'spherio.temps.inc'
	include 'epos.incsf'
      integer iescol,g,b,ssq,id
	integer checkodd
	integer checkomg
	integer checkv2
      double precision peso,m
      double precision T,ub,us,uu,mass,sol,ddnn,fac,xsn,xss
      double precision Tfzo
      character*2 type
      double precision giv_T,giv_ub,xx_Pex

      mass = dble(m)

      if(type.eq.'ic')then
c         if(nic.ne.0)then
	    print*,'option ic in peso is not supported anymore!'
          stop'option ic in peso is not supported anymore!'
c	   endif
c         ub  = ubic(iescol)
c         us  = usic(iescol)
c         T   = Tic(iescol)
c         xsn = snic(iescol)
c         xss = ssic(iescol)
      else if(type.eq.'fz')then
        if ((iquifz.eq.0).or.
     &      (checkodd(id).eq.0).or.
     &      ((iquimode.eq.5).and.(checkomg(id).eq.0)))
     &  then
          Tfzo = min(detetmin,tempfz(iescol))
          ub   = mfrs(iescol)
          us   = msfrs(iescol)
          xsn  = snfz(iescol)
          xss  = ssfz(iescol)
        else
          Tfzo = min(detetmin,tempfrsxn(iescol))
          ub   = mfrsxn(iescol)
          us   = msfrsxn(iescol)
          xsn  = snfz(iescol)                      !Xu Nu's scenario
          xss  = ssfrsxn(iescol)
c          xsn  = snfz(iescol)                        !Hiraro's scenario
c          xss  = ssfz(iescol)
        endif
          T   = Tfzo
      else
         stop 'error in type variable'
      endif

      uu=b*ub+ssq*us
cxxx Correcao no potencial quimico
      giv_T  = T
      giv_ub = abs(ub)

      IF(b.NE.0)THEN
!	   if (giv_T.le.0.1d-3) stop 'stop in peso 1'
         CALL itrp2d(xx_T,xx_ub,xx_P,nn_T,nn_ub,giv_T,giv_ub,xx_Pex)
         uu = uu - (4./3.*pi*(0.7)**3)*xx_Pex
      ENDIF      

      if ((uu.gt.mass).and.(b.eq.0)) then
	    sol=0.d0
	else
          call densty(T,uu,mass,b,g,sol)
	end if

!      if (giv_T.le.0.1d-3) stop 'stop in peso 2'
	call itrp2d(temp,chemb,denom,ntb1x,ntb1y,giv_T,giv_ub,ddnn)

      fac=1.0/ddnn

      sol=sol*fac

      sol=sol*xsn/xss

      peso = dble(sol)

CCC   #################################################################
CCC   special treatment for chemical freeze-out of omega
      if ((iquifz.eq.1).and.(iquimode.eq.5).and.(checkomg(id).eq.1))
     &          peso=peso*10.d0

CCC   #################################################################
CCC   special treatment for v2 calculation of proton
      if ((bugflg.eq.21).and.(checkv2(id).eq.1))
     &          peso=peso*10.d0


CCC   #################################################################
CCC   debugging output
c      if (iauxi.ge.3) then
c	if (peso.ge.0.d0) then
c	    continue
c	elseif(peso.lt.0.d0) then
c         open(11,file=fnnan(1:nfnnan),access='append')
c		WRITE(11,*)'wg has negative value in peso,peso=',peso
c		WRITE(11,*)'SPH freeze index=',iescol
c	    WRITE(11,*)'emission particle number=',id
c	    WRITE(11,'(a,i4,f16.8,3i4)')'id,mm,gg,bb,ssq=',id,m,g,b,ssq
c	    WRITE(11,*)'ub,us,uu,sol=',ub,us,uu,sol
c	    WRITE(11,*)'ddnn,fac=',ddnn,fac
c	    WRITE(11,*)'giv_T,giv_ub',giv_T,giv_ub
c		CLOSE(11)
c	else
c         open(11,file=fnnan(1:nfnnan),access='append')
c		WRITE(11,*)'peso has unphysical value'
c		WRITE(11,*)'SPH freeze index=',iescol
c	    WRITE(11,*)'emission particle number=',id
c	    WRITE(11,'(a,i4,f16.8,3i4)')'id,mm,gg,bb,ssq=',id,m,g,b,ssq
c	    WRITE(11,*)'ddnn,fac=',ddnn,fac
c		CLOSE(11)
c		stop 'peso fatal error!'
c	endif
c	endif
CCC   #################################################################


      return
      end




CCC   #################################################################
CCC   pesotest()
CCC   #################################################################
CCC   last updated 03232007
CCC   modified itrp2d evoking according to the new data in tables
CCC
CCC   last updated 12222006
CCC   inherit and modified from pesoxn()
CCC   #################################################################
      double precision function pesotest(m,g,b,ssq,ub,us,Tout)
      implicit none
      include 'spherio.inc'
	include 'spherio.temps.inc'
c      include 'spherio.evgen1-ic.inc'
      include 'spherio.evgen2-ic.inc'
      include 'spherio.evgen3.inc'
      integer g,b,ssq
      double precision m
      double precision T,ub,us,uu,Tout
	double precision mass,sol
      double precision giv_T,giv_ub,xx_Pex

      T = min(detetmin,tout)
      mass = dble(m)
      uu=b*ub+ssq*us
cxxx Correcao no potencial quimico
      giv_T  = T
      giv_ub = abs(ub)
      IF(b.NE.0)THEN
!	   if (giv_T.le.0.1d-3) stop 'stop in peso 2'
         CALL itrp2d(xx_T,xx_ub,xx_P,nn_T,nn_ub,giv_T,giv_ub,xx_Pex)
         uu = uu - (4./3.*pi*(0.7)**3)*xx_Pex
      ENDIF      

      call densty(T,uu,mass,b,g,sol)


!      call itrp2d(temp,chemb,denom,ntb1x,ntb1y,giv_T,giv_ub,ddnn)
!      fac=1.0/ddnn

!      sol=sol*fac

!      sol=sol*xsn/xss

      pesotest = dble(sol)
   

      return
      end




CCC   #################################################################
CCC   pesotrials()
CCC   #################################################################
CCC   last updated 07072008
CCC   adopt new EOS tables
CCC
CCC   last updated 12222006
CCC   #################################################################
      SUBROUTINE pesotrials(nfr)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
	INCLUDE 'spherio.debug.inc'
	include 'epos.incsf'
      INTEGER nfr,id,bb,gg
	INTEGER ssq
	DOUBLE PRECISION ub,us,uu,Tout1,Tout2
      double precision pesotest,mm,wg1,wg2

c                ((id.ge.300).and.(id.le.327))		!!lambda
c                ((id.ge.390).and.(id.le.401))		!!xi
c                ((id.ge.410).and.(id.le.411))		!!omega
c                ((id.eq.014).and.(id.eq.046))		!!phi(1020)(1680)
c                (id.eq.057)							!!phi3(1850)

      if (iauxi.ge.5) then
      CALL readstb
      CALL nxpd

          id     = 300
          mm     = mss(id)
          gg     = ngf(id)
          bb     = nbr(id)
          ssq    = nsr(id)
          ub     = 0.1506703028d+00
          us     = 0.2233829670d-01
          uu     = bb*ub+ssq*us
          Tout1  = 0.140d0
          wg1=pesotest(mm,gg,bb,ssq,ub,us,Tout1)
          Tout2  = 0.158d0
          wg2=pesotest(mm,gg,bb,ssq,ub,us,Tout2)

	OPEN(70,FILE=fneoe(1:nfneoe),access='append')
	WRITE(70,'(a,i6,4d30.20)') 'id,mm,ub,us=',id,mm,ub,us,uu
	WRITE(70,'(a,4d30.20)') 'Tout1,wg1,Tout2,wg2=',Tout1,wg1,Tout2,wg2
	CLOSE(70)
      endif
CCC   #################################################################

      RETURN
      END   




CCC   #################################################################
CCC   prodis()
CCC   #################################################################
CCC   last updated 07312007
CCC   switch back last modification and adopt ch mode 5
CCC
CCC   last updated 07292007
CCC   let omega thermal freeze-out at CFO
CCC
CCC   last updated 07072007
CCC   adopt new ce scenario for pi+
CCC
CCC   last updated 05252007
CCC   modified to adopt new quimode option
CCC
CCC   last updated 05222007
CCC   checkodd() is used instead of checkomg()
CCC
CCC   last updated 04252007
CCC   modified to adopt checkomg()
CCC
CCC   last updated 03232007
CCC   modified itrp2d evoking according to the new data in tables
CCC
CCC   last updated 12192006
CCC   incorporated detetmin
CCC
CCC   last updated 08172006
CCC   add 2 debugging treatment to avoid divergence
CCC
CCC   last updated 05122006
CCC   add following new variables to incorporate strangeness
CCC   ssq --> strangeness
CCC   the expression for uu is changed
CCC   uu=b*mfrs(iescol) --> uu=b*mfrs(iescol)+ssq*msfrs(iescol)
CCC   the finite volume correction has not be changed
CCC   but the corresponding data should be changed at a late stage
CCC   include 'spherio.evgen3.inc' to include strangeness
CCC   #################################################################
      FUNCTION prodis(iescol,id,m,g,sinal,b,ssq,p,plb,theta)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
	INCLUDE 'spherio.ce.inc'
	include 'spherio.temps.inc'
	INCLUDE 'spherio.quifz.inc'
	INCLUDE 'spherio.evgen1.inc'
      INCLUDE 'spherio.evgen3.inc'
	INCLUDE 'spherio.debug.inc'
	include 'epos.incsf'
	double precision prodis
      INTEGER iescol,g,b,ssq
	INTEGER checkomg
      INTEGER checkodd
      INTEGER id
	INTEGER i
      double precision m,sinal,p,theta,stpr,sszpr
      double precision E,sp,fex,dis
      double precision Tfzo
	double precision plb(0:3)
      double precision x,y,eta,tau
	double precision pp,ssd,pplb
	double precision nr0,nr1,nr2,nr3
	double precision nnn(0:3),norm
	double precision nplb
      double precision giv_T,giv_ub,xx_Pex
	double precision ub,us,uu

      if (((iquifz.eq.1).and.(iquimode.le.3).and.
     &    (checkodd(id).eq.1)).or.
     &    ((iquifz.eq.1).and.(iquimode.eq.5).and.
     &    (checkomg(id).eq.1)))
     &then
          Tfzo = min(detetmin,tempfrsxn(iescol))
          ub    = mfrsxn(iescol)
          us    = msfrsxn(iescol)
      else
          Tfzo = min(detetmin,tempfz(iescol))
          ub    = mfrs(iescol)
          us    = msfrs(iescol)
      endif

	uu=b*ub+ssq*us
      giv_T  = DBLE(Tfzo)
      giv_ub = abs(ub)

      IF(b.NE.0)THEN
!	   if (giv_T.le.0.1d-3) stop 'stop in prodis'
         CALL itrp2d(xx_T,xx_ub,xx_P,nn_T,nn_ub,giv_T,giv_ub,xx_Pex)
         uu = uu - (4./3.*pi*(R0)**3)*xx_Pex
      ENDIF
cxxx
CCC   #################################################################
CCC   divergence check for hadron
      if (iauxi.ge.2) then
	if ((sinal.eq.-1).and.(uu.gt.m)) then
	prodis=0.d0
CCC   #################################################################
CCC   NaN catchup
	if (iauxi.ge.20) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN catchup in prodis!'
	write(11,'(a,3f16.8)')'uu,m,sinal=',uu,m,sinal
	write(11,'(a,i5)')'SPH particle fz index=',iescol
	write(11,'(a,3f16.8)')'snfz,bnfz,tempfz=',snfz(iescol),
     &                    bnfz(iescol),tempfz(iescol)
      close(11)
	endif
CCC   #################################################################
	return
	endif
	endif
CCC   #################################################################

      E=SQRT(m*m+p*p)

      stpr=sfpr(0,iescol)
      sszpr=sfpr(4,iescol)
      
      sp=stpr*E+sszpr*p*COS(theta)
      
      IF(sp.LT.0.) THEN
         prodis=0.
	   RETURN
      ENDIF
      
      fex=EXP(-(E-uu)/Tfzo)
      dis=fex/(1.+sinal*fex)
CCC   #################################################################
CCC   check exp divergence
      if ((-(E-uu)/Tfzo).gt.(88.d0)) then
	      dis=1.d0
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.20) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN catchup in prodis!'
	write(11,*)'exp overflow!'
      close(11)
	endif
CCC   #################################################################
	elseif ((-(E-uu)/Tfzo).lt.(-88.d0)) then
	      dis=0.d0
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.20) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN catchup in prodis!'
	write(11,*)'exp underflow'
      close(11)
	endif
CCC   #################################################################
	endif
CCC   #################################################################
CCC   new ce scenario
	   if (ipid(1).eq.id) then		!check for pi+
	   select case (icemode)
         case (2)
         x      = xfrs(1,iescol)
         y      = xfrs(2,iescol)
         eta    = xfrs(3,iescol)
         tau    = xfrs(0,iescol)
c 4-vector nr_{\mu} {{\tau}xy{\eta}-coord}
         nr0    = nrfz(0,iescol)
         nr1    = nrfz(1,iescol)
         nr2    = nrfz(2,iescol)
         nr3    = nrfz(3,iescol)
	   norm   = nrfz(4,iescol)
c 4-vector nr_{\mu} {txyz-coord}
         nnn(0)     = +COSH(eta)*nr0-1./tau*SINH(eta)*nr3
         nnn(1)     = nr1
         nnn(2)     = nr2
         nnn(3)     = -SINH(eta)*nr0+1./tau*COSH(eta)*nr3
	   nplb=0.0
         DO i=0,3
	       nplb=nplb+nnn(i)*plb(i)
         ENDDO
         pp  = ppfz(iescol)
         ssd = ssfz(iescol)
         nplb = nplb*norm
         pplb = exp(-kappa*m*ssd*ssd/nplb)
	   if (nplb.le.0.d0) pplb=0.d0
         dis=dis*pplb/(1.d0-pplb)/pp*(1.d0-pp)
	   case default
	        continue
         end select
	   end if
CCC   #################################################################
      
      prodis=g/(2.*pi)**3*sp*dis*p*p*SIN(theta)/E
      prodis=prodis/(hbarc**3)
      
      if (iauxi.ge.9) then
	if (((prodis.le.0.d0).and.(.not.(theta.eq.0.d0)).and.
     &     (.not.(dis.eq.0.d0))).or.
     &    (.not.(prodis.le.0.d0.or.prodis.ge.0.d0))) then
	 open(11,file=fnnan(1:nfnnan),access='append')
       write(11,*)'prodis=',prodis
	 write(11,*)'iescol,id,xfrs(0-3,iescol)=',
     &  iescol,id,xfrs(0,iescol),xfrs(1,iescol),xfrs(2,iescol),
     &  xfrs(3,iescol)
	 write(11,*)'nrfz(0-4,iescol)',
     &  nrfz(0,iescol),nrfz(1,iescol),nrfz(2,iescol),nrfz(3,iescol),
     &  nrfz(4,iescol)
       write(11,*)'pplb,pp,uu,Tfzo=',pplb,pp,uu,Tfzo
	 write(11,*)'m,g,b,p,theta=',m,g,b,p,theta
       write(11,*)'sp,dis=',sp,dis
	 write(11,*)'sfpr(0-4,iescol)',sfpr(0,iescol),sfpr(1,iescol),
     &  sfpr(2,iescol),sfpr(3,iescol),sfpr(4,iescol)
	 write(11,*)' '
	 close(11)
       stop 'NaN in prodis!'
      end if
	end if

      RETURN
      END


CCC   #################################################################
CCC   SUBROUTINE PROGRAM: readfzo
CCC   #################################################################
CCC   last updated 03232009
CCC   the program is built based on readfzo()
CCC   #################################################################
      SUBROUTINE readfzo(nfr)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      INCLUDE 'spherio.evgen1.inc'
	INCLUDE 'spherio.evgen4.inc'
	INCLUDE 'spherio.evgen5.inc'
      INCLUDE 'spherio.debug.inc'
      INCLUDE 'epos.incsf'
      INTEGER nfr
      INTEGER infr,ipart,i
	integer itemp
      itemp=ipid(1)       !to avoid the warning message
CCC   #################################################################
CCC   Variables saved for total emission numbers: ntot,wg,wmax
CCC   Variables saved for emission probility: nfr, sfpr, ufrsxn, ufcc, mfrsxn, msfrsxn
CCC   tempfrsxn, mfrs, msfrs, tempfz, xfrs, nrfz, ppfz, ssfz
CCC   Variables saved for uncertain future use: all the rest of them
CCC   #################################################################

            write(*,'(2a)')' Read fzo table from ',fnfzo(1:nfnfzo)
            open(11,FILE=fnztr(1:nfnztr),ACCESS='APPEND')
            write(11,*)' Read fzo table from ',fnfzo(1:nfnfzo)
            close(11)
            open(97,file=fnfzo(1:nfnfzo),status='unknown')
            read(97,*) nfr,nparb_act
            read(97,*)((wg(infr,ipart),infr=1,nfr),ipart=1,nparb_act),
     &                      (wmax(ipart),ipart=1,nparb_act),
     &                      (ntot(ipart),ipart=1,nparb_act)
            read(97,*)((xfrs(i,infr),i=0,3),infr=1,nfr),
     &                      ((rfrs(i,infr),i=0,3),infr=1,nfr),
     &                      ((ufrs(i,infr),i=0,3),infr=1,nfr),
     &                      ((sfrs(i,infr),i=0,3),infr=1,nfr),
     &                      ((ufrsxn(i,infr),i=0,3),infr=1,nfr),
     &                      ((ufcc(i,infr),i=0,3),infr=1,nfr)
            read(97,*)((nrfz(i,infr),i=0,4),infr=1,nfr),
     &                      ((sfpr(i,infr),i=0,4),infr=1,nfr)
         read(97,*)(mfrs(infr),infr=1,nfr),(msfrs(infr),infr=1,nfr),
     &                      (mfrsxn(infr),infr=1,nfr),
     &                      (msfrsxn(infr),infr=1,nfr),
     &       (snfz(infr),infr=1,nfr),(ssfz(infr),infr=1,nfr),
     &       (bnfz(infr),infr=1,nfr),(bbfz(infr),infr=1,nfr),
     &       (ssfrsxn(infr),infr=1,nfr),(bbfrsxn(infr),infr=1,nfr),
     &       (tempfz(infr),infr=1,nfr),(tempfrsxn(infr),infr=1,nfr),
     &       (ppfz(infr),infr=1,nfr),(edfz(infr),infr=1,nfr),
     &       (iflgfpfz(infr),infr=1,nfr)
          close(97)
      
      RETURN
      END






CCC   #################################################################
CCC   rot()
CCC   #################################################################
CCC   last updated
CCC   #################################################################
      SUBROUTINE rot(iescol,p,phi,theta,px,py,pz)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      INTEGER iescol
      double precision p,phi,theta,px,py,pz
      double precision kx,ky,kz,throt,phrot
      double precision sxpr,sypr,szpr,r

      sxpr=-sfpr(1,iescol)
      sypr=-sfpr(2,iescol)
      szpr=-sfpr(3,iescol)
        
      kx = p*SIN(theta)*COS(phi)
      ky = p*SIN(theta)*SIN(phi)
      kz = p*COS(theta)
      
      CALL findph(sxpr,sypr,phrot)
      r = SQRT(sxpr**2+sypr**2+szpr**2)
      CALL findth(szpr,r,throt)
      
      px=kx*COS(phrot)*COS(throt)-ky*SIN(phrot)+kz*COS(phrot)*SIN(throt)
      py=kx*SIN(phrot)*COS(throt)+ky*COS(phrot)+kz*SIN(phrot)*SIN(throt)
      pz=-kx*SIN(throt)+kz*COS(throt)
      
      RETURN
      END




CCC   #################################################################
CCC   setevg()
CCC   #################################################################
CCC   last updated 01102010
CCC   somaenergy_zt is implemented to recon energy in zt metric
CCC   removed weng() and weng2() related terms
CCC
CCC   last updated 01072010
CCC   implement more debug output concerning energy conservation
CCC   among others, somaenergy_p somaengint2_p are implemented
CCC
CCC   last updated 12142009
CCC   modified to fix a minor output bug
CCC
CCC   last updated 09172009
CCC   add yield summation for ridge debugging
CCC
CCC   last updated 06032009
CCC   more energy conservation check is implemented
CCC
CCC   last updated 01022009
CCC   fixed a bug concerning CFO when it is off
CCC
CCC   last updated 01012009
CCC   fix a bug concerning CFO with precision mode
CCC   more debug info
CCC
CCC   last updated 07222008
CCC   fix a bug concerning debug output
CCC
CCC   last updated 07212008
CCC   fix a minor bug about Na-N output
CCC
CCC   last updated 07112008
CCC   fix a bug in the formulae of cfz phase check
CCC
CCC   last updated 07082008
CCC   add one more check for cfz
CCC
CCC   last updated 07072008
CCC   remove table reading put them in load-eos subroutine
CCC   add wg chemical potential dependence
CCC
CCC   last updated 10302007
CCC   add ppfz output
CCC
CCC   last updated 10252007
CCC   add snfz output
CCC
CCC   last updated 10242007
CCC   slightly modified the output
CCC
CCC   last updated 10192007
CCC   modified the format of output
CCC
CCC   last updated 08312007
CCC   adopt vvfrsxn
CCC
CCC   last updated 07052007
CCC   fix a bug concerning output
CCC
CCC   last updated 07042007
CCC   modified to add nrfz, ppfz output
CCC
CCC   last updated 05222007
CCC   modified to add more debugging output
CCC
CCC   last updated 03262007
CCC   modified according to setus()
CCC
CCC   last updated 01182007
CCC   simplified and modified to adopt checkodd()
CCC
CCC   last updated 12222006
CCC   fix a bug
CCC
CCC   last updated 12212006
CCC   modified to provide more debugging info
CCC
CCC   last udpated 10162006
CCC   modified to adopt chemical fo
CCC   add debugging info
CCC
CCC   last updated 08172006
CCC   added debugging output for the pion total numbers
CCC   added debugging output when weigpr goes wrong
CCC   added in 2 place for debugging when snfz(i) goes to zero
CCC
CCC   last updated 07192006
CCC   restore the subroutines setfac() and weigpr()
CCC
CCC   last updated 06072006
CCC   the phsjdg2() subroutine is remarked for debugging purpose
CCC   because the phase boundary determination has not be implemented
CCC   setfac() is remarked to simplify the progress
CCC
CCC   last updated 05122006
CCC   add following new variables to incorporate strangeness
CCC   ssq --> strangeness
CCC   interface of weigpr(), peso() is changed
CCC   include 'spherio.evgen1.inc' to include strangeness
CCC   #################################################################
      SUBROUTINE setevg(nfr)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      INCLUDE 'spherio.evgen1.inc'
	INCLUDE 'spherio.evgen4.inc'
	INCLUDE 'spherio.evgen5.inc'
	INCLUDE 'spherio.ce.inc'
	INCLUDE 'spherio.quifz.inc'
	INCLUDE 'spherio.eos.inc'
	INCLUDE 'spherio.debug.inc'
	include 'spherio.ridge.inc'
c	include 'spherio.eos.inc'
	include 'epos.incsf'
      INTEGER nfr,ipart,id,bb,gg,i,phsflg
	integer phsflgxn
c	integer bbxn
	INTEGER ssq
      double precision mm,sinal
c      double precision weigpr
      double precision peso
c	double precision weigprxn,pesoxn
      DOUBLE PRECISION fac, xnb
	double precision xnbxn
      double precision soma,soma1,soma2,somab
	double precision somaenergy,somajak

	double precision somaenergy_zt
      double precision stau,sx,sy,seta,utau,ux,uy,ueta
	double precision ftau,fx,fy,feta,st,sz,ut,uz

	double precision rdyield,reyield
	integer checkodd,checkomg
	integer Nspp,nn
      INTEGER indx(NPLF)
      DOUBLE PRECISION arr(NPLF)
c       do i=1,nfr
c       open(77,file='vt_fz.dat',status='unknown',access='append')
c       if(abs(xfrs(3,i)).le.0.5d0)then
c       write(77,*)tanh(rfrs(1,i))/cosh(rfrs(3,i)-xfrs(3,i))
c       endif
c       close(77)   
c       enddo 
CCC   #################################################################
      DO ipart=1,nparb_act
          id     = ipid(ipart)
          mm     = mss(id)
          gg     = ngf(id)
          bb     = nbr(id)
          ssq    = nsr(id)
          IF(bb.EQ.0)THEN
             sinal = -1.  !! bosons
          ELSE
             sinal = +1.  !! fermions 
          ENDIF         
          wmax(ipart)=0.
          ntot(ipart)=0.
          DO i=1,nfr
c correcao de volume na formula de Cooper-Frye ?!
CCC   #################################################################
CCC   setfz() is used with peso() to calculate array ufcc and sfpr
CCC   while setfac() and weigpr() is the original one
CCC   there involve approximation in peso where the error would not have
CCC   been estimated correctly
CCC   #################################################################
c               if((imprs.eq.1).and.(iquifz.eq.0)) then !iquifz.ne.0 not implemented yet
c                call setfac(i,id,fac,'fz')
c                wg(i,ipart)=fac*weigpr(i,id,mm,gg,sinal,bb,ssq)
c	          if(i.eq.1.and.ipart.eq.1) then
c                  open(11,file=fnztr(1:nfnztr),access='APPEND')
c                  write(11,'(a)')' weigpr is invoked~'
c                  close(11)
c	          endif
CCC   #################################################################
c               else
                call setus(i)
                wg(i,ipart)=peso(i,id,mm,gg,bb,ssq,'fz')
	          if(i.eq.1.and.ipart.eq.1) then
                  open(11,file=fnztr(1:nfnztr),access='APPEND')
                  write(11,'(a)')' peso is invoked~'
                  close(11)
	          endif
c	          endif
CCC   #################################################################
CCC   debugging output
      if (iauxi.ge.3) then
	if (wg(i,ipart).ge.0.d0) then
	    continue
	elseif(wg(i,ipart).lt.0.d0) then
          open(11,file=fnnan(1:nfnnan),access='append')
		WRITE(11,*)'wg has negative value (peso or weigpr), wg=',
     &                 wg(i,ipart)
		WRITE(11,*)'SPH freeze index=',i
		WRITE(11,'(a,5d16.8)')'snfz,bnfz,tempfz,mfrs,msfrs',snfz(i),
     &                           bnfz(i),tempfz(i),mfrs(i),msfrs(i)
	    WRITE(11,'(a,7d16.8)')'xfrs 0-3,rfrs 1-3=',xfrs(0,i),xfrs(1,i)
     &            ,xfrs(2,i),xfrs(3,i),rfrs(1,i),rfrs(2,i),rfrs(3,i)
	    WRITE(11,'(a,8d16.8)')'sfrs 0-3,ufrs 0-3=',sfrs(0,i),sfrs(1,i)
     &      ,sfrs(2,i),sfrs(3,i),ufrs(0,i),ufrs(1,i),ufrs(2,i),ufrs(3,i)
	    WRITE(11,'(a,5d16.8)')'sfpr 0-4=',sfpr(0,i),sfpr(1,i)
     &      ,sfpr(2,i),sfpr(3,i),sfpr(4,i)
	    WRITE(11,*)'emission particle number=',ipart
	    WRITE(11,'(a,i4,f16.8,3i4)')'id,mm,gg,bb,ssq=',id,mm,gg,bb,ssq
	    WRITE(11,*)'fac=',fac
		CLOSE(11)
		wg(i,ipart)=0.d0
	else
          open(11,file=fnnan(1:nfnnan),access='append')
		WRITE(11,*)'wg has unphysical value'
	    WRITE(11,*)'wg=',wg(i,ipart)
		WRITE(11,*)'SPH freeze index=',i
		WRITE(11,'(a,5d16.8)')'snfz,bnfz,tempfz,mfrs,msfrs',snfz(i),
     &                           bnfz(i),tempfz(i),mfrs(i),msfrs(i)
	    WRITE(11,'(a,7d16.8)')'xfrs 0-3,rfrs 1-3=',xfrs(0,i),xfrs(1,i)
     &            ,xfrs(2,i),xfrs(3,i),rfrs(1,i),rfrs(2,i),rfrs(3,i)
	    WRITE(11,'(a,8d16.8)')'sfrs 0-3,ufrs 0-3=',sfrs(0,i),sfrs(1,i)
     &      ,sfrs(2,i),sfrs(3,i),ufrs(0,i),ufrs(1,i),ufrs(2,i),ufrs(3,i)
	    WRITE(11,'(a,5d16.8)')'sfpr 0-4=',sfpr(0,i),sfpr(1,i)
     &      ,sfpr(2,i),sfpr(3,i),sfpr(4,i)
	    WRITE(11,*)'emission particle number=',ipart
	    WRITE(11,'(a,i4,f16.8,3i4)')'id,mm,gg,bb,ssq=',id,mm,gg,bb,ssq
	    WRITE(11,*)'fac=',fac
		CLOSE(11)
		stop 'wg fatal error!'
	endif
	endif
CCC   #################################################################
            IF(wg(i,ipart).GT.wmax(ipart))wmax(ipart)=wg(i,ipart)
            ntot(ipart)=ntot(ipart)+wg(i,ipart)
          ENDDO ! of i
      ENDDO  ! of ipart

CCC   #################################################################
CCC   debugging output for pion numbers
      if (iauxi.ge.4) then
	somaenergy=0.d0
	somaenergy_zt=0.d0
	somajak=0.d0
      do i=1,nfr
          eos(2)=ssfz(i)
          eos(3)=bbfz(i)
          call eosph(eos,2)
CCC   This is nrfz(covariant) * ufrs(covariant) in etatau metric
          somajak=somajak+nrfz(0,i)*ufrs(0,i)
          somajak=somajak-nrfz(1,i)*ufrs(1,i)
          somajak=somajak-nrfz(2,i)*ufrs(2,i)
          somajak=somajak-nrfz(3,i)*ufrs(3,i)/xfrs(0,i)/xfrs(0,i)
	    somajak=abs(somajak)
	    if (somajak.eq.zero) then
          OPEN(10,FILE=fnsom(1:nfnsom),access='append')
          write(10,'(a,i10)')'somajak.eq.0 of ith ',i
      	write(10,'(a,5d20.10)')'nrfz',
     &            nrfz(0,i),nrfz(1,i),nrfz(2,i),nrfz(3,i),nrfz(4,i)
      	write(10,'(a,5d20.10)')'ufrs,ppfz',
     &            ufrs(0,i),ufrs(1,i),ufrs(2,i),ufrs(3,i),ppfz(i)
          close(10)	        
	    endif
         somaenergy=somaenergy+snfz(i)/ssfz(i)*(eos(1)+eos(4))*ufrs(0,i)
     &      -snfz(i)/ssfz(i)*eos(4)*nrfz(0,i)/somajak
CCC   This is s(covariant) * u(contravariant) in zt metric
c 4-vetor s_{\mu} ({\tau}xy{\eta}-coord)
          stau   = sfrs(0,i)
          sx     = sfrs(1,i)
          sy     = sfrs(2,i)
          seta   = sfrs(3,i)
c 4-vetor u_{\mu} ({\tau}xy{\eta}-coord)
          utau   = ufrs(0,i)
          ux     = ufrs(1,i)
          uy     = ufrs(2,i)
          ueta   = ufrs(3,i)

          ftau    = xfrs(0,i) 
          fx      = xfrs(1,i)
          fy      = xfrs(2,i)
          feta    = xfrs(3,i)
c 4-vetor s_{\mu}(txyz-coord)
          st     =  COSH(feta)*stau-1./ftau*SINH(feta)*seta
          sx     =  sx
          sy     =  sy 
          sz     = -SINH(feta)*stau+1./ftau*COSH(feta)*seta
c 4-vetor u^{\mu} (txyz-coord)
          ut     =  COSH(feta)*utau-1./ftau*SINH(feta)*ueta
          ux     = -ux
          uy     = -uy
          uz     =  SINH(feta)*utau-1./ftau*COSH(feta)*ueta
          somaenergy_zt=somaenergy_zt+
     &      st*((eos(1)+eos(4))*ut**2-eos(4))+
     &      sx*(eos(1)+eos(4))*ut*ux+
     &      sy*(eos(1)+eos(4))*ut*uy+
     &      sz*(eos(1)+eos(4))*ut*uz
      enddo


      OPEN(10,FILE=fnsom(1:nfnsom),access='append')
	write(10,'(a,d20.10)')'total energy from hydro (zt) is:',
     &  somaenergy_zt
	write(10,'(a,d20.10)')'total energy from hydro (etatau) is:',
     &  somaenergy
	
      write(10,*)' '
	write(10,'(a)')'the bare total pion+ pion0 pion- numbers are:'
	write(10,'(4f16.8)')ntot(1),ntot(2),ntot(3),
     &                    ntot(1)+ntot(2)+ntot(3)

      close(10)
	endif
CCC   #################################################################

      do i=1,nfr
         xnb=0.d0
         xnbxn=0.d0
         do ipart=1,nparb_act
            id = ipid(ipart)
            bb = nbr(id)
CCC   #################################################################
            xnb=xnb+bb*ssfz(i)/snfz(i)*wg(i,ipart)
            if (iquifz.ne.0) then
            xnbxn=xnbxn+bb*ssfrsxn(i)/snfz(i)*wg(i,ipart)
            endif
CCC   #################################################################
         enddo
CCC   #################################################################
         if (iauxi.ge.8) then         !baryon density correction due to phase
         call phsjdg2(ssfz(i),bbfz(i),phsflg)
	   phsflgxn=0
         if (iquifz.ne.0) then
         call phsjdg2(ssfrsxn(i),bbfrsxn(i),phsflgxn)
         end if
CCC   #################################################################
         if ((phsflg.ne.0).or.(phsflgxn.ne.0)) then
	      if (((xnb.gt.0.d0).or.(xnb.lt.0.d0)).and.
     &          ((xnbxn.gt.0.d0).or.(xnbxn.lt.0.d0).or.(iquifz.eq.0)))
     &      then
               do ipart=1,nparb_act
	            id = ipid(ipart)
                  if ((phsflg.ne.0).and.      !!not hadronic phase at fz and
     &                ((iquifz.eq.0).or.      !!cfz off or non-qualified(nonodd) particles
     &                 (checkodd(id).eq.0).or.
     &                 ((iquimode.eq.5).and.(checkomg(id).eq.0))))
     &            then
                      wg(i,ipart)=bbfz(i)/xnb*wg(i,ipart)
	            elseif ((phsflgxn.ne.0).and.  !!not hadronic phase at cfz and
     &                    ((iquifz.ne.0).and.   !!cfz on and qualified(strange) particles
     &                     (checkodd(id).ne.0).and.
     &                     ((iquimode.ne.5).or.(checkomg(id).ne.0))))
     &            then
                     wg(i,ipart)=bbfrsxn(i)/xnbxn*wg(i,ipart)
	            else
	                continue
	            endif
               enddo
	      else
CCC   #################################################################
CCC   debugging output for pion numbers
            if ((iauxi.ge.3)) then
            open(11,file=fnnan(1:nfnnan),access='append')
	      write(11,'(a)')'NaN or zero of xnb/xnbxn in setevg detected'
	      write(11,*)'xnb=',xnb
            write(11,*)'xnbxn=',xnbxn
		  WRITE(11,*)'SPH freeze index=',i
		  WRITE(11,'(a,5d16.8)')'snfz,ssfz,bnfz,bbfz,tempfz,',snfz(i),
     &                           ssfz(i),bnfz(i),bbfz(i),tempfz(i)
	      write(11,*)'======'
            close(11)
            OPEN(11,FILE=fnnan(1:nfnnan),status='replace')
            WRITE(11,*)'xnb devide by zero problem detail...'
		  WRITE(11,*)'SPH freeze index=',i
		  WRITE(11,'(a,5d16.8)')'snfz,ssfz,bnfz,bbfz,tempfz,',snfz(i),
     &                           ssfz(i),bnfz(i),bbfz(i),tempfz(i)
	      write(11,'(a)')'ipart ipid bb ssfz(i)/snfz(i) wg'
            do ipart=1,nparb_act
                WRITE(11,'(2i6,3d16.8)')ipart,ipid(ipart),nbr(id),
     &               ssfz(i)/snfz(i),wg(i,ipart)
            enddo
            CLOSE(11)
	      endif
	      write(*,*)'NaN of xnb or xnbxn in setevg..'
	      stop'NaN of xnb or xnbxn in setevg..'
CCC   #################################################################
	      endif
         endif
	   endif
CCC   #################################################################
      enddo

      do ipart=1,nparb_act
         wmax(ipart)=0.
         ntot(ipart)=0.
         do i=1,nfr
            IF(wg(i,ipart).GT.wmax(ipart))wmax(ipart)=wg(i,ipart)
            ntot(ipart)=ntot(ipart)+wg(i,ipart)
         enddo
      enddo


      soma1=0.
      soma2=0.
      do i=1,nfr
         soma=0.
         somab=0.
         do ipart=1,nparb_act
          id     = ipid(ipart)
          mm     = mss(id)
          gg     = ngf(id)
          bb     = nbr(id)
          soma=soma+bb*ssfz(i)/snfz(i)*wg(i,ipart)
          somab=somab+bb*wg(i,ipart)
         enddo
           soma1=soma1+bnfz(i)
           soma2=soma2+somab 
      enddo
CCC   #################################################################
CCC   debugging output for pion numbers
      if (iauxi.ge.4) then
      OPEN(10,FILE=fnsom(1:nfnsom),access='append')
	write(10,'(a)')'the total pion+ pion0 pion- numbers to emit are:'
	write(10,'(4f16.8)')ntot(1),ntot(2),ntot(3),
     &                    ntot(1)+ntot(2)+ntot(3)
	write(10,'(a)')'the total baryon number sum_bn, sum_somab, fluc:'
      write(10,*)soma1,soma2,
     &                (max(soma1,soma2)/min(soma1,soma2)-1.)*100.d0
	write(10,*)'  '
      close(10)
	endif
CCC   #################################################################

CCC   #################################################################
CCC   debugging output for chemical freezeout
CCC   sorting using iflgfpfz value
      if (iauxi.ge.24) then
      OPEN(10,FILE=fneda(1:nfneda),access='append')
	write(10,'(a)')'SPH particle statistics summary table'
	write(10,'(a,2i7)')'nfr,Nsprdg',nfr,Nsprdg
      write(10,'(7a)')
     &'     iflgfpfz sphid snfz bnfz',
     &' tempfz tempfrsxn',
     &' ssfz ssfrsxn bbfz bbfrsxn',
     &' mfrs mfrsxn msfrs msfrsxn',
     &' taufz xxfz yyfz etafz ppfz',
     &' ufrs0 ufrs1 ufrs2 ufrs3',
     &' nrfz0 nrfz1 nrfz3 nrfz3 nrfz4'
	close(10)
      Nspp= nfr
      do i=1,Nspp
         arr(i)=iflgfpfz(i)
      end do
      call indexx(Nspp,NPLF,arr,indx)
	rdyield=0.d0
	reyield=0.d0
      open(10,FILE=fneda(1:nfneda),access='append')
      do nn=1,Nspp
         i=indx(nn)
	if(iridge.eq.1.and.iflgfpfz(i).le.Nsprdg)rdyield=rdyield+wg(i,1)
	if(iridge.eq.1.and.iflgfpfz(i).gt.Nsprdg)reyield=reyield+wg(i,1)
      write(10,'(2i7,26d20.10)')
     &  iflgfpfz(i),i,snfz(i),bnfz(i),
     &  tempfz(i),tempfrsxn(i),
     &  ssfz(i),ssfrsxn(i),bbfz(i),bbfrsxn(i),
     &  mfrs(i),mfrsxn(i),msfrs(i),msfrsxn(i),
     &  xfrs(0,i),xfrs(1,i),xfrs(2,i),xfrs(3,i),ppfz(i),
     &  ufrs(0,i),ufrs(1,i),ufrs(2,i),ufrs(3,i),
     &  nrfz(0,i),nrfz(1,i),nrfz(2,i),nrfz(3,i),nrfz(4,i)
      enddo
      close(10)
	if (iridge.eq.1) then
      rdyield=rdyield/Nsprdg
      reyield=reyield/(Nspp-Nsprdg)
      OPEN(10,FILE=fnsom(1:nfnsom),access='append')
      WRITE(10,'(a,d25.10)')
     &'averaged pion+ yields from focused spots =',rdyield
	WRITE(10,'(a,d25.10)')
     &'averaged pion+ yields from unfocused spots =',reyield
      CLOSE(10)
	endif
	endif
CCC   #################################################################

      RETURN
      END   




CCC   #################################################################
CCC   setfac()
CCC   #################################################################
CCC   last updated 01042009
CCC   updated the chemical freeze-out scenario check
CCC
CCC   last updated 03232007
CCC   modified itrp2d evoking according to the new data in tables
CCC
CCC   last updated 01192006
CCC   INCLUDE 'spherio.quifz.inc'
CCC
CCC   last updated 01182007
CCC   incorporated checkodd and iquifz.eq.0 check
CCC
CCC   last updated 12192006
CCC   incorporated detetmin
CCC
CCC   last updated 05122006
CCC   this subroutine must be changed later or "denom" must be recalclated
CCC   to take into account the strangeness
CCC   include 'spherio.evgen1-ic.inc' to include strangeness
CCC   include 'spherio.evgen1-ic.inc' to include strangeness
CCC   #################################################################
      SUBROUTINE setfac(nf,id,fac,type)
      implicit none
      include 'spherio.inc'
	include 'spherio.temps.inc'
c      include 'spherio.evgen1-ic.inc'
      include 'spherio.evgen2-ic.inc'
	INCLUDE 'spherio.quifz.inc'
	include 'epos.incsf'
      character*2 type
      integer nf,id
	integer checkodd,checkomg
      double precision fac
      double precision ub,ddnn,T
      double precision Tfzo
	double precision giv_T,giv_ub

      if(type.eq.'ic')then
	    print*,'ic option is not supported anymore'
	    stop'ic option is not supported anymore'
c          T    = Tic(nf)
c          ub   = ubic(nf)
      else if(type.eq.'fz')then
        if ((iquifz.eq.0).or.
     &      (checkodd(id).eq.0).or.
     &      ((iquimode.eq.5).and.(checkomg(id).eq.0))) then
          Tfzo  = min(detetmin,tempfz(nf))
          ub    = mfrs(nf)
        else
          Tfzo  = min(detetmin,tempfrsxn(nf))
          ub    = mfrsxn(nf)
        endif
          T    = Tfzo
      else
         stop 'error in type variable'
      endif

      if(T.gt.temp(ntb1x).or.T.lt.temp(1))then
         open(70,file=fneoe(1:nfneoe),access='append')
	   write(70,*)'problem in setfac'
         write(70,*) temp(1),temp(ntb1x),T
         close(70)
         stop 'temp1.err'
      endif
         giv_T=T
         giv_ub=abs(ub)
c>>>>>>>>>>>>
!	   if (giv_T.le.0.1d-3) stop 'stop in setfac'
         call itrp2d(temp,chemb,denom,ntb1x,ntb1y,giv_T,giv_ub,ddnn)
         fac=1.0/ddnn

c>>>>>>>>>>>

      return
      end




CCC   #################################################################
CCC   setnex()
CCC   #################################################################
CCC   last updated 11302008
CCC   value of nptl is shifted according to epos spectators and high-pT
CCC   particles in IC
CCC   #################################################################
      SUBROUTINE setnex(mmptl,sid,nid,plb,mass,tau,x,y,eta)
      INCLUDE 'epos.inc'
	include 'epos.incsf'
	include 'epos.incico'
	INCLUDE 'spherio.debug.inc'
      INTEGER mmptl,sid,nid
	integer idsptl(mxptl)
	COMMON/spheriop/idsptl
      double precision plb(0:3),mass,tau,x,y,eta
      real taugm,r,rangen !to be compatible with nexus

      select case (bugflg)
	case (8,15,16)
          nptl           = mmptl 
	case default
          nptl           = mmptl +  nptlbspo
      end select

      idsptl(nptl)   = sid                              !  spherio id
      idptl(nptl)    = nid                              !  nexus id
      pptl(1,nptl)   = plb(1)                           !  px
      pptl(2,nptl)   = plb(2)                           !  py 
      pptl(3,nptl)   = plb(3)                           !  pz
      pptl(4,nptl)   = plb(0)                           !  E
      pptl(5,nptl)   = mass                             !  m
      xorptl(1,nptl) = x                                !  x
      xorptl(2,nptl) = y                                !  y  
      xorptl(3,nptl) = tau*SINH(eta)                    !  z 
      xorptl(4,nptl) = tau*COSH(eta)                    !  t


c        i=nptl
c        ptptl=pptl(1,i)**2.+pptl(2,i)**2.
c        if(ptptl.le.0.)then
c         ptptl=0.
c        else
c         ptptl=sqrt(ptptl)
c        endif
c        if(ptptl.gt.10.)then
c        ibig=1
c        write(ifmt,*)'?????????-dete-?????????',mmptl,i,ptptl
c        OPEN(10,FILE=fnsom(1:nfnsom),access='append')
c        WRITE(10,'(a,2i9,3d25.10)')
c     &         'high pT particle detected: id,nptl,pT,pz,E=',
c     &          id,nptl,ptptl,pptl(3,nptl),pptl(4,nptl)
c        CLOSE(10)
c        endif


      tivptl(1,nptl)=xorptl(4,nptl)
      call idtau(idptl(nptl),pptl(4,nptl),pptl(5,nptl),taugm)
      r=rangen()
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.5) then
	if (r.le.0.d0) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN in setnex!'
	write(11,'(a,f16.8)')'r=',r
      close(11)
	endif
	endif
CCC   #################################################################
      tivptl(2,nptl)=tivptl(1,nptl)+taugm*(-log(r))

      istptl(nptl)   = 0
      ityptl(nptl)   = 60  ! a new code for particles from hydro
      itsptl(nptl)   = 0
      iorptl(nptl)   = 0
      jorptl(nptl)   = 0
      ifrptl(1,nptl) = 0
      ifrptl(2,nptl) = 0   

      radptl(nptl)   = 0.
      desptl(nptl)   = 0.
      dezptl(nptl)   = 0.  
            
      RETURN
      END




CCC   #################################################################
CCC   setnex_null()
CCC   #################################################################
CCC   last updated 12272008
CCC   skip spherio
CCC   #################################################################
      SUBROUTINE setnex_null()
      INCLUDE 'epos.inc'
	include 'epos.incico'

      nptl           = nptlbspo 
            
      RETURN
      END




CCC   #################################################################
CCC   settot()
CCC   #################################################################
      SUBROUTINE settot(ntot,jntot)      
      IMPLICIT NONE
	include 'spherio.seedspo.inc'
      INTEGER jntot
      double precision ntot
c      double precision ran2r,dd
      double precision poidevr

      
c$$$      jntot = INT(ntot)
c$$$      dd    = ntot-dble(jntot)
c$$$      IF(ran2r(idum).LE.dd) jntot = jntot+1

      jntot = INT(poidevr(ntot,idum))
      
      RETURN
      END      




CCC   #################################################################
CCC   setus()
CCC   subroutine calculate the arrays ufcc and sfpr of the SPH particles
CCC   #################################################################
CCC   last updated 03262007
CCC   renamed to setus()
CCC
CCC   last updated 06072006
CCC   formulae are based on the original weigpr() which has be obsoleted
CCC   while not yet
CCC   #################################################################
      subroutine setus(iescol)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      INCLUDE 'spherio.evgen2.inc'
c      INCLUDE 'spherio.evgen3.inc'
	INCLUDE 'spherio.debug.inc'
	include 'epos.incsf'
      INTEGER iescol
      double precision stau,sx,sy,seta,utau,ux,uy,ueta
      double precision tau,x,y,eta,st,sz,ut,uz,vx,vy,vz,v2
      double precision gamma,stpr,sxpr,sypr,szpr,sszpr

c 4-vetor s_{\mu} ({\tau}xy{\eta}-coord)
      stau   = sfrs(0,iescol)
      sx     = sfrs(1,iescol)
      sy     = sfrs(2,iescol) 
      seta   = sfrs(3,iescol)

c 4-vetor u_{\mu} ({\tau}xy{\eta}-coord)
      utau   = ufrs(0,iescol)
      ux     = ufrs(1,iescol)
      uy     = ufrs(2,iescol)
      ueta   = ufrs(3,iescol)

      tau    = xfrs(0,iescol) 
      x      = xfrs(1,iescol)
      y      = xfrs(2,iescol)
      eta    = xfrs(3,iescol)

c 4-vetor s_{\mu}(txyz-coord)
      st     =  COSH(eta)*stau-1./tau*SINH(eta)*seta
      sx     =  sx
      sy     =  sy 
      sz     = -SINH(eta)*stau+1./tau*COSH(eta)*seta

c 4-vetor u^{\mu} (txyz-coord)
      ut     =  COSH(eta)*utau-1./tau*SINH(eta)*ueta
      ux     = -ux
      uy     = -uy
      uz     =  SINH(eta)*utau-1./tau*COSH(eta)*ueta

      vx     = ux/ut
      vy     = uy/ut
      vz     = uz/ut

      v2     = vx*vx+vy*vy+vz*vz
      gamma  = 1./SQRT(1.-v2)
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.5) then
	if ((1.-v2).lt.0.d0) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN in setfz!'
	write(11,'(a,f16.8)')'(1.-v2)=',(1.-v2)
      close(11)
	endif
	endif
CCC   #################################################################

c transformacao de Lorentz
c 4-vetor s_{\mu} (txyz-coord); sistema proprio de iescol
      if (v2.gt.0.d0) then 
      stpr   = gamma*(st+vx*sx+vy*sy+vz*sz)
      sxpr   =                gamma*vx *st
     &       + (1.+(gamma-1.)*vx*vx/v2)*sx
     &       +     (gamma-1.)*vx*vy/v2 *sy
     &       +     (gamma-1.)*vx*vz/v2 *sz
      sypr   =                gamma*vy *st
     &       +     (gamma-1.)*vx*vy/v2 *sx
     &       + (1.+(gamma-1.)*vy*vy/v2)*sy
     &       +     (gamma-1.)*vz*vy/v2 *sz
      szpr   =                gamma*vz *st
     &       +     (gamma-1.)*vx*vz/v2 *sx
     &       +     (gamma-1.)*vy*vz/v2 *sy
     &       + (1.+(gamma-1.)*vz*vz/v2)*sz
      else
      stpr   = st
      sxpr   = sx
      sypr   = sy
      szpr   = sz
      end if
c Escolho novos eixos xyz tal que: s_{\mu}=(s_{t},0,0,s_{z})
      sszpr  = -SQRT(sxpr**2+sypr**2+szpr**2)

      ufcc(0,iescol)=ut
      ufcc(1,iescol)=ux
      ufcc(2,iescol)=uy
      ufcc(3,iescol)=uz

      sfpr(0,iescol)=stpr
      sfpr(1,iescol)=sxpr
      sfpr(2,iescol)=sypr
      sfpr(3,iescol)=szpr
      sfpr(4,iescol)=sszpr



      RETURN
      END     



CCC   #################################################################
CCC   weigpr()
CCC   it calculates the number of emitted particle
CCC   it does NOT include proper modification for CFO as in peso()
CCC   the problem comes from the value of sfrs
CCC   #################################################################
CCC   last updated 06182009
CCC   fix a potential bug pointed out by Philipe and Arthur
CCC
CCC   last updated 03232007
CCC   modified itrp2d evoking according to the new data in tables
CCC
CCC   last updated 01192006
CCC   INCLUDE 'spherio.quifz.inc'
CCC
CCC   last updated 01182007
CCC   incorporate checkodd and iquifz.eq.0 check
CCC
CCC   last updated 12192006
CCC   incorporated detetmin
CCC
CCC   last updated 08172006
CCC   modified to avoid integral divergence in two situations
CCC
CCC   last updated 06072006
CCC   calculate the sfpr and ufcc using the different subroutine setfz()
CCC   the corresponding part is modified, not yet implemented
CCC
CCC   last updated 05122006
CCC   add following new variables to incorporate strangeness
CCC   ssq --> strangeness
CCC   the expression for uu is changed
CCC   uu=b*mfrs(iescol) --> uu=b*mfrs(iescol)+ssq*msfrs(iescol)
CCC   the finite volume correction has not be changed
CCC   but the corresponding data should be changed at a late stage
CCC   include 'spherio.evgen2.inc' to include strangeness
CCC   include 'spherio.evgen3.inc' to include strangeness
CCC   #################################################################
      double precision FUNCTION weigpr(iescol,id,m,g,sinal,b,ssq)
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      INCLUDE 'spherio.evgen2.inc'
      INCLUDE 'spherio.evgen3.inc'
	INCLUDE 'spherio.debug.inc'
	include 'spherio.temps.inc'
	INCLUDE 'spherio.quifz.inc'
	include 'epos.incsf'
      INTEGER iescol,g,b,ssq,id
      INTEGER i,mk
	INTEGER checkodd
      double precision m,sinal
      double precision stau,sx,sy,seta,utau,ux,uy,ueta
      double precision tau,x,y,eta,st,sz,ut,uz,vx,vy,vz,v2
      double precision gamma,stpr,sxpr,sypr,szpr,sszpr
c	double precision stpr,sszpr
      double precision uu,ub,us
      double precision k,kmax,kmin,dk,sum1,sum2,alpha,E,I1,I2
      double precision tmp1,tmp2,distr,fator,fex
      double precision mstr,ustr
      double precision Tfzo
      PARAMETER (mk=100)
      double precision giv_T,giv_ub,xx_Pex

      if ((iquifz.eq.0).or.(checkodd(id).eq.0)) then
          Tfzo  = min(detetmin,tempfz(iescol))
          ub    = mfrs(iescol)
          us    = msfrs(iescol)
      else
          Tfzo  = min(detetmin,tempfrsxn(iescol))
          ub    = mfrsxn(iescol)
          us    = msfrsxn(iescol)
      endif
      
	uu=b*ub+ssq*us

cxxx Correcao no potencial quimico
CCC   no modification in this formulae, but the data for giv_ub table should change
      giv_T  = DBLE(Tfzo)
      giv_ub = abs(ub)
      IF(b.NE.0)THEN
!	   if (giv_T.le.0.1d-3) stop 'stop in weigpr'
         CALL itrp2d(xx_T,xx_ub,xx_P,nn_T,nn_ub,giv_T,giv_ub,xx_Pex)
         uu = uu - (4.0d0/3.0d0*pi*(R0)**3)*xx_Pex
      ENDIF

      kmin   = pmin/Tfzo
      kmax   = pmax/Tfzo

      mstr   = m/Tfzo
      ustr   = uu/Tfzo 


c 4-vetor s_{\mu} ({\tau}xy{\eta}-coord)
      stau   = sfrs(0,iescol)
      sx     = sfrs(1,iescol)
      sy     = sfrs(2,iescol) 
      seta   = sfrs(3,iescol)

c 4-vetor u_{\mu} ({\tau}xy{\eta}-coord)
      utau   = ufrs(0,iescol)
      ux     = ufrs(1,iescol)
      uy     = ufrs(2,iescol)
      ueta   = ufrs(3,iescol)

      tau    = xfrs(0,iescol) 
      x      = xfrs(1,iescol)
      y      = xfrs(2,iescol)
      eta    = xfrs(3,iescol)

c 4-vetor s_{\mu}(txyz-coord)
      st     =  COSH(eta)*stau-1./tau*SINH(eta)*seta
      sx     =  sx
      sy     =  sy 
      sz     = -SINH(eta)*stau+1./tau*COSH(eta)*seta

c 4-vetor u^{\mu} (txyz-coord) -- not correctly normalized yet doesn't affect the result
      ut     =  COSH(eta)*utau-1./tau*SINH(eta)*ueta
      ux     = -ux
      uy     = -uy
      uz     =  SINH(eta)*utau-1./tau*COSH(eta)*ueta

      vx     = ux/ut
      vy     = uy/ut
      vz     = uz/ut

      v2     = vx*vx+vy*vy+vz*vz
      gamma  = 1./SQRT(1.-v2)

CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.5) then
	if ((1.-v2).lt.0.d0) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN in weigpr!'
	write(11,'(a,f16.8)')'(1.-v2)=',(1.-v2)
      close(11)
	endif
	endif
CCC   #################################################################


c transformacao de Lorentz
c 4-vetor s_{\mu} (txyz-coord); sistema proprio de iescol 
      if (v2.ne.zero) then
      stpr   = gamma*(st+vx*sx+vy*sy+vz*sz)
      sxpr   =                gamma*vx *st
     &       + (1.+(gamma-1.)*vx*vx/v2)*sx
     &       +     (gamma-1.)*vx*vy/v2 *sy
     &       +     (gamma-1.)*vx*vz/v2 *sz
      sypr   =                gamma*vy *st
     &       +     (gamma-1.)*vx*vy/v2 *sx
     &       + (1.+(gamma-1.)*vy*vy/v2)*sy
     &       +     (gamma-1.)*vz*vy/v2 *sz
      szpr   =                gamma*vz *st
     &       +     (gamma-1.)*vx*vz/v2 *sx
     &       +     (gamma-1.)*vy*vz/v2 *sy
     &       + (1.+(gamma-1.)*vz*vz/v2)*sz
	else
      stpr   = st
      sxpr   = sx
      sypr   = sy
      szpr   = sz
	endif

c Escolho novos eixos xyz tal que: s_{\mu}=(s_{t},0,0,s_{z})
      sszpr  = -SQRT(sxpr**2+sypr**2+szpr**2)

      ufcc(0,iescol)=ut
      ufcc(1,iescol)=ux
      ufcc(2,iescol)=uy
      ufcc(3,iescol)=uz

      sfpr(0,iescol)=stpr
      sfpr(1,iescol)=sxpr
      sfpr(2,iescol)=sypr
      sfpr(3,iescol)=szpr
      sfpr(4,iescol)=sszpr

CCC   #################################################################
CCC   divergence check for hadron
	if ((sinal.eq.-1).and.(uu.gt.m)) then
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.20) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN catchup in weigpr!'
	write(11,'(a,3f16.8)')'uu,m,sinal=',uu,m,sinal
	write(11,'(a,i5)')'SPH particle fz index=',iescol
	write(11,'(a,3f16.8)')'snfz,bnfz,tempfz=',snfz(iescol),
     &                    bnfz(iescol),tempfz(iescol)
      close(11)
	endif
CCC   #################################################################
      weigpr=0.d0
	return
	endif
CCC   #################################################################
      dk     = (kmax-kmin)/dble(mk)

      sum1   = 0.
      sum2   = 0.

c Integracao usando Simpson
      DO i = 0,mk
         k = kmin+i*dk
         E = SQRT(mstr**2+k**2)
         alpha = -(stpr*E)/(sszpr*k)
         IF(alpha.LT.-1)THEN
               I1 = 0.
               I2 = 0.
         ELSE IF(alpha.GE.-1. .AND. alpha.LE.1.)THEN
               I1 = alpha+1.
               I2 = 0.5*(alpha*alpha-1.)
         ELSE IF(alpha.GT.1.)THEN
               I1 = 2.
               I2 = 0.
         ELSE
CCC   #################################################################
CCC   NaN catchup
         if (iauxi.ge.3) then
         open(11,file=fnnan(1:nfnnan),access='append')
         write(11,*)'NaN catchup in weigpr!'
	   write(11,*)'norm control didnt kill it errrr...'
	   write(11,*)
         close(11)
	   stop 'error in weigpr but problem might come from norm'
c         weigpr=0.d0
	   return
	   endif
CCC   #################################################################
         ENDIF 
         fex   = EXP(-E+ustr)
         distr = fex/(1.+sinal*fex)
CCC   #################################################################
CCC   check exp divergence
      if ((-E+ustr).gt.(88.d0)) then
	      distr=1.d0
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.20) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN catchup in weigpr!'
	write(11,*)'exp overflow!'
	write(11,*)'(-E+ustr)=',(-E+ustr)
	write(11,'(a,3f16.8)')'uu,m,sinal=',uu,m,sinal
	write(11,'(a,i5)')'SPH particle fz index=',iescol
	write(11,'(a,3f16.8)')'snfz,bnfz,tempfz=',
     &                    snfz(iescol),bnfz(iescol),tempfz(iescol)
      close(11)
	endif
CCC   #################################################################
	elseif ((-E+ustr).lt.(-88.d0)) then
	      distr=0.d0
CCC   #################################################################
CCC   NaN catchup
      if (iauxi.ge.20) then
      open(11,file=fnnan(1:nfnnan),access='append')
      write(11,*)'NaN catchup in weigpr!'
	write(11,*)'exp underflow'
	write(11,*)'(-E+ustr)=',(-E+ustr)
	write(11,'(a,3f16.8)')'uu,m,sinal=',uu,m,sinal
	write(11,'(a,i5)')'SPH particle fz index=',iescol
	write(11,'(a,3f16.8)')'snfz,bnfz,tempfz=',
     &                    snfz(iescol),bnfz(iescol),tempfz(iescol)
      close(11)
	endif
CCC   #################################################################
	      exit
	endif
CCC   #################################################################

         tmp1  = k*k    *distr*I1
         tmp2  = K*k*k/E*distr*I2
         IF(i.EQ.0 .OR. i.EQ.mk)THEN
            fator = 1.
         ELSE IF(MOD(i,2).EQ.1)THEN
            fator = 4.
         ELSE IF(MOD(i,2).EQ.0)THEN
            fator = 2.
         ENDIF
         sum1 = sum1+tmp1*fator
         sum2 = sum2+tmp2*fator

      ENDDO

      weigpr = (stpr*sum1+sszpr*sum2)*dk/3.
      weigpr = g/(2.*pi)**2*(Tfzo**3)*weigpr
      weigpr = weigpr/(hbarc*hbarc*hbarc)

      RETURN
      END     



CCC   #################################################################
CCC   SHELL SUBROUTINE PROGRAM: awrite
CCC   Output hydro results to the data file
CCC   #################################################################
CCC   last udpated 20081226
CCC   #################################################################
      subroutine xellwrite(nfrzz)
c	implicit none
      include 'epos.inc'
      include 'spherio.io.inc'
	integer nfrzz  !not used yet

      if(ispherio.ne.1)then
	    write(*,*)'skipping xellwrite... '
          return
      endif
            
	select case (ifzlistfmt)
      case (1)
	    call xellwrite_epos(nfrzz)
	case (2)
	    call xellwrite_epos(nfrzz)
	case (3)
	    call xellwrite_share(nfrzz)
	case (4)
	    call xellwrite_root(nfrzz)
	case default
	    write(*,*)'ifzlistfmt flag error, ifzlistfmt=',ifzlistfmt
		stop 'ifzlistfmt flag error!'
	end select

      return
	end


CCC   #################################################################
CCC   SHELL SUBROUTINE PROGRAM: awrite
CCC   Output hydro results to the data file
CCC   #################################################################
CCC   last udpated 20081226
CCC   #################################################################
      subroutine xellwrite_epos(nfrzz)
      include 'epos.inc'
      include 'epos.incso'
	include 'epos.incsf'
	integer nfrzz  !not used yet
cxx      INTEGER sharepid(500)
cxx      COMMON/sharep/sharepid
      integer idsptl(mxptl)
	COMMON/spheriop/idsptl
      integer j

      open(11,FILE=fnztr(1:nfnztr),ACCESS='APPEND')
      write(11,*)' xellwrite is invoked to output to ',fnxll(1:nfnxll)
      close(11)

CCC   #################################################################
CCC   ideal
CCC   #################################################################      
c      open(97,file=fnxll(1:nfnxll),access='append')
c      write(97,'(3a)')'# number of hadrons, nucleon number of ',
c     &'projectile, proton number, nucleon number of target, ',
c     &'proton number of target:'
c      write(97,'(5i8)')nptl,maproj,laproj,matarg,latarg
c	write(97,'(3a)')'# collision energy, maximum impact parameter,',
c     &' minimum impact parameter, maximum azimuthal angle, ',
c     &'minimum azimuthal angle:'
c	write(97,'(5d20.10)')engy,bmaxim,bminim,phimax,phimin
c	write(97,'(3a)')'id-nexus/epos id-spherio ',
c     &'px[GeV] py[GeV] pz[GeV] E[GeV] ',
c     &'m[GeV] x[fm] y[fm] z[fm] t[fm]'
c      do j=1,nptl
c      write(97,'(2i8,9d20.10)')idptl(j),idsptl(j),
c     & pptl(1,j),pptl(2,j),pptl(3,j),pptl(4,j),pptl(5,j),
c     & xorptl(1,j),xorptl(2,j),xorptl(3,j),xorptl(4,j)
c      enddo
c      close(97)

CCC   #################################################################
CCC   compact
CCC   #################################################################
      open(97,file=fnxll(1:nfnxll),access='append')
      write(97,'(3i8,2d20.10)')nptl,maproj,laproj,bmaxim,bminim
      do j=1,nptl
      write(97,'(2i8,4d20.10)')j,idptl(j),
     & pptl(1,j),pptl(2,j),pptl(3,j),pptl(5,j)
      enddo
      close(97)

      return
	end


CCC   #################################################################
CCC   SHELL SUBROUTINE PROGRAM: awrite
CCC   Output hydro results to the data file
CCC   #################################################################
CCC   last udpated 20081226
CCC   #################################################################
      subroutine xellwrite_root(nfrzz)
      implicit none
      include 'spherio.debug.inc'
      include 'epos.incsf'
	integer nfrzz  !not used yet


      write (*,*)'From xellwrite_root:'
      write (*,*)'Not implemented yet, nothing will be done here!'

      if (iauxi.ge.4) then
          OPEN(11,FILE=fnztr(1:nfnztr),STATUS='UNKNOWN',ACCESS='APPEND')
          WRITE(11,'(a)')'From xellwrite_root:'
          WRITE(11,'(a)')'Not implemented yet, nada will be done here!'
          CLOSE(11)
      endif

      return
	end


CCC   #################################################################
CCC   SHELL SUBROUTINE PROGRAM: awrite
CCC   Output hydro results to the data file
CCC   #################################################################
CCC   last udpated 20081226
CCC   #################################################################
      subroutine xellwrite_share(nfrzz)
      include 'epos.inc'
      include 'epos.incso'
	include 'epos.incsf'
	integer nfrzz  !not used yet
      INTEGER sharepid(500)
      COMMON/sharep/sharepid
      integer idsptl(mxptl)
	COMMON/spheriop/idsptl
	integer j

      open(11,FILE=fnztr(1:nfnztr),ACCESS='APPEND')
      write(11,*)' xellwrite is invoked to output to ',fnxll(1:nfnxll)
      close(11)
      
      open(97,file=fnxll(1:nfnxll),access='append')
      write(97,'(3a)')'# number of hadrons, nucleon number of ',
     &'projectile, proton number, nucleon number of target, ',
     &'proton number of target:'
      write(97,'(5i8)')nptl,maproj,laproj,matarg,latarg
	write(97,'(3a)')'# collision energy, maximum impact parameter,',
     &' minimum impact parameter, maximum azimuthal angle, ',
     &'minimum azimuthal angle:'
	write(97,'(5d20.10)')engy,bmaxim,bminim,phimax,phimin
	write(97,'(2a)')'id-share px[GeV] py[GeV] pz[GeV] E[GeV] ',
     &'m[GeV] x[fm] y[fm] z[fm] t[fm]'

	call sharepd
      
      do j=1, nptl
      write(97,'(i8,9d20.10)')sharepid(idsptl(j)),
     & pptl(1,j),pptl(2,j),pptl(3,j),pptl(4,j),pptl(5,j),
     & xorptl(1,j),xorptl(2,j),xorptl(3,j),xorptl(4,j)
      enddo

      close(97)

      return
	end


