ccc   ###############################################################
ccc   Welcom to SPheRIO, 
ccc   
ccc   ===   Smoothed Particle hydrodynamical evolution of 
ccc            Relativistic heavy-IOn collisions, SPheRIO   === 
ccc   This is include file for SPheRIO, spherio.incl   
ccc   last update:                     
ccc   ###############################################################

ccc   ///////////////////////////////////////////////////////////////
c                 Fundamental setting in SPheRIO

      DOUBLE PRECISION zero,uni,half,two,three,four,six,epsilon
      DOUBLE PRECISION pi,hbarc
      PARAMETER(zero=0.0000d+00,uni=1.0000d+00,half=0.5000d+00) 
      PARAMETER(two=2.000d+00,four=4.000d+00,epsilon=1.000d-08) 
      PARAMETER(three=3.000d+00,six=6.000d+00)
      PARAMETER(pi=3.141592654d+00,hbarc=0.197327053d+00)
ccc   ///////////////////////////////////////////////////////////////

ccc   ///////////////////////////////////////////////////////////////
ccc   ===============    PARAMETER    in SPheRIO     ================
      DOUBLE PRECISION hxy,het,dtau
      DOUBLE PRECISION decaysplt
      DOUBLE PRECISION dal 
      DOUBLE PRECISION ptmin1,ptmax1,rpmin1,rpmax1,phmin1,phmax1

      INTEGER NPL,NPX,LX,RL,NPLF,nfskip,ntspx,npmn
      INTEGER evflg,phaseflg
      INTEGER Npt1,Nrp1,Nph1

      integer ivflag
ccc   ///////////////////////////////////////////////////////////////
c
c
c     ===============================================================
c                 SPH "h" size parameter and flags 
c     --------------------------------------------------------------- 
cxx      PARAMETER(hxy= 0.750d+00) !! [fm]  : SPH h size in x-y. 
cxx      PARAMETER(het= 0.750d+00) !! [non] : SPH h size in eta. 
      PARAMETER(phaseflg=1) !without(0) with(1)  QGP phase transition 
      PARAMETER(evflg=1)    !now available only for event-by-event(1) 
c     ===============================================================
c
c
c     ===============================================================
c                 Here is tau-step and output control
c     ---------------------------------------------------------------
c     dtau.. tau step size, 
c     nfskip... hydro-output file generate every " nfskip" tau step, 
c     ntspx...   maximu tau step. 
cxx      PARAMETER(dtau= 0.25d+00)
cxx      PARAMETER(  nfskip=    1)
      PARAMETER(  nfskip=    4)
      PARAMETER(   ntspx= 1000)
c     =============================================================== 
c
c
c     ===============================================================
c                 NPL... the maximum SPH-particle number. 
c     ---------------------------------------------------------------
      PARAMETER(NPLF= 200000)
cxx      PARAMETER(NPLF= 60000)
cxx      PARAMETER(NPLF= 45000)  
cxx      PARAMETER(NPLF= 100000)
      PARAMETER(NPL=  200000)
cxx      PARAMETER(NPL=  80000)
cxx      PARAMETER(NPL=  50000) 
cxx      PARAMETER(NPL=  43000)  
cxx      PARAMETER(NPL=  120000)      
      PARAMETER(NPX=   10000)
cxx      PARAMETER(NPX=   2500)      
      PARAMETER(LX=     300)
cxx      PARAMETER(LX=     250)
cxx      PARAMETER(LX=     150)
cxx      PARAMETER(LX=     100)
      PARAMETER(RL=       2)
cxx      PARAMETER(RL=       3)
c     ===============================================================
c
c
c     ===============================================================
c                 SPH initial particle settings.. 
c              = Configuration of initial particles = 
c                see 'xx.optns' and 'nexus/epos.incico' 
c     ===============================================================
c
c
c     =============================================================== 
c                        Particle decay contorl 
c     ---------------------------------------------------------------
c      PARAMETER(npmn=             27) !!  minimum number in Kernel W 
c      PARAMETER(npmn=             125) !!  minimum number in Kernel W
      PARAMETER(npmn=             64) !!  minimum number in Kernel W
      PARAMETER(decaysplt= 0.250d+00) !!  decay separation 25% of "h"  
c     =============================================================== 
c
c
c     =============================================================== 
c             particle control and freezeout setting 
c     ---------------------------------------------------------------
cxxx      PARAMETER(Tf=     0.140d+00)  !! freezeout temprature  
cxxx      PARAMETER(Tfin=   0.080d+00)  !! SPH final temp.(elimination)
c     =============================================================== 
c
c
c     =============================================================== 
c                          single particle spectra 
c     ---------------------------------------------------------------
c     acceptance setting 1: full phase space
      PARAMETER(dal=  1.00d+00) 

      PARAMETER(Npt1= 16)
cxxx      PARAMETER(ptmin1=  0.100d+00,ptmax1= +2.000d+00)
      PARAMETER(ptmin1=  0.000d+00,ptmax1= +2.000d+00)
      PARAMETER(Nrp1= 16)
cxxx      PARAMETER(rpmin1= -3.000d+00,rpmax1= +3.000d+00)
      PARAMETER(rpmin1= -5.000d+00,rpmax1= +5.000d+00)
      PARAMETER(Nph1= 16)
      PARAMETER(phmin1=  0.000d+00,phmax1= 6.283d+00)
c     =============================================================== 


      parameter (ivflag = 0)  !! ivflag=1 : velocidade da diagonalizacao
                              !! ivflag=0 : velocidade do Klaus
c
c
ccc   ===============    COMMON BLOCK   in SPheRIO   ================
      DOUBLE PRECISION xymx,etmx
      DOUBLE PRECISION xx,yy,et,al,bt,ph,sn,ss
      DOUBLE PRECISION pibn,pibd,sgmn,sgmd
      DOUBLE PRECISION br,bd,sr,sd,qr,qd
      DOUBLE PRECISION mbxn,msxn,tempxn,uxn,ssxn,bbxn
      DOUBLE PRECISION mbxn_aux,msxn_aux,tempxn_aux
      DOUBLE PRECISION uxn_aux,ssxn_aux,bbxn_aux
      DOUBLE PRECISION ppce      

      DOUBLE PRECISION stot,btot,etot,ez,sftot,bftot,eftot
      DOUBLE PRECISION etot0
      DOUBLE PRECISION sres,bres,eres,sresint,bresint,eresint
      DOUBLE PRECISION slst,blst,elst,slstint,blstint,elstint
      DOUBLE PRECISION stoteta,sreseta,sresinteta,slsteta,slstinteta
      DOUBLE PRECISION xfrs,ufrs,rfrs,sfrs,mfrs,msfrs
      DOUBLE PRECISION mfrsxn,msfrsxn,tempfrsxn
      DOUBLE PRECISION ufrsxn,ssfrsxn,bbfrsxn
      INTEGER iflgfpfz
      DOUBLE PRECISION sfpr,ufcc
      DOUBLE PRECISION nrfz,snfz,ssfz,ppfz
      DOUBLE PRECISION almx 
      DOUBLE PRECISION mss,BAGCNST,R0
      DOUBLE PRECISION bpd
      DOUBLE PRECISION bnfz,edfz,bbfz,tempfz

      DOUBLE PRECISION brsum,snsum

      INTEGER Nsp,Nfr0
      INTEGER ndpr,idp,idq,oflg
      INTEGER idp_aux,idq_aux
      INTEGER hd,lt,np,kl,npflg
      INTEGER hda,lta
      INTEGER ngf,nbr,nqr,nsr
      INTEGER IPd
      INTEGER ipdx,ipc1,ipc2,ipc3,iptag1,iptag2,iptag3

ccc   ###############################################################
ccc          --- Interface  NeXuS/EPOS  =>  SPheRIO ---       
ccc   using include file:  nexus/epos.incico 

ccc   ###############################################################
      COMMON/NSP/Nsp(-2:2),Nfr0       !! SPH particle number and IC particle number
      COMMON/KCTR/np,kl(NPX)     !! kernel control by "prcn" 
      COMMON/SBETOT/stot,btot,etot,ez,etot0     !! Initial total entropy
      COMMON/SBERES/sres,bres,eres,sresint,bresint,eresint
      COMMON/SBEFTOT/sftot,bftot,eftot
      COMMON/SBELST/slst,blst,elst,slstint,blstint,elstint
      COMMON/SBETTA/stoteta,sreseta,sresinteta,slsteta,slstinteta
ccc   ###############################################################
ccc          === SPH particle common block ... === 
      COMMON/HDLT/hd(-2:0,LX,LX,LX),lt(-2:0,NPL)
      COMMON/NPF/npflg
      COMMON/ODR/oflg

      COMMON/XYZ/xx(-2:2,NPL),yy(-2:2,NPL),et(-2:2,NPL)
      COMMON/RAP/al(-2:2,NPL),bt(-2:2,NPL),ph(-2:2,NPL)
      COMMON/NEWCE/ppce(NPL)
      COMMON/XYMX/xymx(-2:2),etmx(-2:2)

      COMMON/SEN/ss(-2:2,NPL),sn(-2:2,NPL),br(-2:2,NPL),bd(-2:2,NPL)
      COMMON/STR/sr(-2:2,NPL),sd(-2:2,NPL),qr(-2:2,NPL),qd(-2:2,NPL)
      COMMON/SGM/sgmn(-2:2,NPL),sgmd(-2:2,NPL)
      COMMON/VIB/pibn(-2:2,NPL),pibd(-2:2,NPL)
      COMMON/QUIMU1/mbxn(NPL),msxn(NPL),tempxn(NPL)
      COMMON/QUIMU2/uxn(0:3,NPL),ssxn(NPL),bbxn(NPL)
      COMMON/QUIMU3/mbxn_aux(NPL),msxn_aux(NPL),tempxn_aux(NPL)
      COMMON/QUIMU4/uxn_aux(0:3,NPL),ssxn_aux(NPL),bbxn_aux(NPL)

ccc   ###############################################################

ccc   ###############################################################
c                    ---  particle decay  --- 
      COMMON/NDPR/ndpr(NPL)
      COMMON/PARE1/idp(-2:0,NPL),idq(-2:0,NPL)
      COMMON/PARE2/idp_aux(-2:0,NPL),idq_aux(-2:0,NPL)
ccc   ###############################################################
c                      ---  freeze out  ---
      COMMON/FRZE1/xfrs(0:3,NPLF),ufrs(0:3,NPLF),rfrs(0:3,NPLF)
      COMMON/FRZE2/sfrs(0:3,NPLF),mfrs(NPLF),msfrs(NPLF)
      COMMON/FRZE3/nrfz(0:4,NPLF),snfz(NPLF),ssfz(NPLF),ppfz(NPLF)
      COMMON/FRZE4/edfz(NPLF),bnfz(NPLF),bbfz(NPLF),tempfz(NPLF)
      COMMON/FRZE5/mfrsxn(NPLF),msfrsxn(NPLF),tempfrsxn(NPLF)
      COMMON/FRZE6/ufrsxn(0:3,NPLF),ssfrsxn(NPLF),bbfrsxn(NPLF)
      COMMON/FRZE7/iflgfpfz(NPLF)
      COMMON/SCM1/sfpr(0:4,NPLF),ufcc(0:3,NPLF)
      COMMON/HDAL/almx,hda(LX),lta(NPLF)

ccc   ###############################################################
c                        ---  from EoS  --- 
      COMMON/BAGCNST/BAGCNST
      COMMON/HARDCORE/R0
      COMMON/prtclms/mss(1000)
      COMMON/quantum/ngf(1000),nbr(1000),nqr(1000),nsr(1000) 	
ccc   ###############################################################
c                        ---  for output --- 
c
      COMMON/IPDATA/IPd(100),bpd(100)  
      COMMON/PRFROT/ipdx,ipc1,ipc2,ipc3,iptag1,iptag2,iptag3 
ccc   ###############################################################

cxx   ###############################################################
c     for checking
      COMMON/CHECKING/brsum,snsum
cxx   ###############################################################

      COMMON/PIONDBG/hxy,het,dtau

      INTEGER iflgfp(NPL),iflgfp_aux(NPL)
      COMMON/FLAGFP/ iflgfp,iflgfp_aux
      
      INTEGER iflgxn(NPL),iflgxn_aux(NPL)
      COMMON/FLAGXN/ iflgxn,iflgxn_aux

      INTEGER iflgce(NPL),iflgce_aux(NPL)
      COMMON/FLAGCE/ iflgce,iflgce_aux

	  
	  
ccc   end include file


